# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `complex` Chapter.
"""

# NAG Copyright 2017-2020.

from ..base import utils

sqrt = utils._EngineState._get_symbol('a02aaf')
sqrt.restype = None
sqrt.argtypes = (
    utils._BYREF_FLOAT64, # Input, xr.
    utils._BYREF_FLOAT64, # Input, xi.
    utils._BYREF_FLOAT64, # Output, yr.
    utils._BYREF_FLOAT64, # Output, yi.
)

abs = utils._EngineState._get_symbol('a02abf') # pylint: disable=redefined-builtin
abs.restype = utils._EngineFloat64ScalarType.c_type
abs.argtypes = (
    utils._BYREF_FLOAT64, # Input, xr.
    utils._BYREF_FLOAT64, # Input, xi.
)

divide = utils._EngineState._get_symbol('a02acf')
divide.restype = None
divide.argtypes = (
    utils._BYREF_FLOAT64, # Input, xr.
    utils._BYREF_FLOAT64, # Input, xi.
    utils._BYREF_FLOAT64, # Input, yr.
    utils._BYREF_FLOAT64, # Input, yi.
    utils._BYREF_FLOAT64, # Output, zr.
    utils._BYREF_FLOAT64, # Output, zi.
)
