# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `det` Chapter.
"""

# NAG Copyright 2017-2020.

from ..base import utils

real_gen = utils._EngineState._get_symbol('f03baf')
real_gen.restype = None
real_gen.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineIntArrayType.c_type, # Input, ipiv[n].
    utils._BYREF_FLOAT64, # Output, d.
    utils._BYREF_INT, # Output, id.
    utils._BYREF_INT, # Input/Output, ifail.
)

real_sym = utils._EngineState._get_symbol('f03bff')
real_sym.restype = None
real_sym.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._BYREF_FLOAT64, # Output, d.
    utils._BYREF_INT, # Output, id.
    utils._BYREF_INT, # Input/Output, ifail.
)

real_band_sym = utils._EngineState._get_symbol('f03bhf')
real_band_sym.restype = None
real_band_sym.argtypes = (
    utils._BYREF_STRING, # Input, uplo(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, kd.
    utils._EngineFloat64ArrayType.c_type, # Input, ab[ldab, *].
    utils._BYREF_INT, # Input, ldab.
    utils._BYREF_FLOAT64, # Output, d.
    utils._BYREF_INT, # Output, id.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of uplo.
)

complex_gen = utils._EngineState._get_symbol('f03bnf')
complex_gen.restype = None
complex_gen.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineComplex128ArrayType.c_type, # Input, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineIntArrayType.c_type, # Input, ipiv[n].
    utils._BYREF_COMPLEX128, # Output, d.
    utils._EngineIntArrayType.c_type, # Output, id[2].
    utils._BYREF_INT, # Input/Output, ifail.
)
