# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `dot` Chapter.
"""

# NAG Copyright 2017-2020.

from ..base import utils

real_prec = utils._EngineState._get_symbol('x03aaf')
real_prec.restype = None
real_prec.argtypes = (
    utils._EngineFloat64ArrayType.c_type, # Input, a[isizea].
    utils._BYREF_INT, # Input, isizea.
    utils._EngineFloat64ArrayType.c_type, # Input, b[isizeb].
    utils._BYREF_INT, # Input, isizeb.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, istepa.
    utils._BYREF_INT, # Input, istepb.
    utils._BYREF_FLOAT64, # Input, c1.
    utils._BYREF_FLOAT64, # Input, c2.
    utils._BYREF_FLOAT64, # Output, d1.
    utils._BYREF_FLOAT64, # Output, d2.
    utils._BYREF_LOGICAL, # Input, sw.
    utils._BYREF_INT, # Input/Output, ifail.
)

complex_prec = utils._EngineState._get_symbol('x03abf')
complex_prec.restype = None
complex_prec.argtypes = (
    utils._EngineComplex128ArrayType.c_type, # Input, a[isizea].
    utils._BYREF_INT, # Input, isizea.
    utils._EngineComplex128ArrayType.c_type, # Input, b[isizeb].
    utils._BYREF_INT, # Input, isizeb.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, istepa.
    utils._BYREF_INT, # Input, istepb.
    utils._BYREF_COMPLEX128, # Input, cx.
    utils._BYREF_COMPLEX128, # Output, dx.
    utils._BYREF_LOGICAL, # Input, sw.
    utils._BYREF_INT, # Input/Output, ifail.
)
