# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `fit` Chapter.
"""

# NAG Copyright 2017-2020.

from ..base import utils

dim1_cheb_arb = utils._EngineState._get_symbol('e02adf')
dim1_cheb_arb.restype = None
dim1_cheb_arb.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, kplus1.
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input, x[m].
    utils._EngineFloat64ArrayType.c_type, # Input, y[m].
    utils._EngineFloat64ArrayType.c_type, # Input, w[m].
    utils._EngineFloat64ArrayType.c_type, # Workspace, work1[3*m].
    utils._EngineFloat64ArrayType.c_type, # Workspace, work2[2*kplus1].
    utils._EngineFloat64ArrayType.c_type, # Output, a[lda, kplus1].
    utils._EngineFloat64ArrayType.c_type, # Output, s[kplus1].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim1_cheb_eval = utils._EngineState._get_symbol('e02aef')
dim1_cheb_eval.restype = None
dim1_cheb_eval.argtypes = (
    utils._BYREF_INT, # Input, nplus1.
    utils._EngineFloat64ArrayType.c_type, # Input, a[nplus1].
    utils._BYREF_FLOAT64, # Input, xcap.
    utils._BYREF_FLOAT64, # Output, p.
    utils._BYREF_INT, # Input/Output, ifail.
)

dim1_cheb_glp = utils._EngineState._get_symbol('e02aff')
dim1_cheb_glp.restype = None
dim1_cheb_glp.argtypes = (
    utils._BYREF_INT, # Input, nplus1.
    utils._EngineFloat64ArrayType.c_type, # Input, f[nplus1].
    utils._EngineFloat64ArrayType.c_type, # Output, a[nplus1].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim1_cheb_con = utils._EngineState._get_symbol('e02agf')
dim1_cheb_con.restype = None
dim1_cheb_con.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, kplus1.
    utils._BYREF_INT, # Input, lda.
    utils._BYREF_FLOAT64, # Input, xmin.
    utils._BYREF_FLOAT64, # Input, xmax.
    utils._EngineFloat64ArrayType.c_type, # Input, x[m].
    utils._EngineFloat64ArrayType.c_type, # Input, y[m].
    utils._EngineFloat64ArrayType.c_type, # Input, w[m].
    utils._BYREF_INT, # Input, mf.
    utils._EngineFloat64ArrayType.c_type, # Input, xf[mf].
    utils._EngineFloat64ArrayType.c_type, # Input, yf[lyf].
    utils._BYREF_INT, # Input, lyf.
    utils._EngineIntArrayType.c_type, # Input, ip[mf].
    utils._EngineFloat64ArrayType.c_type, # Output, a[lda, kplus1].
    utils._EngineFloat64ArrayType.c_type, # Output, s[kplus1].
    utils._BYREF_INT, # Output, np1.
    utils._EngineFloat64ArrayType.c_type, # Output, wrk[lwrk].
    utils._BYREF_INT, # Input, lwrk.
    utils._EngineIntArrayType.c_type, # Workspace, iwrk[liwrk].
    utils._BYREF_INT, # Input, liwrk.
    utils._BYREF_INT, # Input/Output, ifail.
)

dim1_cheb_deriv = utils._EngineState._get_symbol('e02ahf')
dim1_cheb_deriv.restype = None
dim1_cheb_deriv.argtypes = (
    utils._BYREF_INT, # Input, np1.
    utils._BYREF_FLOAT64, # Input, xmin.
    utils._BYREF_FLOAT64, # Input, xmax.
    utils._EngineFloat64ArrayType.c_type, # Input, a[la].
    utils._BYREF_INT, # Input, ia1.
    utils._BYREF_INT, # Input, la.
    utils._BYREF_FLOAT64, # Output, patm1.
    utils._EngineFloat64ArrayType.c_type, # Output, adif[ladif].
    utils._BYREF_INT, # Input, iadif1.
    utils._BYREF_INT, # Input, ladif.
    utils._BYREF_INT, # Input/Output, ifail.
)

dim1_cheb_integ = utils._EngineState._get_symbol('e02ajf')
dim1_cheb_integ.restype = None
dim1_cheb_integ.argtypes = (
    utils._BYREF_INT, # Input, np1.
    utils._BYREF_FLOAT64, # Input, xmin.
    utils._BYREF_FLOAT64, # Input, xmax.
    utils._EngineFloat64ArrayType.c_type, # Input, a[la].
    utils._BYREF_INT, # Input, ia1.
    utils._BYREF_INT, # Input, la.
    utils._BYREF_FLOAT64, # Input, qatm1.
    utils._EngineFloat64ArrayType.c_type, # Output, aintc[laint].
    utils._BYREF_INT, # Input, iaint1.
    utils._BYREF_INT, # Input, laint.
    utils._BYREF_INT, # Input/Output, ifail.
)

dim1_cheb_eval2 = utils._EngineState._get_symbol('e02akf')
dim1_cheb_eval2.restype = None
dim1_cheb_eval2.argtypes = (
    utils._BYREF_INT, # Input, np1.
    utils._BYREF_FLOAT64, # Input, xmin.
    utils._BYREF_FLOAT64, # Input, xmax.
    utils._EngineFloat64ArrayType.c_type, # Input, a[la].
    utils._BYREF_INT, # Input, ia1.
    utils._BYREF_INT, # Input, la.
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_FLOAT64, # Output, result.
    utils._BYREF_INT, # Input/Output, ifail.
)

dim1_minimax_polynomial = utils._EngineState._get_symbol('e02alf')
dim1_minimax_polynomial.restype = None
dim1_minimax_polynomial.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Output, a[m+1].
    utils._BYREF_FLOAT64, # Output, ref.
    utils._BYREF_INT, # Input/Output, ifail.
)

dim1_spline_knots = utils._EngineState._get_symbol('e02baf')
dim1_spline_knots.restype = None
dim1_spline_knots.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, ncap7.
    utils._EngineFloat64ArrayType.c_type, # Input, x[m].
    utils._EngineFloat64ArrayType.c_type, # Input, y[m].
    utils._EngineFloat64ArrayType.c_type, # Input, w[m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, lamda[ncap7].
    utils._EngineFloat64ArrayType.c_type, # Workspace, work1[m].
    utils._EngineFloat64ArrayType.c_type, # Workspace, work2[4*ncap7].
    utils._EngineFloat64ArrayType.c_type, # Output, c[ncap7].
    utils._BYREF_FLOAT64, # Output, ss.
    utils._BYREF_INT, # Input/Output, ifail.
)

dim1_spline_eval = utils._EngineState._get_symbol('e02bbf')
dim1_spline_eval.restype = None
dim1_spline_eval.argtypes = (
    utils._BYREF_INT, # Input, ncap7.
    utils._EngineFloat64ArrayType.c_type, # Input, lamda[ncap7].
    utils._EngineFloat64ArrayType.c_type, # Input, c[ncap7].
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_FLOAT64, # Output, s.
    utils._BYREF_INT, # Input/Output, ifail.
)

dim1_spline_deriv = utils._EngineState._get_symbol('e02bcf')
dim1_spline_deriv.restype = None
dim1_spline_deriv.argtypes = (
    utils._BYREF_INT, # Input, ncap7.
    utils._EngineFloat64ArrayType.c_type, # Input, lamda[ncap7].
    utils._EngineFloat64ArrayType.c_type, # Input, c[ncap7].
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_INT, # Input, left.
    utils._EngineFloat64ArrayType.c_type, # Output, s[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim1_spline_integ = utils._EngineState._get_symbol('e02bdf')
dim1_spline_integ.restype = None
dim1_spline_integ.argtypes = (
    utils._BYREF_INT, # Input, ncap7.
    utils._EngineFloat64ArrayType.c_type, # Input, lamda[ncap7].
    utils._EngineFloat64ArrayType.c_type, # Input, c[ncap7].
    utils._BYREF_FLOAT64, # Output, dint.
    utils._BYREF_INT, # Input/Output, ifail.
)

dim1_spline_auto = utils._EngineState._get_symbol('e02bef')
dim1_spline_auto.restype = None
dim1_spline_auto.argtypes = (
    utils._BYREF_STRING, # Input, start(len=1).
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, x[m].
    utils._EngineFloat64ArrayType.c_type, # Input, y[m].
    utils._EngineFloat64ArrayType.c_type, # Input, w[m].
    utils._BYREF_FLOAT64, # Input, s.
    utils._BYREF_INT, # Input, nest.
    utils._BYREF_INT, # Input/Output, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, lamda[nest].
    utils._EngineFloat64ArrayType.c_type, # Output, c[nest].
    utils._BYREF_FLOAT64, # Output, fp.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, wrk[lwrk].
    utils._BYREF_INT, # Input, lwrk.
    utils._EngineIntArrayType.c_type, # Input/Output, iwrk[nest].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of start.
)

dim1_spline_deriv_vector = utils._EngineState._get_symbol('e02bff')
dim1_spline_deriv_vector.restype = None
dim1_spline_deriv_vector.argtypes = (
    utils._BYREF_INT, # Input, start.
    utils._BYREF_INT, # Input, ncap7.
    utils._EngineFloat64ArrayType.c_type, # Input, lamda[ncap7].
    utils._EngineFloat64ArrayType.c_type, # Input, c[ncap7].
    utils._BYREF_INT, # Input, deriv.
    utils._BYREF_INT, # Input, xord.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nx].
    utils._EngineIntArrayType.c_type, # Input/Output, ixloc[nx].
    utils._BYREF_INT, # Input, nx.
    utils._EngineFloat64ArrayType.c_type, # Output, s[lds, *].
    utils._BYREF_INT, # Input, lds.
    utils._EngineIntArrayType.c_type, # Input/Output, iwrk[liwrk].
    utils._BYREF_INT, # Input, liwrk.
    utils._BYREF_INT, # Input/Output, ifail.
)

dim2_cheb_lines = utils._EngineState._get_symbol('e02caf')
dim2_cheb_lines.restype = None
dim2_cheb_lines.argtypes = (
    utils._EngineIntArrayType.c_type, # Input, m[n].
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, k.
    utils._BYREF_INT, # Input, l.
    utils._EngineFloat64ArrayType.c_type, # Input, x[mtot].
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._EngineFloat64ArrayType.c_type, # Input, f[mtot].
    utils._EngineFloat64ArrayType.c_type, # Input, w[mtot].
    utils._BYREF_INT, # Input, mtot.
    utils._EngineFloat64ArrayType.c_type, # Output, a[na].
    utils._BYREF_INT, # Input, na.
    utils._EngineFloat64ArrayType.c_type, # Input, xmin[n].
    utils._EngineFloat64ArrayType.c_type, # Input, xmax[n].
    utils._EngineFloat64ArrayType.c_type, # Input, nux[inuxp1].
    utils._BYREF_INT, # Input, inuxp1.
    utils._EngineFloat64ArrayType.c_type, # Input, nuy[inuyp1].
    utils._BYREF_INT, # Input, inuyp1.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[nwork].
    utils._BYREF_INT, # Input, nwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

dim2_cheb_eval = utils._EngineState._get_symbol('e02cbf')
dim2_cheb_eval.restype = None
dim2_cheb_eval.argtypes = (
    utils._BYREF_INT, # Input, mfirst.
    utils._BYREF_INT, # Input, mlast.
    utils._BYREF_INT, # Input, k.
    utils._BYREF_INT, # Input, l.
    utils._EngineFloat64ArrayType.c_type, # Input, x[mlast].
    utils._BYREF_FLOAT64, # Input, xmin.
    utils._BYREF_FLOAT64, # Input, xmax.
    utils._BYREF_FLOAT64, # Input, y.
    utils._BYREF_FLOAT64, # Input, ymin.
    utils._BYREF_FLOAT64, # Input, ymax.
    utils._EngineFloat64ArrayType.c_type, # Output, ff[mlast].
    utils._EngineFloat64ArrayType.c_type, # Input, a[na].
    utils._BYREF_INT, # Input, na.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[nwork].
    utils._BYREF_INT, # Input, nwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

dim2_spline_panel = utils._EngineState._get_symbol('e02daf')
dim2_spline_panel.restype = None
dim2_spline_panel.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, px.
    utils._BYREF_INT, # Input, py.
    utils._EngineFloat64ArrayType.c_type, # Input, x[m].
    utils._EngineFloat64ArrayType.c_type, # Input, y[m].
    utils._EngineFloat64ArrayType.c_type, # Input, f[m].
    utils._EngineFloat64ArrayType.c_type, # Input, w[m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, lamda[px].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, mu[py].
    utils._EngineIntArrayType.c_type, # Input, point[npoint].
    utils._BYREF_INT, # Input, npoint.
    utils._EngineFloat64ArrayType.c_type, # Output, dl[nc].
    utils._EngineFloat64ArrayType.c_type, # Output, c[nc].
    utils._BYREF_INT, # Input, nc.
    utils._EngineFloat64ArrayType.c_type, # Workspace, ws[nws].
    utils._BYREF_INT, # Input, nws.
    utils._BYREF_FLOAT64, # Input, eps.
    utils._BYREF_FLOAT64, # Output, sigma.
    utils._BYREF_INT, # Output, rank.
    utils._BYREF_INT, # Input/Output, ifail.
)

dim2_spline_grid = utils._EngineState._get_symbol('e02dcf')
dim2_spline_grid.restype = None
dim2_spline_grid.argtypes = (
    utils._BYREF_STRING, # Input, start(len=1).
    utils._BYREF_INT, # Input, mx.
    utils._EngineFloat64ArrayType.c_type, # Input, x[mx].
    utils._BYREF_INT, # Input, my.
    utils._EngineFloat64ArrayType.c_type, # Input, y[my].
    utils._EngineFloat64ArrayType.c_type, # Input, f[mx*my].
    utils._BYREF_FLOAT64, # Input, s.
    utils._BYREF_INT, # Input, nxest.
    utils._BYREF_INT, # Input, nyest.
    utils._BYREF_INT, # Input/Output, nx.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, lamda[nxest].
    utils._BYREF_INT, # Input/Output, ny.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, mu[nyest].
    utils._EngineFloat64ArrayType.c_type, # Output, c[(nxest-4)*(nyest-4)].
    utils._BYREF_FLOAT64, # Output, fp.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, wrk[lwrk].
    utils._BYREF_INT, # Input, lwrk.
    utils._EngineIntArrayType.c_type, # Input/Output, iwrk[liwrk].
    utils._BYREF_INT, # Input, liwrk.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of start.
)

dim2_spline_sctr = utils._EngineState._get_symbol('e02ddf')
dim2_spline_sctr.restype = None
dim2_spline_sctr.argtypes = (
    utils._BYREF_STRING, # Input, start(len=1).
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[m].
    utils._EngineFloat64ArrayType.c_type, # Input, f[m].
    utils._EngineFloat64ArrayType.c_type, # Input, w[m].
    utils._BYREF_FLOAT64, # Input, s.
    utils._BYREF_INT, # Input, nxest.
    utils._BYREF_INT, # Input, nyest.
    utils._BYREF_INT, # Input/Output, nx.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, lamda[nxest].
    utils._BYREF_INT, # Input/Output, ny.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, mu[nyest].
    utils._EngineFloat64ArrayType.c_type, # Output, c[(nxest-4)*(nyest-4)].
    utils._BYREF_FLOAT64, # Output, fp.
    utils._BYREF_INT, # Output, rank.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, wrk[lwrk].
    utils._BYREF_INT, # Input, lwrk.
    utils._EngineIntArrayType.c_type, # Workspace, iwrk[liwrk].
    utils._BYREF_INT, # Input, liwrk.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of start.
)

dim2_spline_evalv = utils._EngineState._get_symbol('e02def')
dim2_spline_evalv.restype = None
dim2_spline_evalv.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, px.
    utils._BYREF_INT, # Input, py.
    utils._EngineFloat64ArrayType.c_type, # Input, x[m].
    utils._EngineFloat64ArrayType.c_type, # Input, y[m].
    utils._EngineFloat64ArrayType.c_type, # Input, lamda[px].
    utils._EngineFloat64ArrayType.c_type, # Input, mu[py].
    utils._EngineFloat64ArrayType.c_type, # Input, c[(px-4)*(py-4)].
    utils._EngineFloat64ArrayType.c_type, # Output, ff[m].
    utils._EngineFloat64ArrayType.c_type, # Workspace, wrk[py-4].
    utils._EngineIntArrayType.c_type, # Workspace, iwrk[py-4].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim2_spline_evalm = utils._EngineState._get_symbol('e02dff')
dim2_spline_evalm.restype = None
dim2_spline_evalm.argtypes = (
    utils._BYREF_INT, # Input, mx.
    utils._BYREF_INT, # Input, my.
    utils._BYREF_INT, # Input, px.
    utils._BYREF_INT, # Input, py.
    utils._EngineFloat64ArrayType.c_type, # Input, x[mx].
    utils._EngineFloat64ArrayType.c_type, # Input, y[my].
    utils._EngineFloat64ArrayType.c_type, # Input, lamda[px].
    utils._EngineFloat64ArrayType.c_type, # Input, mu[py].
    utils._EngineFloat64ArrayType.c_type, # Input, c[(px-4)*(py-4)].
    utils._EngineFloat64ArrayType.c_type, # Output, ff[mx*my].
    utils._EngineFloat64ArrayType.c_type, # Workspace, wrk[lwrk].
    utils._BYREF_INT, # Input, lwrk.
    utils._EngineIntArrayType.c_type, # Workspace, iwrk[liwrk].
    utils._BYREF_INT, # Input, liwrk.
    utils._BYREF_INT, # Input/Output, ifail.
)

dim2_spline_derivm = utils._EngineState._get_symbol('e02dhf')
dim2_spline_derivm.restype = None
dim2_spline_derivm.argtypes = (
    utils._BYREF_INT, # Input, mx.
    utils._BYREF_INT, # Input, my.
    utils._BYREF_INT, # Input, px.
    utils._BYREF_INT, # Input, py.
    utils._EngineFloat64ArrayType.c_type, # Input, x[mx].
    utils._EngineFloat64ArrayType.c_type, # Input, y[my].
    utils._EngineFloat64ArrayType.c_type, # Input, lamda[px].
    utils._EngineFloat64ArrayType.c_type, # Input, mu[py].
    utils._EngineFloat64ArrayType.c_type, # Input, c[(px-4)*(py-4)].
    utils._BYREF_INT, # Input, nux.
    utils._BYREF_INT, # Input, nuy.
    utils._EngineFloat64ArrayType.c_type, # Output, z[mx*my].
    utils._BYREF_INT, # Input/Output, ifail.
)

glin_l1sol = utils._EngineState._get_symbol('e02gaf')
glin_l1sol.restype = None
glin_l1sol.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[lda, nplus2].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, b[m].
    utils._BYREF_INT, # Input, nplus2.
    utils._BYREF_FLOAT64, # Input, toler.
    utils._EngineFloat64ArrayType.c_type, # Output, x[nplus2].
    utils._BYREF_FLOAT64, # Output, resid.
    utils._BYREF_INT, # Output, irank.
    utils._BYREF_INT, # Output, iter.
    utils._EngineIntArrayType.c_type, # Workspace, iwork[m].
    utils._BYREF_INT, # Input/Output, ifail.
)

glinc_l1sol_monit = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_INT, # Input, niter.
    utils._BYREF_INT, # Input, k.
    utils._BYREF_FLOAT64, # Input, el1n.
)
glinc_l1sol = utils._EngineState._get_symbol('e02gbf')
glinc_l1sol.restype = None
glinc_l1sol.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, mpl.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, e[lde, mpl].
    utils._BYREF_INT, # Input, lde.
    utils._EngineFloat64ArrayType.c_type, # Input, f[mpl].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_INT, # Input, mxs.
    glinc_l1sol_monit,
    utils._BYREF_INT, # Input, iprint.
    utils._BYREF_INT, # Output, k.
    utils._BYREF_FLOAT64, # Output, el1n.
    utils._EngineIntArrayType.c_type, # Output, indx[mpl].
    utils._EngineFloat64ArrayType.c_type, # Workspace, w[iw].
    utils._BYREF_INT, # Input, iw.
    utils._BYREF_INT, # Input/Output, ifail.
)

glin_linf = utils._EngineState._get_symbol('e02gcf')
glin_linf.restype = None
glin_linf.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, sda.
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[lda, sda].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, b[m].
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_FLOAT64, # Input/Output, relerr.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_FLOAT64, # Output, resmax.
    utils._BYREF_INT, # Output, irank.
    utils._BYREF_INT, # Output, iter.
    utils._BYREF_INT, # Input/Output, ifail.
)

dim2_spline_ts_sctr = utils._EngineState._get_symbol('e02jdf')
dim2_spline_ts_sctr.restype = None
dim2_spline_ts_sctr.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._EngineFloat64ArrayType.c_type, # Input, f[n].
    utils._BYREF_INT, # Input, lsminp.
    utils._BYREF_INT, # Input, lsmaxp.
    utils._BYREF_INT, # Input, nxcels.
    utils._BYREF_INT, # Input, nycels.
    utils._BYREF_INT, # Input, lcoefs.
    utils._EngineFloat64ArrayType.c_type, # Output, coefs[lcoefs].
    utils._EngineIntArrayType.c_type, # Input/Output, iopts[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, opts[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim2_spline_ts_evalv = utils._EngineState._get_symbol('e02jef')
dim2_spline_ts_evalv.restype = None
dim2_spline_ts_evalv.argtypes = (
    utils._BYREF_INT, # Input, nevalv.
    utils._EngineFloat64ArrayType.c_type, # Input, xevalv[nevalv].
    utils._EngineFloat64ArrayType.c_type, # Input, yevalv[nevalv].
    utils._EngineFloat64ArrayType.c_type, # Input, coefs[*].
    utils._EngineFloat64ArrayType.c_type, # Output, fevalv[nevalv].
    utils._EngineIntArrayType.c_type, # Input, iopts[*].
    utils._EngineFloat64ArrayType.c_type, # Input, opts[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim2_spline_ts_evalm = utils._EngineState._get_symbol('e02jff')
dim2_spline_ts_evalm.restype = None
dim2_spline_ts_evalm.argtypes = (
    utils._BYREF_INT, # Input, nxeval.
    utils._BYREF_INT, # Input, nyeval.
    utils._EngineFloat64ArrayType.c_type, # Input, xevalm[nxeval].
    utils._EngineFloat64ArrayType.c_type, # Input, yevalm[nyeval].
    utils._EngineFloat64ArrayType.c_type, # Input, coefs[*].
    utils._EngineFloat64ArrayType.c_type, # Output, fevalm[nxeval, nyeval].
    utils._EngineIntArrayType.c_type, # Input, iopts[*].
    utils._EngineFloat64ArrayType.c_type, # Input, opts[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

pade_app = utils._EngineState._get_symbol('e02raf')
pade_app.restype = None
pade_app.argtypes = (
    utils._BYREF_INT, # Input, ia.
    utils._BYREF_INT, # Input, ib.
    utils._EngineFloat64ArrayType.c_type, # Input, c[ic].
    utils._BYREF_INT, # Input, ic.
    utils._EngineFloat64ArrayType.c_type, # Output, a[ia].
    utils._EngineFloat64ArrayType.c_type, # Output, b[ib].
    utils._EngineFloat64ArrayType.c_type, # Workspace, w[jw].
    utils._BYREF_INT, # Input, jw.
    utils._BYREF_INT, # Input/Output, ifail.
)

pade_eval = utils._EngineState._get_symbol('e02rbf')
pade_eval.restype = None
pade_eval.argtypes = (
    utils._EngineFloat64ArrayType.c_type, # Input, a[ia].
    utils._BYREF_INT, # Input, ia.
    utils._EngineFloat64ArrayType.c_type, # Input, b[ib].
    utils._BYREF_INT, # Input, ib.
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_FLOAT64, # Output, ans.
    utils._BYREF_INT, # Input/Output, ifail.
)

dim2_spline_sort = utils._EngineState._get_symbol('e02zaf')
dim2_spline_sort.restype = None
dim2_spline_sort.argtypes = (
    utils._BYREF_INT, # Input, px.
    utils._BYREF_INT, # Input, py.
    utils._EngineFloat64ArrayType.c_type, # Input, lamda[px].
    utils._EngineFloat64ArrayType.c_type, # Input, mu[py].
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, x[m].
    utils._EngineFloat64ArrayType.c_type, # Input, y[m].
    utils._EngineIntArrayType.c_type, # Output, point[npoint].
    utils._BYREF_INT, # Input, npoint.
    utils._EngineIntArrayType.c_type, # Workspace, adres[nadres].
    utils._BYREF_INT, # Input, nadres.
    utils._BYREF_INT, # Input/Output, ifail.
)

opt_set = utils._EngineState._get_symbol('e02zkf')
opt_set.restype = None
opt_set.argtypes = (
    utils._BYREF_STRING, # Input, optstr(len=*).
    utils._EngineIntArrayType.c_type, # Input/Output, iopts[liopts].
    utils._BYREF_INT, # Input, liopts.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, opts[lopts].
    utils._BYREF_INT, # Input, lopts.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of optstr.
)

opt_get = utils._EngineState._get_symbol('e02zlf')
opt_get.restype = None
opt_get.argtypes = (
    utils._BYREF_STRING, # Input, optstr(len=*).
    utils._BYREF_INT, # Output, ivalue.
    utils._BYREF_FLOAT64, # Output, rvalue.
    utils._BYREF_STRING, # Output, cvalue(len=*).
    utils._BYREF_INT, # Output, optype.
    utils._EngineIntArrayType.c_type, # Input, iopts[*].
    utils._EngineFloat64ArrayType.c_type, # Input, opts[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of optstr.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cvalue.
)
