# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `glopt` Chapter.
"""

# NAG Copyright 2017-2020.

from ..base import utils

bnd_mcs_init = utils._EngineState._get_symbol('e05jaf')
bnd_mcs_init.restype = None
bnd_mcs_init.argtypes = (
    utils._BYREF_INT, # Input, n_r.
    utils._EngineFloat64ArrayType.c_type, # Output, comm[lcomm].
    utils._BYREF_INT, # Input, lcomm.
    utils._BYREF_INT, # Input/Output, ifail.
)

bnd_mcs_solve_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_FLOAT64, # Output, f.
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Output, inform.
)
bnd_mcs_solve_monit = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ncall.
    utils._EngineFloat64ArrayType.c_type, # Input, xbest[n].
    utils._EngineIntArrayType.c_type, # Input, icount[6].
    utils._BYREF_INT, # Input, ninit.
    utils._EngineFloat64ArrayType.c_type, # Input, list[n, ninit].
    utils._EngineIntArrayType.c_type, # Input, numpts[n].
    utils._EngineIntArrayType.c_type, # Input, initpt[n].
    utils._BYREF_INT, # Input, nbaskt.
    utils._EngineFloat64ArrayType.c_type, # Input, xbaskt[n, nbaskt].
    utils._EngineFloat64ArrayType.c_type, # Input, boxl[n].
    utils._EngineFloat64ArrayType.c_type, # Input, boxu[n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Output, inform.
)
bnd_mcs_solve = utils._EngineState._get_symbol('e05jbf')
bnd_mcs_solve.restype = None
bnd_mcs_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    bnd_mcs_solve_objfun,
    utils._BYREF_INT, # Input, ibound.
    utils._BYREF_INT, # Input, iinit.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bl[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bu[n].
    utils._BYREF_INT, # Input, sdlist.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, list[n, sdlist].
    utils._EngineIntArrayType.c_type, # Input/Output, numpts[n].
    utils._EngineIntArrayType.c_type, # Input/Output, initpt[n].
    bnd_mcs_solve_monit,
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_FLOAT64, # Output, obj.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, comm[lcomm].
    utils._BYREF_INT, # Input, lcomm.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

bnd_mcs_dummy_monit = utils._EngineState._get_symbol('e05jbk')
bnd_mcs_dummy_monit.restype = None
bnd_mcs_dummy_monit.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ncall.
    utils._EngineFloat64ArrayType.c_type, # Input, xbest[n].
    utils._EngineIntArrayType.c_type, # Input, icount[6].
    utils._BYREF_INT, # Input, ninit.
    utils._EngineFloat64ArrayType.c_type, # Input, list[n, ninit].
    utils._EngineIntArrayType.c_type, # Input, numpts[n].
    utils._EngineIntArrayType.c_type, # Input, initpt[n].
    utils._BYREF_INT, # Input, nbaskt.
    utils._EngineFloat64ArrayType.c_type, # Input, xbaskt[n, nbaskt].
    utils._EngineFloat64ArrayType.c_type, # Input, boxl[n].
    utils._EngineFloat64ArrayType.c_type, # Input, boxu[n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Output, inform.
)

bnd_mcs_optset_file = utils._EngineState._get_symbol('e05jcf')
bnd_mcs_optset_file.restype = None
bnd_mcs_optset_file.argtypes = (
    utils._BYREF_INT, # Input, iopts.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, comm[lcomm].
    utils._BYREF_INT, # Input, lcomm.
    utils._BYREF_INT, # Input/Output, ifail.
)

bnd_mcs_optset_string = utils._EngineState._get_symbol('e05jdf')
bnd_mcs_optset_string.restype = None
bnd_mcs_optset_string.argtypes = (
    utils._BYREF_STRING, # Input, optstr(len=*).
    utils._EngineFloat64ArrayType.c_type, # Input/Output, comm[lcomm].
    utils._BYREF_INT, # Input, lcomm.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of optstr.
)

bnd_mcs_optset_char = utils._EngineState._get_symbol('e05jef')
bnd_mcs_optset_char.restype = None
bnd_mcs_optset_char.argtypes = (
    utils._BYREF_STRING, # Input, optstr(len=*).
    utils._BYREF_STRING, # Input, cvalue(len=*).
    utils._EngineFloat64ArrayType.c_type, # Input/Output, comm[lcomm].
    utils._BYREF_INT, # Input, lcomm.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of optstr.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cvalue.
)

bnd_mcs_optset_int = utils._EngineState._get_symbol('e05jff')
bnd_mcs_optset_int.restype = None
bnd_mcs_optset_int.argtypes = (
    utils._BYREF_STRING, # Input, optstr(len=*).
    utils._BYREF_INT, # Input, ivalue.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, comm[lcomm].
    utils._BYREF_INT, # Input, lcomm.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of optstr.
)

bnd_mcs_optset_real = utils._EngineState._get_symbol('e05jgf')
bnd_mcs_optset_real.restype = None
bnd_mcs_optset_real.argtypes = (
    utils._BYREF_STRING, # Input, optstr(len=*).
    utils._BYREF_FLOAT64, # Input, rvalue.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, comm[lcomm].
    utils._BYREF_INT, # Input, lcomm.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of optstr.
)

bnd_mcs_option_check = utils._EngineState._get_symbol('e05jhf')
bnd_mcs_option_check.restype = utils._EngineIntScalarType.c_type
bnd_mcs_option_check.argtypes = (
    utils._BYREF_STRING, # Input, optstr(len=*).
    utils._EngineFloat64ArrayType.c_type, # Input, comm[lcomm].
    utils._BYREF_INT, # Input, lcomm.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of optstr.
)

bnd_mcs_optget_char = utils._EngineState._get_symbol('e05jjf')
bnd_mcs_optget_char.restype = None
bnd_mcs_optget_char.argtypes = (
    utils._BYREF_STRING, # Input, optstr(len=*).
    utils._BYREF_STRING, # Output, cvalue(len=*).
    utils._EngineFloat64ArrayType.c_type, # Input, comm[lcomm].
    utils._BYREF_INT, # Input, lcomm.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of optstr.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cvalue.
)

bnd_mcs_optget_int = utils._EngineState._get_symbol('e05jkf')
bnd_mcs_optget_int.restype = None
bnd_mcs_optget_int.argtypes = (
    utils._BYREF_STRING, # Input, optstr(len=*).
    utils._BYREF_INT, # Output, ivalue.
    utils._EngineFloat64ArrayType.c_type, # Input, comm[lcomm].
    utils._BYREF_INT, # Input, lcomm.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of optstr.
)

bnd_mcs_optget_real = utils._EngineState._get_symbol('e05jlf')
bnd_mcs_optget_real.restype = None
bnd_mcs_optget_real.argtypes = (
    utils._BYREF_STRING, # Input, optstr(len=*).
    utils._BYREF_FLOAT64, # Output, rvalue.
    utils._EngineFloat64ArrayType.c_type, # Input, comm[lcomm].
    utils._BYREF_INT, # Input, lcomm.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of optstr.
)

bnd_pso_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, ndim.
    utils._EngineFloat64ArrayType.c_type, # Input, x[ndim].
    utils._BYREF_FLOAT64, # Input/Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, vecout[ndim].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
bnd_pso_monmod = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, ndim.
    utils._BYREF_INT, # Input, npar.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[ndim, npar].
    utils._EngineFloat64ArrayType.c_type, # Input, xb[ndim].
    utils._BYREF_FLOAT64, # Input, fb.
    utils._EngineFloat64ArrayType.c_type, # Input, xbest[ndim, npar].
    utils._EngineFloat64ArrayType.c_type, # Input, fbest[npar].
    utils._EngineIntArrayType.c_type, # Input, itt[6].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, inform.
)
bnd_pso = utils._EngineState._get_symbol('e05saf')
bnd_pso.restype = None
bnd_pso.argtypes = (
    utils._BYREF_INT, # Input, ndim.
    utils._BYREF_INT, # Input, npar.
    utils._EngineFloat64ArrayType.c_type, # Output, xb[ndim].
    utils._BYREF_FLOAT64, # Output, fb.
    utils._EngineFloat64ArrayType.c_type, # Input, bl[ndim].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[ndim].
    bnd_pso_objfun,
    bnd_pso_monmod,
    utils._EngineIntArrayType.c_type, # Input/Output, iopts[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, opts[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineIntArrayType.c_type, # Output, itt[6].
    utils._BYREF_INT, # Output, inform.
    utils._BYREF_INT, # Input/Output, ifail.
)

nlp_pso_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, ndim.
    utils._EngineFloat64ArrayType.c_type, # Input, x[ndim].
    utils._BYREF_FLOAT64, # Input/Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, vecout[ndim].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
nlp_pso_confun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, ncon.
    utils._BYREF_INT, # Input, ndim.
    utils._BYREF_INT, # Input, ldcj.
    utils._EngineIntArrayType.c_type, # Input, needc[ncon].
    utils._EngineFloat64ArrayType.c_type, # Input, x[ndim].
    utils._EngineFloat64ArrayType.c_type, # Output, c[ncon].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjac[ldcj, ndim].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
nlp_pso_monmod = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, ndim.
    utils._BYREF_INT, # Input, ncon.
    utils._BYREF_INT, # Input, npar.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[ndim, npar].
    utils._EngineFloat64ArrayType.c_type, # Input, xb[ndim].
    utils._BYREF_FLOAT64, # Input, fb.
    utils._EngineFloat64ArrayType.c_type, # Input, cb[ncon].
    utils._EngineFloat64ArrayType.c_type, # Input, xbest[ndim, npar].
    utils._EngineFloat64ArrayType.c_type, # Input, fbest[npar].
    utils._EngineFloat64ArrayType.c_type, # Input, cbest[ncon, npar].
    utils._EngineIntArrayType.c_type, # Input, itt[7].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, inform.
)
nlp_pso = utils._EngineState._get_symbol('e05sbf')
nlp_pso.restype = None
nlp_pso.argtypes = (
    utils._BYREF_INT, # Input, ndim.
    utils._BYREF_INT, # Input, ncon.
    utils._BYREF_INT, # Input, npar.
    utils._EngineFloat64ArrayType.c_type, # Output, xb[ndim].
    utils._BYREF_FLOAT64, # Output, fb.
    utils._EngineFloat64ArrayType.c_type, # Output, cb[ncon].
    utils._EngineFloat64ArrayType.c_type, # Input, bl[ndim+ncon].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[ndim+ncon].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, xbest[ndim, npar].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fbest[npar].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cbest[ncon, npar].
    nlp_pso_objfun,
    nlp_pso_confun,
    nlp_pso_monmod,
    utils._EngineIntArrayType.c_type, # Input/Output, iopts[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, opts[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineIntArrayType.c_type, # Output, itt[7].
    utils._BYREF_INT, # Output, inform.
    utils._BYREF_INT, # Input/Output, ifail.
)

bnd_pso_dummy_monmod = utils._EngineState._get_symbol('e05sxm')
bnd_pso_dummy_monmod.restype = None
bnd_pso_dummy_monmod.argtypes = (
    utils._BYREF_INT, # Input, ndim.
    utils._BYREF_INT, # Input, npar.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[ndim, npar].
    utils._EngineFloat64ArrayType.c_type, # Input, xb[ndim].
    utils._BYREF_FLOAT64, # Input, fb.
    utils._EngineFloat64ArrayType.c_type, # Input, xbest[ndim, npar].
    utils._EngineFloat64ArrayType.c_type, # Input, fbest[npar].
    utils._EngineIntArrayType.c_type, # Input, itt[6].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, inform.
)

nlp_pso_dummy_monmod = utils._EngineState._get_symbol('e05sym')
nlp_pso_dummy_monmod.restype = None
nlp_pso_dummy_monmod.argtypes = (
    utils._BYREF_INT, # Input, ndim.
    utils._BYREF_INT, # Input, ncon.
    utils._BYREF_INT, # Input, npar.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[ndim, npar].
    utils._EngineFloat64ArrayType.c_type, # Input, xb[ndim].
    utils._BYREF_FLOAT64, # Input, fb.
    utils._EngineFloat64ArrayType.c_type, # Input, cb[ncon].
    utils._EngineFloat64ArrayType.c_type, # Input, xbest[ndim, npar].
    utils._EngineFloat64ArrayType.c_type, # Input, fbest[npar].
    utils._EngineFloat64ArrayType.c_type, # Input, cbest[ncon, npar].
    utils._EngineIntArrayType.c_type, # Input, itt[7].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, inform.
)

nlp_pso_dummy_confun = utils._EngineState._get_symbol('e05szm')
nlp_pso_dummy_confun.restype = None
nlp_pso_dummy_confun.argtypes = (
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, ncon.
    utils._BYREF_INT, # Input, ndim.
    utils._BYREF_INT, # Input, ldcj.
    utils._EngineIntArrayType.c_type, # Input, needc[ncon].
    utils._EngineFloat64ArrayType.c_type, # Input, x[ndim].
    utils._EngineFloat64ArrayType.c_type, # Output, c[ncon].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjac[ldcj, ndim].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)

nlp_multistart_sqp_confun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ldcjsl.
    utils._EngineIntArrayType.c_type, # Input, needc[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, c[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjsl[ldcjsl, n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
nlp_multistart_sqp_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, objgrd[n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
nlp_multistart_sqp_start = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, npts.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, quas[n, npts].
    utils._BYREF_INT, # Input, n.
    utils._BYREF_LOGICAL, # Input, repeat.
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, mode.
)
nlp_multistart_sqp = utils._EngineState._get_symbol('e05ucf')
nlp_multistart_sqp.restype = None
nlp_multistart_sqp.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nclin.
    utils._BYREF_INT, # Input, ncnln.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n+nclin+ncnln].
    nlp_multistart_sqp_confun,
    nlp_multistart_sqp_objfun,
    utils._BYREF_INT, # Input, npts.
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, nb].
    utils._BYREF_INT, # Input, ldx.
    nlp_multistart_sqp_start,
    utils._BYREF_LOGICAL, # Input, repeat.
    utils._BYREF_INT, # Input, nb.
    utils._EngineFloat64ArrayType.c_type, # Output, objf[nb].
    utils._EngineFloat64ArrayType.c_type, # Output, objgrd[ldobjd, nb].
    utils._BYREF_INT, # Input, ldobjd.
    utils._EngineIntArrayType.c_type, # Output, iter[nb].
    utils._EngineFloat64ArrayType.c_type, # Output, c[ldc, nb].
    utils._BYREF_INT, # Input, ldc.
    utils._EngineFloat64ArrayType.c_type, # Output, cjac[ldcjac, sdcjac, nb].
    utils._BYREF_INT, # Input, ldcjac.
    utils._BYREF_INT, # Input, sdcjac.
    utils._EngineFloat64ArrayType.c_type, # Output, r[ldr, sdr, nb].
    utils._BYREF_INT, # Input, ldr.
    utils._BYREF_INT, # Input, sdr.
    utils._EngineFloat64ArrayType.c_type, # Output, clamda[ldclda, nb].
    utils._BYREF_INT, # Input, ldclda.
    utils._EngineIntArrayType.c_type, # Output, istate[listat, nb].
    utils._BYREF_INT, # Input, listat.
    utils._EngineIntArrayType.c_type, # Input/Output, iopts[740].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, opts[485].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineIntArrayType.c_type, # Output, info[nb].
    utils._BYREF_INT, # Input/Output, ifail.
)

multistart_start_points = utils._EngineState._get_symbol('e05ucz')
multistart_start_points.restype = None
multistart_start_points.argtypes = (
    utils._BYREF_INT, # Input, npts.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, quas[n, npts].
    utils._BYREF_INT, # Input, n.
    utils._BYREF_LOGICAL, # Input, repeat1.
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, mode.
)

nlp_multistart_dcf = utils._EngineState._get_symbol('e05udm')
nlp_multistart_dcf.restype = None
nlp_multistart_dcf.argtypes = (
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ldcjsl.
    utils._EngineIntArrayType.c_type, # Input, needc[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, c[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjsl[ldcjsl, *].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)

nlp_multistart_sqp_lsq_confun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ldcjsl.
    utils._EngineIntArrayType.c_type, # Input, needc[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, c[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjsl[ldcjsl, *].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
nlp_multistart_sqp_lsq_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ldfjsl.
    utils._BYREF_INT, # Input, needfi.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, f[m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fjsl[ldfjsl, *].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
nlp_multistart_sqp_lsq_start = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, npts.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, quas[n, npts].
    utils._BYREF_INT, # Input, n.
    utils._BYREF_LOGICAL, # Input, repeat1.
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, mode.
)
nlp_multistart_sqp_lsq = utils._EngineState._get_symbol('e05usf')
nlp_multistart_sqp_lsq.restype = None
nlp_multistart_sqp_lsq.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nclin.
    utils._BYREF_INT, # Input, ncnln.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, y[m].
    nlp_multistart_sqp_lsq_confun,
    nlp_multistart_sqp_lsq_objfun,
    utils._BYREF_INT, # Input, npts.
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, *].
    utils._BYREF_INT, # Input, ldx.
    nlp_multistart_sqp_lsq_start,
    utils._BYREF_LOGICAL, # Input, repeat1.
    utils._BYREF_INT, # Input, nb.
    utils._EngineFloat64ArrayType.c_type, # Output, objf[nb].
    utils._EngineFloat64ArrayType.c_type, # Output, f[m, *].
    utils._EngineFloat64ArrayType.c_type, # Output, fjac[ldfjac, sdfjac, *].
    utils._BYREF_INT, # Input, ldfjac.
    utils._BYREF_INT, # Input, sdfjac.
    utils._EngineIntArrayType.c_type, # Output, iter[nb].
    utils._EngineFloat64ArrayType.c_type, # Output, c[ldc, *].
    utils._BYREF_INT, # Input, ldc.
    utils._EngineFloat64ArrayType.c_type, # Output, cjac[ldcjac, sdcjac, *].
    utils._BYREF_INT, # Input, ldcjac.
    utils._BYREF_INT, # Input, sdcjac.
    utils._EngineFloat64ArrayType.c_type, # Output, clamda[ldclda, *].
    utils._BYREF_INT, # Input, ldclda.
    utils._EngineIntArrayType.c_type, # Output, istate[listat, *].
    utils._BYREF_INT, # Input, listat.
    utils._EngineIntArrayType.c_type, # Input/Output, iopts[740].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, opts[485].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineIntArrayType.c_type, # Output, info[nb].
    utils._BYREF_INT, # Input/Output, ifail.
)

optset = utils._EngineState._get_symbol('e05zkf')
optset.restype = None
optset.argtypes = (
    utils._BYREF_STRING, # Input, optstr(len=*).
    utils._EngineIntArrayType.c_type, # Input/Output, iopts[liopts].
    utils._BYREF_INT, # Input, liopts.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, opts[lopts].
    utils._BYREF_INT, # Input, lopts.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of optstr.
)

optget = utils._EngineState._get_symbol('e05zlf')
optget.restype = None
optget.argtypes = (
    utils._BYREF_STRING, # Input, optstr(len=*).
    utils._BYREF_INT, # Output, ivalue.
    utils._BYREF_FLOAT64, # Output, rvalue.
    utils._BYREF_STRING, # Output, cvalue(len=*).
    utils._BYREF_INT, # Output, optype.
    utils._EngineIntArrayType.c_type, # Input, iopts[*].
    utils._EngineFloat64ArrayType.c_type, # Input, opts[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of optstr.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cvalue.
)
