# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `ieee` Chapter.
"""

# NAG Copyright 2017-2020.

from ..base import utils

is_finite = utils._EngineState._get_symbol('x07aaf')
is_finite.restype = utils._EngineLogicalScalarType.c_type
is_finite.argtypes = (
    utils._BYREF_FLOAT64, # Input, x.
)

is_nan = utils._EngineState._get_symbol('x07abf')
is_nan.restype = utils._EngineLogicalScalarType.c_type
is_nan.argtypes = (
    utils._BYREF_FLOAT64, # Input, x.
)

create_infinity = utils._EngineState._get_symbol('x07baf')
create_infinity.restype = None
create_infinity.argtypes = (
    utils._BYREF_INT, # Input, isign.
    utils._BYREF_FLOAT64, # Output, x.
)

create_nan = utils._EngineState._get_symbol('x07bbf')
create_nan.restype = None
create_nan.argtypes = (
    utils._BYREF_INT, # Input, quiet.
    utils._BYREF_FLOAT64, # Output, x.
)

get_exception_mode = utils._EngineState._get_symbol('x07caf')
get_exception_mode.restype = None
get_exception_mode.argtypes = (
    utils._EngineIntArrayType.c_type, # Output, exceptionmode[3].
)

set_exception_mode = utils._EngineState._get_symbol('x07cbf')
set_exception_mode.restype = None
set_exception_mode.argtypes = (
    utils._EngineIntArrayType.c_type, # Input, exceptionmode[3].
)
