# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `linsys` Chapter.
"""

# NAG Copyright 2017-2020.

from ..base import utils

withdraw_real_posdef_solve_ref = utils._EngineState._get_symbol('f04abf')
withdraw_real_posdef_solve_ref.restype = None
withdraw_real_posdef_solve_ref.argtypes = (
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Output, c[ldc, m].
    utils._BYREF_INT, # Input, ldc.
    utils._EngineFloat64ArrayType.c_type, # Workspace, wkspce[n].
    utils._EngineFloat64ArrayType.c_type, # Output, bb[ldbb, m].
    utils._BYREF_INT, # Input, ldbb.
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_real_square_solve_ref = utils._EngineState._get_symbol('f04aef')
withdraw_real_square_solve_ref.restype = None
withdraw_real_square_solve_ref.argtypes = (
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Output, c[ldc, *].
    utils._BYREF_INT, # Input, ldc.
    utils._EngineFloat64ArrayType.c_type, # Workspace, wkspce[max(1, n)].
    utils._EngineFloat64ArrayType.c_type, # Output, aa[ldaa, *].
    utils._BYREF_INT, # Input, ldaa.
    utils._EngineFloat64ArrayType.c_type, # Output, bb[ldbb, *].
    utils._BYREF_INT, # Input, ldbb.
    utils._BYREF_INT, # Input/Output, ifail.
)

real_gen_lsqsol = utils._EngineState._get_symbol('f04amf')
real_gen_lsqsol.restype = None
real_gen_lsqsol.argtypes = (
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, n].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, ir].
    utils._BYREF_INT, # Input, ldx.
    utils._EngineFloat64ArrayType.c_type, # Input, b[ldb, ir].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ir.
    utils._BYREF_FLOAT64, # Input, eps.
    utils._EngineFloat64ArrayType.c_type, # Output, qr[ldqr, n].
    utils._BYREF_INT, # Input, ldqr.
    utils._EngineFloat64ArrayType.c_type, # Output, alpha[n].
    utils._EngineFloat64ArrayType.c_type, # Workspace, e[n].
    utils._EngineFloat64ArrayType.c_type, # Workspace, y[n].
    utils._EngineFloat64ArrayType.c_type, # Workspace, z[n].
    utils._EngineFloat64ArrayType.c_type, # Workspace, r[m].
    utils._EngineIntArrayType.c_type, # Output, ipiv[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_real_posdef_solve_1rhs = utils._EngineState._get_symbol('f04asf')
withdraw_real_posdef_solve_1rhs.restype = None
withdraw_real_posdef_solve_1rhs.argtypes = (
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input, b[max(1, n)].
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, c[max(1, n)].
    utils._EngineFloat64ArrayType.c_type, # Workspace, wk1[max(1, n)].
    utils._EngineFloat64ArrayType.c_type, # Workspace, wk2[max(1, n)].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_real_square_solve_1rhs = utils._EngineState._get_symbol('f04atf')
withdraw_real_square_solve_1rhs.restype = None
withdraw_real_square_solve_1rhs.argtypes = (
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input, b[*].
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, c[n].
    utils._EngineFloat64ArrayType.c_type, # Output, aa[ldaa, n].
    utils._BYREF_INT, # Input, ldaa.
    utils._EngineFloat64ArrayType.c_type, # Workspace, wks1[n].
    utils._EngineFloat64ArrayType.c_type, # Workspace, wks2[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

real_sparse_fac_solve = utils._EngineState._get_symbol('f04axf')
real_sparse_fac_solve.restype = None
real_sparse_fac_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, a[licn].
    utils._BYREF_INT, # Input, licn.
    utils._EngineIntArrayType.c_type, # Input, icn[licn].
    utils._EngineIntArrayType.c_type, # Input/Output, ikeep[5*n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rhs[n].
    utils._EngineFloat64ArrayType.c_type, # Workspace, w[n].
    utils._BYREF_INT, # Input, mtype.
    utils._EngineIntArrayType.c_type, # Input, idisp[2].
    utils._BYREF_FLOAT64, # Output, resid.
)

real_square_solve = utils._EngineState._get_symbol('f04baf')
real_square_solve.restype = None
real_square_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineIntArrayType.c_type, # Output, ipiv[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
)

real_band_solve = utils._EngineState._get_symbol('f04bbf')
real_band_solve.restype = None
real_band_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, kl.
    utils._BYREF_INT, # Input, ku.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ab[ldab, *].
    utils._BYREF_INT, # Input, ldab.
    utils._EngineIntArrayType.c_type, # Output, ipiv[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
)

real_tridiag_solve = utils._EngineState._get_symbol('f04bcf')
real_tridiag_solve.restype = None
real_tridiag_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, dl[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, d[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, du[*].
    utils._EngineFloat64ArrayType.c_type, # Output, du2[n-2].
    utils._EngineIntArrayType.c_type, # Output, ipiv[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
)

real_posdef_solve = utils._EngineState._get_symbol('f04bdf')
real_posdef_solve.restype = None
real_posdef_solve.argtypes = (
    utils._BYREF_STRING, # Input, uplo(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of uplo.
)

real_posdef_packed_solve = utils._EngineState._get_symbol('f04bef')
real_posdef_packed_solve.restype = None
real_posdef_packed_solve.argtypes = (
    utils._BYREF_STRING, # Input, uplo(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ap[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of uplo.
)

real_posdef_band_solve = utils._EngineState._get_symbol('f04bff')
real_posdef_band_solve.restype = None
real_posdef_band_solve.argtypes = (
    utils._BYREF_STRING, # Input, uplo(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, kd.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ab[ldab, *].
    utils._BYREF_INT, # Input, ldab.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of uplo.
)

real_posdef_tridiag_solve = utils._EngineState._get_symbol('f04bgf')
real_posdef_tridiag_solve.restype = None
real_posdef_tridiag_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, d[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, e[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
)

real_symm_solve = utils._EngineState._get_symbol('f04bhf')
real_symm_solve.restype = None
real_symm_solve.argtypes = (
    utils._BYREF_STRING, # Input, uplo(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineIntArrayType.c_type, # Output, ipiv[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of uplo.
)

real_symm_packed_solve = utils._EngineState._get_symbol('f04bjf')
real_symm_packed_solve.restype = None
real_symm_packed_solve.argtypes = (
    utils._BYREF_STRING, # Input, uplo(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ap[*].
    utils._EngineIntArrayType.c_type, # Output, ipiv[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of uplo.
)

complex_square_solve = utils._EngineState._get_symbol('f04caf')
complex_square_solve.restype = None
complex_square_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineIntArrayType.c_type, # Output, ipiv[n].
    utils._EngineComplex128ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
)

complex_band_solve = utils._EngineState._get_symbol('f04cbf')
complex_band_solve.restype = None
complex_band_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, kl.
    utils._BYREF_INT, # Input, ku.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, ab[ldab, *].
    utils._BYREF_INT, # Input, ldab.
    utils._EngineIntArrayType.c_type, # Output, ipiv[n].
    utils._EngineComplex128ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
)

complex_tridiag_solve = utils._EngineState._get_symbol('f04ccf')
complex_tridiag_solve.restype = None
complex_tridiag_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, dl[*].
    utils._EngineComplex128ArrayType.c_type, # Input/Output, d[*].
    utils._EngineComplex128ArrayType.c_type, # Input/Output, du[*].
    utils._EngineComplex128ArrayType.c_type, # Output, du2[n-2].
    utils._EngineIntArrayType.c_type, # Output, ipiv[n].
    utils._EngineComplex128ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
)

complex_posdef_solve = utils._EngineState._get_symbol('f04cdf')
complex_posdef_solve.restype = None
complex_posdef_solve.argtypes = (
    utils._BYREF_STRING, # Input, uplo(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of uplo.
)

complex_posdef_packed_solve = utils._EngineState._get_symbol('f04cef')
complex_posdef_packed_solve.restype = None
complex_posdef_packed_solve.argtypes = (
    utils._BYREF_STRING, # Input, uplo(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, ap[*].
    utils._EngineComplex128ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of uplo.
)

complex_posdef_band_solve = utils._EngineState._get_symbol('f04cff')
complex_posdef_band_solve.restype = None
complex_posdef_band_solve.argtypes = (
    utils._BYREF_STRING, # Input, uplo(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, kd.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, ab[ldab, *].
    utils._BYREF_INT, # Input, ldab.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of uplo.
)

complex_posdef_tridiag_solve = utils._EngineState._get_symbol('f04cgf')
complex_posdef_tridiag_solve.restype = None
complex_posdef_tridiag_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, d[*].
    utils._EngineComplex128ArrayType.c_type, # Input/Output, e[*].
    utils._EngineComplex128ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
)

complex_herm_solve = utils._EngineState._get_symbol('f04chf')
complex_herm_solve.restype = None
complex_herm_solve.argtypes = (
    utils._BYREF_STRING, # Input, uplo(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineIntArrayType.c_type, # Output, ipiv[n].
    utils._EngineComplex128ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of uplo.
)

complex_herm_packed_solve = utils._EngineState._get_symbol('f04cjf')
complex_herm_packed_solve.restype = None
complex_herm_packed_solve.argtypes = (
    utils._BYREF_STRING, # Input, uplo(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, ap[*].
    utils._EngineIntArrayType.c_type, # Output, ipiv[n].
    utils._EngineComplex128ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of uplo.
)

complex_symm_solve = utils._EngineState._get_symbol('f04dhf')
complex_symm_solve.restype = None
complex_symm_solve.argtypes = (
    utils._BYREF_STRING, # Input, uplo(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineIntArrayType.c_type, # Output, ipiv[n].
    utils._EngineComplex128ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of uplo.
)

complex_symm_packed_solve = utils._EngineState._get_symbol('f04djf')
complex_symm_packed_solve.restype = None
complex_symm_packed_solve.argtypes = (
    utils._BYREF_STRING, # Input, uplo(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nrhs.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, ap[*].
    utils._EngineIntArrayType.c_type, # Output, ipiv[n].
    utils._EngineComplex128ArrayType.c_type, # Input/Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_FLOAT64, # Output, rcond.
    utils._BYREF_FLOAT64, # Output, errbnd.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of uplo.
)

real_toeplitz_yule = utils._EngineState._get_symbol('f04fef')
real_toeplitz_yule.restype = None
real_toeplitz_yule.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, t[n+1].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_LOGICAL, # Input, wantp.
    utils._EngineFloat64ArrayType.c_type, # Output, p[*].
    utils._BYREF_LOGICAL, # Input, wantv.
    utils._EngineFloat64ArrayType.c_type, # Output, v[*].
    utils._BYREF_FLOAT64, # Output, vlast.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[n-1].
    utils._BYREF_INT, # Input/Output, ifail.
)

real_toeplitz_solve = utils._EngineState._get_symbol('f04fff')
real_toeplitz_solve.restype = None
real_toeplitz_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, t[0:*].
    utils._EngineFloat64ArrayType.c_type, # Input, b[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_LOGICAL, # Input, wantp.
    utils._EngineFloat64ArrayType.c_type, # Output, p[*].
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[2*(n-1)].
    utils._BYREF_INT, # Input/Output, ifail.
)

real_gen_solve = utils._EngineState._get_symbol('f04jgf')
real_gen_solve.restype = None
real_gen_solve.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[lda, n].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, b[m].
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_LOGICAL, # Output, svd.
    utils._BYREF_FLOAT64, # Output, sigma.
    utils._BYREF_INT, # Output, irank.
    utils._EngineFloat64ArrayType.c_type, # Output, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

real_tridiag_fac_solve = utils._EngineState._get_symbol('f04lef')
real_tridiag_fac_solve.restype = None
real_tridiag_fac_solve.argtypes = (
    utils._BYREF_INT, # Input, job.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, a[n].
    utils._EngineFloat64ArrayType.c_type, # Input, b[n].
    utils._EngineFloat64ArrayType.c_type, # Input, c[n].
    utils._EngineFloat64ArrayType.c_type, # Input, d[n].
    utils._EngineIntArrayType.c_type, # Input, ipiv[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[n].
    utils._BYREF_FLOAT64, # Input/Output, tol.
    utils._BYREF_INT, # Input/Output, ifail.
)

real_blkdiag_fac_solve = utils._EngineState._get_symbol('f04lhf')
real_blkdiag_fac_solve.restype = None
real_blkdiag_fac_solve.argtypes = (
    utils._BYREF_STRING, # Input, trans(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nbloks.
    utils._EngineIntArrayType.c_type, # Input, blkstr[3, nbloks].
    utils._EngineFloat64ArrayType.c_type, # Input, a[lena].
    utils._BYREF_INT, # Input, lena.
    utils._EngineIntArrayType.c_type, # Input, pivot[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, b[ldb, ir].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_INT, # Input, ir.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of trans.
)

real_posdef_vband_solve = utils._EngineState._get_symbol('f04mcf')
real_posdef_vband_solve.restype = None
real_posdef_vband_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, al[lal].
    utils._BYREF_INT, # Input, lal.
    utils._EngineFloat64ArrayType.c_type, # Input, d[*].
    utils._EngineIntArrayType.c_type, # Input, nrow[n].
    utils._BYREF_INT, # Input, ir.
    utils._EngineFloat64ArrayType.c_type, # Input, b[ldb, ir].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_INT, # Input, iselct.
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, ir].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input/Output, ifail.
)

real_toeplitz_yule_update = utils._EngineState._get_symbol('f04mef')
real_toeplitz_yule_update.restype = None
real_toeplitz_yule_update.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, t[n+1].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[*].
    utils._BYREF_FLOAT64, # Input/Output, v.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[n-1].
    utils._BYREF_INT, # Input/Output, ifail.
)

real_toeplitz_update = utils._EngineState._get_symbol('f04mff')
real_toeplitz_update.restype = None
real_toeplitz_update.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, t[0:*].
    utils._EngineFloat64ArrayType.c_type, # Input, b[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[*].
    utils._BYREF_FLOAT64, # Output, p.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, work[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

real_gen_sparse_lsqsol_aprod = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input, lruser.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._BYREF_INT, # Input, liuser.
)
real_gen_sparse_lsqsol = utils._EngineState._get_symbol('f04qaf')
real_gen_sparse_lsqsol.restype = None
real_gen_sparse_lsqsol.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, b[m].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, se[n].
    real_gen_sparse_lsqsol_aprod,
    utils._BYREF_FLOAT64, # Input, damp.
    utils._BYREF_FLOAT64, # Input, atol.
    utils._BYREF_FLOAT64, # Input, btol.
    utils._BYREF_FLOAT64, # Input, conlim.
    utils._BYREF_INT, # Input/Output, itnlim.
    utils._BYREF_INT, # Input, msglvl.
    utils._BYREF_INT, # Output, itn.
    utils._BYREF_FLOAT64, # Output, anorm.
    utils._BYREF_FLOAT64, # Output, acond.
    utils._BYREF_FLOAT64, # Output, rnorm.
    utils._BYREF_FLOAT64, # Output, arnorm.
    utils._BYREF_FLOAT64, # Output, xnorm.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[n, 2].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input, lruser.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._BYREF_INT, # Input, liuser.
    utils._BYREF_INT, # Output, inform.
    utils._BYREF_INT, # Input/Output, ifail.
)

real_gen_lsq_covmat = utils._EngineState._get_symbol('f04yaf')
real_gen_lsq_covmat.restype = None
real_gen_lsq_covmat.argtypes = (
    utils._BYREF_INT, # Input, job.
    utils._BYREF_INT, # Input, p.
    utils._BYREF_FLOAT64, # Input, sigma.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[lda, p].
    utils._BYREF_INT, # Input, lda.
    utils._BYREF_LOGICAL, # Input, svd.
    utils._BYREF_INT, # Input, irank.
    utils._EngineFloat64ArrayType.c_type, # Input, sv[p].
    utils._EngineFloat64ArrayType.c_type, # Output, cj[p].
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[p].
    utils._BYREF_INT, # Input/Output, ifail.
)

real_gen_norm_rcomm = utils._EngineState._get_symbol('f04ydf')
real_gen_norm_rcomm.restype = None
real_gen_norm_rcomm.argtypes = (
    utils._BYREF_INT, # Input/Output, irevcm.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[ldx, *].
    utils._BYREF_INT, # Input, ldx.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[ldy, *].
    utils._BYREF_INT, # Input, ldy.
    utils._BYREF_FLOAT64, # Input/Output, estnrm.
    utils._BYREF_INT, # Input, t.
    utils._BYREF_INT, # Input, seed.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, work[m*t].
    utils._EngineIntArrayType.c_type, # Input/Output, iwork[2*n+5*t+20].
    utils._BYREF_INT, # Input/Output, ifail.
)

complex_gen_norm_rcomm = utils._EngineState._get_symbol('f04zdf')
complex_gen_norm_rcomm.restype = None
complex_gen_norm_rcomm.argtypes = (
    utils._BYREF_INT, # Input/Output, irevcm.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, x[ldx, *].
    utils._BYREF_INT, # Input, ldx.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, y[ldy, *].
    utils._BYREF_INT, # Input, ldy.
    utils._BYREF_FLOAT64, # Input/Output, estnrm.
    utils._BYREF_INT, # Input, t.
    utils._BYREF_INT, # Input, seed.
    utils._EngineComplex128ArrayType.c_type, # Input/Output, work[m*t].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwork[2*n].
    utils._EngineIntArrayType.c_type, # Input/Output, iwork[2*n+5*t+20].
    utils._BYREF_INT, # Input/Output, ifail.
)
