# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `machine` Chapter.
"""

# NAG Copyright 2017-2020.

from ..base import utils

sinarg_max = utils._EngineState._get_symbol('x02ahf')
sinarg_max.restype = utils._EngineFloat64ScalarType.c_type
sinarg_max.argtypes = (
    utils._BYREF_FLOAT64, # Input, x.
)

precision = utils._EngineState._get_symbol('x02ajf')
precision.restype = utils._EngineFloat64ScalarType.c_type
precision.argtypes = (
)

real_smallest = utils._EngineState._get_symbol('x02akf')
real_smallest.restype = utils._EngineFloat64ScalarType.c_type
real_smallest.argtypes = (
)

real_largest = utils._EngineState._get_symbol('x02alf')
real_largest.restype = utils._EngineFloat64ScalarType.c_type
real_largest.argtypes = (
)

real_safe = utils._EngineState._get_symbol('x02amf')
real_safe.restype = utils._EngineFloat64ScalarType.c_type
real_safe.argtypes = (
)

complex_safe = utils._EngineState._get_symbol('x02anf')
complex_safe.restype = utils._EngineFloat64ScalarType.c_type
complex_safe.argtypes = (
)

integer_max = utils._EngineState._get_symbol('x02bbf')
integer_max.restype = utils._EngineIntScalarType.c_type
integer_max.argtypes = (
    utils._BYREF_FLOAT64, # Input, x.
)

decimal_digits = utils._EngineState._get_symbol('x02bef')
decimal_digits.restype = utils._EngineIntScalarType.c_type
decimal_digits.argtypes = (
    utils._BYREF_FLOAT64, # Input, x.
)

model_base = utils._EngineState._get_symbol('x02bhf')
model_base.restype = utils._EngineIntScalarType.c_type
model_base.argtypes = (
)

model_digits = utils._EngineState._get_symbol('x02bjf')
model_digits.restype = utils._EngineIntScalarType.c_type
model_digits.argtypes = (
)

model_minexp = utils._EngineState._get_symbol('x02bkf')
model_minexp.restype = utils._EngineIntScalarType.c_type
model_minexp.argtypes = (
)

model_maxexp = utils._EngineState._get_symbol('x02blf')
model_maxexp.restype = utils._EngineIntScalarType.c_type
model_maxexp.argtypes = (
)
