# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `mip` Chapter.
"""

# NAG Copyright 2017-2020.

from ..base import utils

ilp_dense = utils._EngineState._get_symbol('h02bbf')
ilp_dense.restype = None
ilp_dense.argtypes = (
    utils._BYREF_INT, # Input/Output, itmax.
    utils._BYREF_INT, # Input, msglvl.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n+m].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n+m].
    utils._EngineIntArrayType.c_type, # Input, intvar[n].
    utils._EngineFloat64ArrayType.c_type, # Input, cvec[n].
    utils._BYREF_INT, # Input, maxnod.
    utils._BYREF_INT, # Input, intfst.
    utils._BYREF_INT, # Input, maxdpt.
    utils._BYREF_FLOAT64, # Input/Output, toliv.
    utils._BYREF_FLOAT64, # Input/Output, tolfes.
    utils._BYREF_FLOAT64, # Input/Output, bigbnd.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, objmip.
    utils._EngineIntArrayType.c_type, # Output, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._EngineFloat64ArrayType.c_type, # Output, rwork[lrwork].
    utils._BYREF_INT, # Input, lrwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

ilp_mpsx = utils._EngineState._get_symbol('h02bff')
ilp_mpsx.restype = None
ilp_mpsx.argtypes = (
    utils._BYREF_INT, # Input, infile.
    utils._BYREF_INT, # Input, maxn.
    utils._BYREF_INT, # Input, maxm.
    utils._BYREF_STRING, # Input, optim(len=3).
    utils._BYREF_FLOAT64, # Input, xbldef.
    utils._BYREF_FLOAT64, # Input, xbudef.
    utils._BYREF_INT, # Input, maxdpt.
    utils._BYREF_INT, # Input, msglvl.
    utils._BYREF_INT, # Output, n.
    utils._BYREF_INT, # Output, m.
    utils._EngineFloat64ArrayType.c_type, # Output, x[maxn].
    utils._EngineCharArrayType.c_type, # Output, crname(len=8)[maxn+maxm].
    utils._EngineIntArrayType.c_type, # Output, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._EngineFloat64ArrayType.c_type, # Output, rwork[lrwork].
    utils._BYREF_INT, # Input, lrwork.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of optim.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of crname.
)

ilp_mpsx_convert = utils._EngineState._get_symbol('h02buf')
ilp_mpsx_convert.restype = None
ilp_mpsx_convert.argtypes = (
    utils._BYREF_INT, # Input, infile.
    utils._BYREF_INT, # Input, maxn.
    utils._BYREF_INT, # Input, maxm.
    utils._BYREF_STRING, # Input, optim(len=3).
    utils._BYREF_FLOAT64, # Input, xbldef.
    utils._BYREF_FLOAT64, # Input, xbudef.
    utils._BYREF_STRING, # Input/Output, nmobj(len=8).
    utils._BYREF_STRING, # Input/Output, nmrhs(len=8).
    utils._BYREF_STRING, # Input/Output, nmrng(len=8).
    utils._BYREF_STRING, # Input/Output, nmbnd(len=8).
    utils._BYREF_LOGICAL, # Input, mpslst.
    utils._BYREF_INT, # Output, n.
    utils._BYREF_INT, # Output, m.
    utils._EngineFloat64ArrayType.c_type, # Output, a[maxm, maxn].
    utils._EngineFloat64ArrayType.c_type, # Output, bl[maxn+maxm].
    utils._EngineFloat64ArrayType.c_type, # Output, bu[maxn+maxm].
    utils._EngineFloat64ArrayType.c_type, # Output, cvec[maxn].
    utils._EngineFloat64ArrayType.c_type, # Output, x[maxn].
    utils._EngineIntArrayType.c_type, # Output, intvar[maxn].
    utils._EngineCharArrayType.c_type, # Output, crname(len=8)[maxn+maxm].
    utils._BYREF_STRING, # Output, nmprob(len=8).
    utils._EngineIntArrayType.c_type, # Workspace, iwork[maxn+maxm].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of optim.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of nmobj.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of nmrhs.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of nmrng.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of nmbnd.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of crname.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of nmprob.
)

ilp_print = utils._EngineState._get_symbol('h02bvf')
ilp_print.restype = None
ilp_print.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n+m].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n+m].
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Input, clamda[n+m].
    utils._EngineIntArrayType.c_type, # Input, istate[n+m].
    utils._EngineCharArrayType.c_type, # Input, crname(len=8)[n+m].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of crname.
)

ilp_info = utils._EngineState._get_symbol('h02bzf')
ilp_info.restype = None
ilp_info.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Output, bl[n+m].
    utils._EngineFloat64ArrayType.c_type, # Output, bu[n+m].
    utils._EngineFloat64ArrayType.c_type, # Output, clamda[n+m].
    utils._EngineIntArrayType.c_type, # Output, istate[n+m].
    utils._EngineIntArrayType.c_type, # Input, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._EngineFloat64ArrayType.c_type, # Input, rwork[lrwork].
    utils._BYREF_INT, # Input, lrwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

iqp_dense_qphess = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, jthcol.
    utils._EngineFloat64ArrayType.c_type, # Input, h[ldh, *].
    utils._BYREF_INT, # Input, ldh.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, hx[n].
)
iqp_dense_monit = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, intfnd.
    utils._BYREF_INT, # Input, nodes.
    utils._BYREF_INT, # Input, depth.
    utils._BYREF_FLOAT64, # Input, obj.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_FLOAT64, # Input/Output, bstval.
    utils._EngineFloat64ArrayType.c_type, # Input, bstsol[n].
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n].
    utils._BYREF_INT, # Input, n.
    utils._BYREF_LOGICAL, # Input/Output, halt.
    utils._BYREF_INT, # Input/Output, count.
)
iqp_dense = utils._EngineState._get_symbol('h02cbf')
iqp_dense.restype = None
iqp_dense.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nclin.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bl[n+nclin].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bu[n+nclin].
    utils._EngineFloat64ArrayType.c_type, # Input, cvec[*].
    utils._EngineFloat64ArrayType.c_type, # Input, h[ldh, *].
    utils._BYREF_INT, # Input, ldh.
    iqp_dense_qphess,
    utils._EngineIntArrayType.c_type, # Input, intvar[lintvr].
    utils._BYREF_INT, # Input, lintvr.
    utils._BYREF_INT, # Input, mdepth.
    utils._EngineIntArrayType.c_type, # Input/Output, istate[n+nclin].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, xs[n].
    utils._BYREF_FLOAT64, # Output, obj.
    utils._EngineFloat64ArrayType.c_type, # Output, ax[max(1, nclin)].
    utils._EngineFloat64ArrayType.c_type, # Output, clamda[n+nclin].
    utils._BYREF_INT, # Input, strtgy.
    utils._EngineIntArrayType.c_type, # Workspace, iwrk[liwrk].
    utils._BYREF_INT, # Input, liwrk.
    utils._EngineFloat64ArrayType.c_type, # Workspace, wrk[lwrk].
    utils._BYREF_INT, # Input, lwrk.
    iqp_dense_monit,
    utils._BYREF_INT, # Input/Output, ifail.
)

iqp_dense_dummy_monit = utils._EngineState._get_symbol('h02cbu')
iqp_dense_dummy_monit.restype = None
iqp_dense_dummy_monit.argtypes = (
    utils._BYREF_INT, # Input, intfnd.
    utils._BYREF_INT, # Input, nodes.
    utils._BYREF_INT, # Input, depth.
    utils._BYREF_FLOAT64, # Input, obj.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_FLOAT64, # Input/Output, bstval.
    utils._EngineFloat64ArrayType.c_type, # Input, bstsol[n].
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n].
    utils._BYREF_INT, # Input, n.
    utils._BYREF_LOGICAL, # Input/Output, halt.
    utils._BYREF_INT, # Input/Output, count.
)

iqp_dense_optfile = utils._EngineState._get_symbol('h02ccf')
iqp_dense_optfile.restype = None
iqp_dense_optfile.argtypes = (
    utils._BYREF_INT, # Input, ioptns.
    utils._BYREF_INT, # Output, inform.
)

iqp_dense_optstr = utils._EngineState._get_symbol('h02cdf')
iqp_dense_optstr.restype = None
iqp_dense_optstr.argtypes = (
    utils._BYREF_STRING, # Input, str(len=*).
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of str.
)

iqp_sparse_qphx = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, nstate.
    utils._BYREF_INT, # Input, ncolh.
    utils._EngineFloat64ArrayType.c_type, # Input, x[ncolh].
    utils._EngineFloat64ArrayType.c_type, # Output, hx[ncolh].
)
iqp_sparse_monit = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, intfnd.
    utils._BYREF_INT, # Input, nodes.
    utils._BYREF_INT, # Input, depth.
    utils._BYREF_FLOAT64, # Input, obj.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_FLOAT64, # Input/Output, bstval.
    utils._EngineFloat64ArrayType.c_type, # Input, bstsol[n].
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n].
    utils._BYREF_INT, # Input, n.
    utils._BYREF_LOGICAL, # Input/Output, halt.
    utils._BYREF_INT, # Input/Output, count.
)
iqp_sparse = utils._EngineState._get_symbol('h02cef')
iqp_sparse.restype = None
iqp_sparse.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, nnz.
    utils._BYREF_INT, # Input, iobj.
    utils._BYREF_INT, # Input, ncolh.
    iqp_sparse_qphx,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[nnz].
    utils._EngineIntArrayType.c_type, # Input, ha[nnz].
    utils._EngineIntArrayType.c_type, # Input, ka[n+1].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bl[n+m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bu[n+m].
    utils._BYREF_STRING, # Input, start(len=1).
    utils._EngineCharArrayType.c_type, # Input, names(len=8)[5].
    utils._BYREF_INT, # Input, nname.
    utils._EngineCharArrayType.c_type, # Input, crname(len=8)[nname].
    utils._BYREF_INT, # Input/Output, ns.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, xs[n+m].
    utils._EngineIntArrayType.c_type, # Input, intvar[lintvr].
    utils._BYREF_INT, # Input, lintvr.
    utils._BYREF_INT, # Input, mdepth.
    utils._EngineIntArrayType.c_type, # Input/Output, istate[n+m].
    utils._BYREF_INT, # Output, miniz.
    utils._BYREF_INT, # Output, minz.
    utils._BYREF_FLOAT64, # Output, obj.
    utils._EngineFloat64ArrayType.c_type, # Output, clamda[n+m].
    utils._BYREF_INT, # Input, strtgy.
    utils._EngineIntArrayType.c_type, # Workspace, iz[leniz].
    utils._BYREF_INT, # Input, leniz.
    utils._EngineFloat64ArrayType.c_type, # Workspace, z[lenz].
    utils._BYREF_INT, # Input, lenz.
    iqp_sparse_monit,
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of start.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of names.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of crname.
)

iqp_sparse_dummy_monit = utils._EngineState._get_symbol('h02cey')
iqp_sparse_dummy_monit.restype = None
iqp_sparse_dummy_monit.argtypes = (
    utils._BYREF_INT, # Input, intfnd.
    utils._BYREF_INT, # Input, nodes.
    utils._BYREF_INT, # Input, depth.
    utils._BYREF_FLOAT64, # Input, obj.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_FLOAT64, # Input/Output, bstval.
    utils._EngineFloat64ArrayType.c_type, # Input, bstsol[n].
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n].
    utils._BYREF_INT, # Input, n.
    utils._BYREF_LOGICAL, # Input/Output, halt.
    utils._BYREF_INT, # Input/Output, count.
)

iqp_sparse_optfile = utils._EngineState._get_symbol('h02cff')
iqp_sparse_optfile.restype = None
iqp_sparse_optfile.argtypes = (
    utils._BYREF_INT, # Input, ioptns.
    utils._BYREF_INT, # Output, inform.
)

iqp_sparse_optstr = utils._EngineState._get_symbol('h02cgf')
iqp_sparse_optstr.restype = None
iqp_sparse_optstr.argtypes = (
    utils._BYREF_STRING, # Input, str(len=*).
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of str.
)

sqp_confun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Input, varcon[*].
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, c[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjac[ncnln, n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
sqp_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Input, varcon[*].
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_FLOAT64, # Output, objmip.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, objgrd[n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
sqp = utils._EngineState._get_symbol('h02daf')
sqp.restype = None
sqp.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nclin.
    utils._BYREF_INT, # Input, ncnln.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input, d[nclin].
    utils._EngineFloat64ArrayType.c_type, # Output, ax[nclin].
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n].
    utils._EngineIntArrayType.c_type, # Input, varcon[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    sqp_confun,
    utils._EngineFloat64ArrayType.c_type, # Output, c[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Output, cjac[ncnln, n].
    sqp_objfun,
    utils._EngineFloat64ArrayType.c_type, # Output, objgrd[n].
    utils._BYREF_INT, # Input, maxit.
    utils._BYREF_FLOAT64, # Input, acc.
    utils._BYREF_FLOAT64, # Output, objmip.
    utils._EngineIntArrayType.c_type, # Input, iopts[*].
    utils._EngineFloat64ArrayType.c_type, # Input, opts[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

sqp_dummy_confun = utils._EngineState._get_symbol('h02ddm')
sqp_dummy_confun.restype = None
sqp_dummy_confun.argtypes = (
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Input, varcon[*].
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, c[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjac[ncnln, n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)

optset = utils._EngineState._get_symbol('h02zkf')
optset.restype = None
optset.argtypes = (
    utils._BYREF_STRING, # Input, optstr(len=*).
    utils._EngineIntArrayType.c_type, # Input/Output, iopts[liopts].
    utils._BYREF_INT, # Input, liopts.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, opts[lopts].
    utils._BYREF_INT, # Input, lopts.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of optstr.
)

optget = utils._EngineState._get_symbol('h02zlf')
optget.restype = None
optget.argtypes = (
    utils._BYREF_STRING, # Input, optstr(len=*).
    utils._BYREF_INT, # Output, ivalue.
    utils._BYREF_FLOAT64, # Output, rvalue.
    utils._BYREF_STRING, # Output, cvalue(len=*).
    utils._BYREF_INT, # Output, optype.
    utils._EngineIntArrayType.c_type, # Input, iopts[*].
    utils._EngineFloat64ArrayType.c_type, # Input, opts[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of optstr.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cvalue.
)

transportation = utils._EngineState._get_symbol('h03abf')
transportation.restype = None
transportation.argtypes = (
    utils._EngineIntArrayType.c_type, # Input, kost[ldkost, mb].
    utils._BYREF_INT, # Input, ldkost.
    utils._BYREF_INT, # Input, ma.
    utils._BYREF_INT, # Input, mb.
    utils._BYREF_INT, # Input, m.
    utils._EngineIntArrayType.c_type, # Input/Output, k15[m].
    utils._BYREF_INT, # Input, maxit.
    utils._EngineIntArrayType.c_type, # Workspace, k7[m].
    utils._EngineIntArrayType.c_type, # Workspace, k9[m].
    utils._BYREF_INT, # Output, numit.
    utils._EngineIntArrayType.c_type, # Output, k6[m].
    utils._EngineIntArrayType.c_type, # Output, k8[m].
    utils._EngineIntArrayType.c_type, # Output, k11[m].
    utils._EngineIntArrayType.c_type, # Output, k12[m].
    utils._BYREF_FLOAT64, # Output, z.
    utils._BYREF_INT, # Input/Output, ifail.
)

shortestpath = utils._EngineState._get_symbol('h03adf')
shortestpath.restype = None
shortestpath.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ns.
    utils._BYREF_INT, # Input, ne.
    utils._BYREF_LOGICAL, # Input, direct.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineFloat64ArrayType.c_type, # Input, d[nnz].
    utils._EngineIntArrayType.c_type, # Input/Output, irow[nnz].
    utils._EngineIntArrayType.c_type, # Input, icol[nnz].
    utils._BYREF_FLOAT64, # Output, splen.
    utils._EngineIntArrayType.c_type, # Output, path[n].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[3*n+1].
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[2*n].
    utils._BYREF_INT, # Input/Output, ifail.
)

tsp_simann = utils._EngineState._get_symbol('h03bbf')
tsp_simann.restype = None
tsp_simann.argtypes = (
    utils._BYREF_INT, # Input, nc.
    utils._EngineFloat64ArrayType.c_type, # Input, dm[nc, nc].
    utils._BYREF_FLOAT64, # Input, bound.
    utils._BYREF_FLOAT64, # Input, targc.
    utils._EngineIntArrayType.c_type, # Output, path[nc].
    utils._BYREF_FLOAT64, # Output, cost.
    utils._BYREF_INT, # Output, tmode.
    utils._EngineFloat64ArrayType.c_type, # Output, alg_stats[6].
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

best_subset_given_size_revcomm = utils._EngineState._get_symbol('h05aaf')
best_subset_given_size_revcomm.restype = None
best_subset_given_size_revcomm.argtypes = (
    utils._BYREF_INT, # Input/Output, irevcm.
    utils._BYREF_INT, # Input, mincr.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, ip.
    utils._BYREF_INT, # Input, nbest.
    utils._BYREF_INT, # Input/Output, drop.
    utils._BYREF_INT, # Input/Output, lz.
    utils._EngineIntArrayType.c_type, # Input/Output, z[m-ip].
    utils._BYREF_INT, # Input/Output, la.
    utils._EngineIntArrayType.c_type, # Input/Output, a[max(nbest, m)].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bscore[max(nbest, m)].
    utils._EngineIntArrayType.c_type, # Input/Output, bz[m-ip, nbest].
    utils._BYREF_INT, # Input, mincnt.
    utils._BYREF_FLOAT64, # Input, gamma.
    utils._EngineFloat64ArrayType.c_type, # Input, acc[2].
    utils._EngineIntArrayType.c_type, # Input/Output, icomm[licomm].
    utils._BYREF_INT, # Input, licomm.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rcomm[lrcomm].
    utils._BYREF_INT, # Input, lrcomm.
    utils._BYREF_INT, # Input/Output, ifail.
)

best_subset_given_size_f = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, drop.
    utils._BYREF_INT, # Input, lz.
    utils._EngineIntArrayType.c_type, # Input, z[lz].
    utils._BYREF_INT, # Input, la.
    utils._EngineIntArrayType.c_type, # Input, a[la].
    utils._EngineFloat64ArrayType.c_type, # Output, score[max(la, 1)].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, info.
)
best_subset_given_size = utils._EngineState._get_symbol('h05abf')
best_subset_given_size.restype = None
best_subset_given_size.argtypes = (
    utils._BYREF_INT, # Input, mincr.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, ip.
    utils._BYREF_INT, # Input, nbest.
    utils._BYREF_INT, # Output, la.
    utils._EngineFloat64ArrayType.c_type, # Output, bscore[nbest].
    utils._EngineIntArrayType.c_type, # Output, bz[m-ip, nbest].
    best_subset_given_size_f,
    utils._BYREF_INT, # Input, mincnt.
    utils._BYREF_FLOAT64, # Input, gamma.
    utils._EngineFloat64ArrayType.c_type, # Input, acc[2].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)
