# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `omp` Chapter.
"""

# NAG Copyright 2017-2020.

from ..base import utils

set_num_threads = utils._EngineState._get_symbol('x06aaf')
set_num_threads.restype = None
set_num_threads.argtypes = (
    utils._BYREF_INT, # Input, num.
    utils._BYREF_INT, # Input/Output, ifail.
)

get_num_threads = utils._EngineState._get_symbol('x06abf')
get_num_threads.restype = utils._EngineIntScalarType.c_type
get_num_threads.argtypes = (
)

get_max_threads = utils._EngineState._get_symbol('x06acf')
get_max_threads.restype = utils._EngineIntScalarType.c_type
get_max_threads.argtypes = (
)

get_thread_num = utils._EngineState._get_symbol('x06adf')
get_thread_num.restype = utils._EngineIntScalarType.c_type
get_thread_num.argtypes = (
)

in_parallel = utils._EngineState._get_symbol('x06aff')
in_parallel.restype = utils._EngineIntScalarType.c_type
in_parallel.argtypes = (
)

set_nested = utils._EngineState._get_symbol('x06agf')
set_nested.restype = None
set_nested.argtypes = (
    utils._BYREF_INT, # Input, nesting.
)

get_nested = utils._EngineState._get_symbol('x06ahf')
get_nested.restype = utils._EngineIntScalarType.c_type
get_nested.argtypes = (
)

using_threaded_impl = utils._EngineState._get_symbol('x06xaf')
using_threaded_impl.restype = utils._EngineIntScalarType.c_type
using_threaded_impl.argtypes = (
)
