# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `orthog` Chapter.
"""

# NAG Copyright 2017-2020.

from ..base import utils

real_gram_schmidt = utils._EngineState._get_symbol('f05aaf')
real_gram_schmidt.restype = None
real_gram_schmidt.argtypes = (
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[lda, n2].
    utils._BYREF_INT, # Input, lda.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n1.
    utils._BYREF_INT, # Input, n2.
    utils._EngineFloat64ArrayType.c_type, # Workspace, s[n2].
    utils._BYREF_FLOAT64, # Output, cc.
    utils._BYREF_INT, # Output, icol.
    utils._BYREF_INT, # Input/Output, ifail.
)
