# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `rand` Chapter.
"""

# NAG Copyright 2017-2020.

from ..base import utils

withdraw_dist_uniform01 = utils._EngineState._get_symbol('g05kaf')
withdraw_dist_uniform01.restype = utils._EngineFloat64ScalarType.c_type
withdraw_dist_uniform01.argtypes = (
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
)

withdraw_init_repeat = utils._EngineState._get_symbol('g05kbf')
withdraw_init_repeat.restype = None
withdraw_init_repeat.argtypes = (
    utils._BYREF_INT, # Input/Output, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
)

withdraw_init_nonrepeat = utils._EngineState._get_symbol('g05kcf')
withdraw_init_nonrepeat.restype = None
withdraw_init_nonrepeat.argtypes = (
    utils._BYREF_INT, # Input/Output, igen.
    utils._EngineIntArrayType.c_type, # Output, iseed[4].
)

withdraw_logical = utils._EngineState._get_symbol('g05kef')
withdraw_logical.restype = utils._EngineLogicalScalarType.c_type
withdraw_logical.argtypes = (
    utils._BYREF_FLOAT64, # Input, p.
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

init_repeat = utils._EngineState._get_symbol('g05kff')
init_repeat.restype = None
init_repeat.argtypes = (
    utils._BYREF_INT, # Input, genid.
    utils._BYREF_INT, # Input, subid.
    utils._EngineIntArrayType.c_type, # Input, seed[lseed].
    utils._BYREF_INT, # Input, lseed.
    utils._EngineIntArrayType.c_type, # Output, state[lstate].
    utils._BYREF_INT, # Input/Output, lstate.
    utils._BYREF_INT, # Input/Output, ifail.
)

init_nonrepeat = utils._EngineState._get_symbol('g05kgf')
init_nonrepeat.restype = None
init_nonrepeat.argtypes = (
    utils._BYREF_INT, # Input, genid.
    utils._BYREF_INT, # Input, subid.
    utils._EngineIntArrayType.c_type, # Output, state[lstate].
    utils._BYREF_INT, # Input/Output, lstate.
    utils._BYREF_INT, # Input/Output, ifail.
)

init_leapfrog = utils._EngineState._get_symbol('g05khf')
init_leapfrog.restype = None
init_leapfrog.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, k.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

init_skipahead = utils._EngineState._get_symbol('g05kjf')
init_skipahead.restype = None
init_skipahead.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

init_skipahead_power2 = utils._EngineState._get_symbol('g05kkf')
init_skipahead_power2.restype = None
init_skipahead_power2.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_dist_normal = utils._EngineState._get_symbol('g05laf')
withdraw_dist_normal.restype = None
withdraw_dist_normal.argtypes = (
    utils._BYREF_FLOAT64, # Input, xmu.
    utils._BYREF_FLOAT64, # Input, var.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_dist_students_t = utils._EngineState._get_symbol('g05lbf')
withdraw_dist_students_t.restype = None
withdraw_dist_students_t.argtypes = (
    utils._BYREF_INT, # Input, df.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_dist_chisq = utils._EngineState._get_symbol('g05lcf')
withdraw_dist_chisq.restype = None
withdraw_dist_chisq.argtypes = (
    utils._BYREF_INT, # Input, df.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_dist_f = utils._EngineState._get_symbol('g05ldf')
withdraw_dist_f.restype = None
withdraw_dist_f.argtypes = (
    utils._BYREF_INT, # Input, df1.
    utils._BYREF_INT, # Input, df2.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_dist_beta = utils._EngineState._get_symbol('g05lef')
withdraw_dist_beta.restype = None
withdraw_dist_beta.argtypes = (
    utils._BYREF_FLOAT64, # Input, a.
    utils._BYREF_FLOAT64, # Input, b.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_dist_gamma = utils._EngineState._get_symbol('g05lff')
withdraw_dist_gamma.restype = None
withdraw_dist_gamma.argtypes = (
    utils._BYREF_FLOAT64, # Input, a.
    utils._BYREF_FLOAT64, # Input, b.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_dist_uniform = utils._EngineState._get_symbol('g05lgf')
withdraw_dist_uniform.restype = None
withdraw_dist_uniform.argtypes = (
    utils._BYREF_FLOAT64, # Input, a.
    utils._BYREF_FLOAT64, # Input, b.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_dist_triangular = utils._EngineState._get_symbol('g05lhf')
withdraw_dist_triangular.restype = None
withdraw_dist_triangular.argtypes = (
    utils._BYREF_FLOAT64, # Input, xmin.
    utils._BYREF_FLOAT64, # Input, xmax.
    utils._BYREF_FLOAT64, # Input, xmed.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_dist_exp = utils._EngineState._get_symbol('g05ljf')
withdraw_dist_exp.restype = None
withdraw_dist_exp.argtypes = (
    utils._BYREF_FLOAT64, # Input, a.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_dist_lognormal = utils._EngineState._get_symbol('g05lkf')
withdraw_dist_lognormal.restype = None
withdraw_dist_lognormal.argtypes = (
    utils._BYREF_FLOAT64, # Input, xmu.
    utils._BYREF_FLOAT64, # Input, var.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_dist_cauchy = utils._EngineState._get_symbol('g05llf')
withdraw_dist_cauchy.restype = None
withdraw_dist_cauchy.argtypes = (
    utils._BYREF_FLOAT64, # Input, xmed.
    utils._BYREF_FLOAT64, # Input, semiqr.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_dist_weibull = utils._EngineState._get_symbol('g05lmf')
withdraw_dist_weibull.restype = None
withdraw_dist_weibull.argtypes = (
    utils._BYREF_FLOAT64, # Input, a.
    utils._BYREF_FLOAT64, # Input, b.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_dist_logistic = utils._EngineState._get_symbol('g05lnf')
withdraw_dist_logistic.restype = None
withdraw_dist_logistic.argtypes = (
    utils._BYREF_FLOAT64, # Input, a.
    utils._BYREF_FLOAT64, # Input, b.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_dist_vonmises = utils._EngineState._get_symbol('g05lpf')
withdraw_dist_vonmises.restype = None
withdraw_dist_vonmises.argtypes = (
    utils._BYREF_FLOAT64, # Input, vk.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_dist_expmix = utils._EngineState._get_symbol('g05lqf')
withdraw_dist_expmix.restype = None
withdraw_dist_expmix.argtypes = (
    utils._BYREF_INT, # Input, nmix.
    utils._EngineFloat64ArrayType.c_type, # Input, a[nmix].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, wgt[nmix].
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_multivar_students_t = utils._EngineState._get_symbol('g05lxf')
withdraw_multivar_students_t.restype = None
withdraw_multivar_students_t.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, df.
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, xmu[m].
    utils._EngineFloat64ArrayType.c_type, # Input, c[ldc, m].
    utils._BYREF_INT, # Input, ldc.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, m].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_multivar_normal = utils._EngineState._get_symbol('g05lyf')
withdraw_multivar_normal.restype = None
withdraw_multivar_normal.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, xmu[m].
    utils._EngineFloat64ArrayType.c_type, # Input, c[ldc, m].
    utils._BYREF_INT, # Input, ldc.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, m].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_multivar_normal_svec = utils._EngineState._get_symbol('g05lzf')
withdraw_multivar_normal_svec.restype = None
withdraw_multivar_normal_svec.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xmu[n].
    utils._EngineFloat64ArrayType.c_type, # Input, c[ldc, n].
    utils._BYREF_INT, # Input, ldc.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[nr].
    utils._BYREF_INT, # Input, nr.
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_int_uniform = utils._EngineState._get_symbol('g05maf')
withdraw_int_uniform.restype = None
withdraw_int_uniform.argtypes = (
    utils._BYREF_INT, # Input, a.
    utils._BYREF_INT, # Input, b.
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_int_geom = utils._EngineState._get_symbol('g05mbf')
withdraw_int_geom.restype = None
withdraw_int_geom.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_FLOAT64, # Input, p.
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[nr].
    utils._BYREF_INT, # Input, nr.
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_int_negbin = utils._EngineState._get_symbol('g05mcf')
withdraw_int_negbin.restype = None
withdraw_int_negbin.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, p.
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[nr].
    utils._BYREF_INT, # Input, nr.
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_int_log = utils._EngineState._get_symbol('g05mdf')
withdraw_int_log.restype = None
withdraw_int_log.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_FLOAT64, # Input, a.
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[nr].
    utils._BYREF_INT, # Input, nr.
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_int_poisson_varmean = utils._EngineState._get_symbol('g05mef')
withdraw_int_poisson_varmean.restype = None
withdraw_int_poisson_varmean.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, vlamda[m].
    utils._EngineIntArrayType.c_type, # Output, x[m].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_int_binomial = utils._EngineState._get_symbol('g05mjf')
withdraw_int_binomial.restype = None
withdraw_int_binomial.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, p.
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[nr].
    utils._BYREF_INT, # Input, nr.
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_int_poisson = utils._EngineState._get_symbol('g05mkf')
withdraw_int_poisson.restype = None
withdraw_int_poisson.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_FLOAT64, # Input, lambda.
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[nr].
    utils._BYREF_INT, # Input, nr.
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_int_hypergeom = utils._EngineState._get_symbol('g05mlf')
withdraw_int_hypergeom.restype = None
withdraw_int_hypergeom.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, ns.
    utils._BYREF_INT, # Input, np.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[nr].
    utils._BYREF_INT, # Input, nr.
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_int_multinomial = utils._EngineState._get_symbol('g05mrf')
withdraw_int_multinomial.restype = None
withdraw_int_multinomial.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, k.
    utils._EngineFloat64ArrayType.c_type, # Input, p[k].
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Output, x[ldx, k].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[nr].
    utils._BYREF_INT, # Input, nr.
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_int_general = utils._EngineState._get_symbol('g05mzf')
withdraw_int_general.restype = None
withdraw_int_general.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._EngineFloat64ArrayType.c_type, # Input, p[np].
    utils._BYREF_INT, # Input, np.
    utils._BYREF_INT, # Input, ip1.
    utils._BYREF_INT, # Input, itype.
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[nr].
    utils._BYREF_INT, # Input, nr.
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_permute = utils._EngineState._get_symbol('g05naf')
withdraw_permute.restype = None
withdraw_permute.argtypes = (
    utils._EngineIntArrayType.c_type, # Input/Output, index[n].
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_sample = utils._EngineState._get_symbol('g05nbf')
withdraw_sample.restype = None
withdraw_sample.argtypes = (
    utils._EngineIntArrayType.c_type, # Input, ipop[n].
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Output, isampl[m].
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._BYREF_INT, # Input/Output, ifail.
)

permute = utils._EngineState._get_symbol('g05ncf')
permute.restype = None
permute.argtypes = (
    utils._EngineIntArrayType.c_type, # Input/Output, indx[n].
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

sample = utils._EngineState._get_symbol('g05ndf')
sample.restype = None
sample.argtypes = (
    utils._EngineIntArrayType.c_type, # Input, ipop[n].
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Output, isampl[m].
    utils._BYREF_INT, # Input, m.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

sample_wgt = utils._EngineState._get_symbol('g05nef')
sample_wgt.restype = None
sample_wgt.argtypes = (
    utils._BYREF_STRING, # Input, order(len=1).
    utils._EngineFloat64ArrayType.c_type, # Input, wt[n].
    utils._BYREF_STRING, # Input, pop(len=1).
    utils._EngineIntArrayType.c_type, # Input, ipop[*].
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Output, isampl[m].
    utils._BYREF_INT, # Input, m.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of order.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of pop.
)

withdraw_times_arma = utils._EngineState._get_symbol('g05paf')
withdraw_times_arma.restype = None
withdraw_times_arma.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_FLOAT64, # Input, xmean.
    utils._BYREF_INT, # Input, ip.
    utils._EngineFloat64ArrayType.c_type, # Input, phi[ip].
    utils._BYREF_INT, # Input, iq.
    utils._EngineFloat64ArrayType.c_type, # Input, theta[iq].
    utils._BYREF_FLOAT64, # Input, avar.
    utils._BYREF_FLOAT64, # Output, var.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[nr].
    utils._BYREF_INT, # Input, nr.
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_times_mv_varma = utils._EngineState._get_symbol('g05pcf')
withdraw_times_mv_varma.restype = None
withdraw_times_mv_varma.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, k.
    utils._EngineFloat64ArrayType.c_type, # Input, xmean[k].
    utils._BYREF_INT, # Input, ip.
    utils._EngineFloat64ArrayType.c_type, # Input, phi[ip*k*k].
    utils._BYREF_INT, # Input, iq.
    utils._EngineFloat64ArrayType.c_type, # Input, theta[iq*k*k].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, var[ldvar, k].
    utils._BYREF_INT, # Input, ldvar.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldvar, n].
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[nr].
    utils._BYREF_INT, # Input, nr.
    utils._EngineIntArrayType.c_type, # Workspace, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

times_garch_asym1 = utils._EngineState._get_symbol('g05pdf')
times_garch_asym1.restype = None
times_garch_asym1.argtypes = (
    utils._BYREF_STRING, # Input, dist(len=1).
    utils._BYREF_INT, # Input, num.
    utils._BYREF_INT, # Input, ip.
    utils._BYREF_INT, # Input, iq.
    utils._EngineFloat64ArrayType.c_type, # Input, theta[iq+ip+1].
    utils._BYREF_FLOAT64, # Input, gamma.
    utils._BYREF_INT, # Input, df.
    utils._EngineFloat64ArrayType.c_type, # Output, ht[num].
    utils._EngineFloat64ArrayType.c_type, # Output, et[num].
    utils._BYREF_LOGICAL, # Input, fcall.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of dist.
)

times_garch_asym2 = utils._EngineState._get_symbol('g05pef')
times_garch_asym2.restype = None
times_garch_asym2.argtypes = (
    utils._BYREF_STRING, # Input, dist(len=1).
    utils._BYREF_INT, # Input, num.
    utils._BYREF_INT, # Input, ip.
    utils._BYREF_INT, # Input, iq.
    utils._EngineFloat64ArrayType.c_type, # Input, theta[iq+ip+1].
    utils._BYREF_FLOAT64, # Input, gamma.
    utils._BYREF_INT, # Input, df.
    utils._EngineFloat64ArrayType.c_type, # Output, ht[num].
    utils._EngineFloat64ArrayType.c_type, # Output, et[num].
    utils._BYREF_LOGICAL, # Input, fcall.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of dist.
)

times_garch_gjr = utils._EngineState._get_symbol('g05pff')
times_garch_gjr.restype = None
times_garch_gjr.argtypes = (
    utils._BYREF_STRING, # Input, dist(len=1).
    utils._BYREF_INT, # Input, num.
    utils._BYREF_INT, # Input, ip.
    utils._BYREF_INT, # Input, iq.
    utils._EngineFloat64ArrayType.c_type, # Input, theta[iq+ip+1].
    utils._BYREF_FLOAT64, # Input, gamma.
    utils._BYREF_INT, # Input, df.
    utils._EngineFloat64ArrayType.c_type, # Output, ht[num].
    utils._EngineFloat64ArrayType.c_type, # Output, et[num].
    utils._BYREF_LOGICAL, # Input, fcall.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of dist.
)

times_garch_exp = utils._EngineState._get_symbol('g05pgf')
times_garch_exp.restype = None
times_garch_exp.argtypes = (
    utils._BYREF_STRING, # Input, dist(len=1).
    utils._BYREF_INT, # Input, num.
    utils._BYREF_INT, # Input, ip.
    utils._BYREF_INT, # Input, iq.
    utils._EngineFloat64ArrayType.c_type, # Input, theta[2*iq+ip+1].
    utils._BYREF_INT, # Input, df.
    utils._EngineFloat64ArrayType.c_type, # Output, ht[num].
    utils._EngineFloat64ArrayType.c_type, # Output, et[num].
    utils._BYREF_LOGICAL, # Input, fcall.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of dist.
)

times_arma = utils._EngineState._get_symbol('g05phf')
times_arma.restype = None
times_arma.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, xmean.
    utils._BYREF_INT, # Input, ip.
    utils._EngineFloat64ArrayType.c_type, # Input, phi[ip].
    utils._BYREF_INT, # Input, iq.
    utils._EngineFloat64ArrayType.c_type, # Input, theta[iq].
    utils._BYREF_FLOAT64, # Input, avar.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._BYREF_FLOAT64, # Output, var.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

times_mv_varma = utils._EngineState._get_symbol('g05pjf')
times_mv_varma.restype = None
times_mv_varma.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, k.
    utils._EngineFloat64ArrayType.c_type, # Input, xmean[k].
    utils._BYREF_INT, # Input, ip.
    utils._EngineFloat64ArrayType.c_type, # Input, phi[k*k*ip].
    utils._BYREF_INT, # Input, iq.
    utils._EngineFloat64ArrayType.c_type, # Input, theta[k*k*iq].
    utils._EngineFloat64ArrayType.c_type, # Input, var[ldvar, k].
    utils._BYREF_INT, # Input, ldvar.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, n].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input/Output, ifail.
)

times_smooth_exp = utils._EngineState._get_symbol('g05pmf')
times_smooth_exp.restype = None
times_smooth_exp.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, itype.
    utils._BYREF_INT, # Input, p.
    utils._EngineFloat64ArrayType.c_type, # Input, param[*].
    utils._EngineFloat64ArrayType.c_type, # Input, init[*].
    utils._BYREF_FLOAT64, # Input, var.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[*].
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Input, e[en].
    utils._BYREF_INT, # Input, en.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

kfold_xyw = utils._EngineState._get_symbol('g05pvf')
kfold_xyw.restype = None
kfold_xyw.argtypes = (
    utils._BYREF_INT, # Input, k.
    utils._BYREF_INT, # Input, fold.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, sordx.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[ldx, *].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input, usey.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[*].
    utils._BYREF_INT, # Input, usew.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[*].
    utils._BYREF_INT, # Output, nt.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

subsamp_xyw = utils._EngineState._get_symbol('g05pwf')
subsamp_xyw.restype = None
subsamp_xyw.argtypes = (
    utils._BYREF_INT, # Input, nt.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, sordx.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[ldx, *].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input, usey.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, y[*].
    utils._BYREF_INT, # Input, usew.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[*].
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

matrix_orthog = utils._EngineState._get_symbol('g05pxf')
matrix_orthog.restype = None
matrix_orthog.argtypes = (
    utils._BYREF_STRING, # Input, side(len=1).
    utils._BYREF_STRING, # Input, init(len=1).
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[lda, n].
    utils._BYREF_INT, # Input, lda.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of side.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of init.
)

matrix_corr = utils._EngineState._get_symbol('g05pyf')
matrix_corr.restype = None
matrix_corr.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, d[n].
    utils._BYREF_FLOAT64, # Input, eps.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, c[ldc, n].
    utils._BYREF_INT, # Input, ldc.
    utils._BYREF_INT, # Input/Output, ifail.
)

matrix_2waytable = utils._EngineState._get_symbol('g05pzf')
matrix_2waytable.restype = None
matrix_2waytable.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, nrow.
    utils._BYREF_INT, # Input, ncol.
    utils._EngineIntArrayType.c_type, # Input, totr[nrow].
    utils._EngineIntArrayType.c_type, # Input, totc[ncol].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineIntArrayType.c_type, # Output, x[ldx, ncol].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_matrix_orthog = utils._EngineState._get_symbol('g05qaf')
withdraw_matrix_orthog.restype = None
withdraw_matrix_orthog.argtypes = (
    utils._BYREF_STRING, # Input, side(len=1).
    utils._BYREF_STRING, # Input, init(len=1).
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[lda, n].
    utils._BYREF_INT, # Input, lda.
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._EngineFloat64ArrayType.c_type, # Workspace, wk[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of side.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of init.
)

withdraw_matrix_corr = utils._EngineState._get_symbol('g05qbf')
withdraw_matrix_corr.restype = None
withdraw_matrix_corr.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, d[n].
    utils._EngineFloat64ArrayType.c_type, # Output, c[ldc, n].
    utils._BYREF_INT, # Input, ldc.
    utils._BYREF_FLOAT64, # Input, eps.
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._EngineFloat64ArrayType.c_type, # Workspace, wk[2*n].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_matrix_2waytable = utils._EngineState._get_symbol('g05qdf')
withdraw_matrix_2waytable.restype = None
withdraw_matrix_2waytable.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, nrow.
    utils._BYREF_INT, # Input, ncol.
    utils._EngineIntArrayType.c_type, # Input, totr[nrow].
    utils._EngineIntArrayType.c_type, # Input, totc[ncol].
    utils._EngineIntArrayType.c_type, # Output, x[ldx, ncol].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[nr].
    utils._BYREF_INT, # Input, nr.
    utils._EngineIntArrayType.c_type, # Workspace, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_copula_normal = utils._EngineState._get_symbol('g05raf')
withdraw_copula_normal.restype = None
withdraw_copula_normal.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, c[ldc, m].
    utils._BYREF_INT, # Input, ldc.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, m].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_copula_students_t = utils._EngineState._get_symbol('g05rbf')
withdraw_copula_students_t.restype = None
withdraw_copula_students_t.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, df.
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, c[ldc, m].
    utils._BYREF_INT, # Input, ldc.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, m].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input, igen.
    utils._EngineIntArrayType.c_type, # Input/Output, iseed[4].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._BYREF_INT, # Input/Output, ifail.
)

copula_students_t = utils._EngineState._get_symbol('g05rcf')
copula_students_t.restype = None
copula_students_t.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, df.
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, c[ldc, m].
    utils._BYREF_INT, # Input, ldc.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, *].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input/Output, ifail.
)

copula_normal = utils._EngineState._get_symbol('g05rdf')
copula_normal.restype = None
copula_normal.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, c[ldc, m].
    utils._BYREF_INT, # Input, ldc.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, *].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input/Output, ifail.
)

copula_clayton_bivar = utils._EngineState._get_symbol('g05ref')
copula_clayton_bivar.restype = None
copula_clayton_bivar.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, theta.
    utils._BYREF_INT, # Input, sorder.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, sdx].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input, sdx.
    utils._BYREF_INT, # Input/Output, ifail.
)

copula_frank_bivar = utils._EngineState._get_symbol('g05rff')
copula_frank_bivar.restype = None
copula_frank_bivar.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, theta.
    utils._BYREF_INT, # Input, sorder.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, sdx].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input, sdx.
    utils._BYREF_INT, # Input/Output, ifail.
)

copula_plackett_bivar = utils._EngineState._get_symbol('g05rgf')
copula_plackett_bivar.restype = None
copula_plackett_bivar.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, theta.
    utils._BYREF_INT, # Input, sorder.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, sdx].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input, sdx.
    utils._BYREF_INT, # Input/Output, ifail.
)

copula_clayton = utils._EngineState._get_symbol('g05rhf')
copula_clayton.restype = None
copula_clayton.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, theta.
    utils._BYREF_INT, # Input, sorder.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, sdx].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input, sdx.
    utils._BYREF_INT, # Input/Output, ifail.
)

copula_frank = utils._EngineState._get_symbol('g05rjf')
copula_frank.restype = None
copula_frank.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, theta.
    utils._BYREF_INT, # Input, sorder.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, sdx].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input, sdx.
    utils._BYREF_INT, # Input/Output, ifail.
)

copula_gumbel = utils._EngineState._get_symbol('g05rkf')
copula_gumbel.restype = None
copula_gumbel.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, theta.
    utils._BYREF_INT, # Input, sorder.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, sdx].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input, sdx.
    utils._BYREF_INT, # Input/Output, ifail.
)

multivar_students_t = utils._EngineState._get_symbol('g05ryf')
multivar_students_t.restype = None
multivar_students_t.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, df.
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, xmu[m].
    utils._EngineFloat64ArrayType.c_type, # Input, c[ldc, m].
    utils._BYREF_INT, # Input, ldc.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, *].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input/Output, ifail.
)

multivar_normal = utils._EngineState._get_symbol('g05rzf')
multivar_normal.restype = None
multivar_normal.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, xmu[m].
    utils._EngineFloat64ArrayType.c_type, # Input, c[ldc, m].
    utils._BYREF_INT, # Input, ldc.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, *].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input/Output, ifail.
)

dist_uniform01 = utils._EngineState._get_symbol('g05saf')
dist_uniform01.restype = None
dist_uniform01.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

dist_beta = utils._EngineState._get_symbol('g05sbf')
dist_beta.restype = None
dist_beta.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, a.
    utils._BYREF_FLOAT64, # Input, b.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

dist_cauchy = utils._EngineState._get_symbol('g05scf')
dist_cauchy.restype = None
dist_cauchy.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, xmed.
    utils._BYREF_FLOAT64, # Input, semiqr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

dist_chisq = utils._EngineState._get_symbol('g05sdf')
dist_chisq.restype = None
dist_chisq.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, df.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

dist_dirichlet = utils._EngineState._get_symbol('g05sef')
dist_dirichlet.restype = None
dist_dirichlet.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, a[m].
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[ldx, *].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input/Output, ifail.
)

dist_exp = utils._EngineState._get_symbol('g05sff')
dist_exp.restype = None
dist_exp.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, a.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

dist_expmix = utils._EngineState._get_symbol('g05sgf')
dist_expmix.restype = None
dist_expmix.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nmix.
    utils._EngineFloat64ArrayType.c_type, # Input, a[nmix].
    utils._EngineFloat64ArrayType.c_type, # Input, wgt[nmix].
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

dist_f = utils._EngineState._get_symbol('g05shf')
dist_f.restype = None
dist_f.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, df1.
    utils._BYREF_INT, # Input, df2.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

dist_gamma = utils._EngineState._get_symbol('g05sjf')
dist_gamma.restype = None
dist_gamma.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, a.
    utils._BYREF_FLOAT64, # Input, b.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

dist_normal = utils._EngineState._get_symbol('g05skf')
dist_normal.restype = None
dist_normal.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, xmu.
    utils._BYREF_FLOAT64, # Input, var.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

dist_logistic = utils._EngineState._get_symbol('g05slf')
dist_logistic.restype = None
dist_logistic.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, a.
    utils._BYREF_FLOAT64, # Input, b.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

dist_lognormal = utils._EngineState._get_symbol('g05smf')
dist_lognormal.restype = None
dist_lognormal.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, xmu.
    utils._BYREF_FLOAT64, # Input, var.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

dist_students_t = utils._EngineState._get_symbol('g05snf')
dist_students_t.restype = None
dist_students_t.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, df.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

dist_triangular = utils._EngineState._get_symbol('g05spf')
dist_triangular.restype = None
dist_triangular.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, xmin.
    utils._BYREF_FLOAT64, # Input, xmed.
    utils._BYREF_FLOAT64, # Input, xmax.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

dist_uniform = utils._EngineState._get_symbol('g05sqf')
dist_uniform.restype = None
dist_uniform.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, a.
    utils._BYREF_FLOAT64, # Input, b.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

dist_vonmises = utils._EngineState._get_symbol('g05srf')
dist_vonmises.restype = None
dist_vonmises.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, vk.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

dist_weibull = utils._EngineState._get_symbol('g05ssf')
dist_weibull.restype = None
dist_weibull.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, a.
    utils._BYREF_FLOAT64, # Input, b.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

int_binomial = utils._EngineState._get_symbol('g05taf')
int_binomial.restype = None
int_binomial.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, p.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineIntArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

logical = utils._EngineState._get_symbol('g05tbf')
logical.restype = None
logical.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, p.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineLogicalArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

int_geom = utils._EngineState._get_symbol('g05tcf')
int_geom.restype = None
int_geom.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, p.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineIntArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

int_general = utils._EngineState._get_symbol('g05tdf')
int_general.restype = None
int_general.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, p[np].
    utils._BYREF_INT, # Input, np.
    utils._BYREF_INT, # Input, ip1.
    utils._BYREF_INT, # Input, itype.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineIntArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

int_hypergeom = utils._EngineState._get_symbol('g05tef')
int_hypergeom.restype = None
int_hypergeom.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ns.
    utils._BYREF_INT, # Input, np.
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineIntArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

int_log = utils._EngineState._get_symbol('g05tff')
int_log.restype = None
int_log.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, a.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineIntArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

int_multinomial = utils._EngineState._get_symbol('g05tgf')
int_multinomial.restype = None
int_multinomial.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, k.
    utils._EngineFloat64ArrayType.c_type, # Input, p[k].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineIntArrayType.c_type, # Output, x[ldx, *].
    utils._BYREF_INT, # Input, ldx.
    utils._BYREF_INT, # Input/Output, ifail.
)

int_negbin = utils._EngineState._get_symbol('g05thf')
int_negbin.restype = None
int_negbin.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, p.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineIntArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

int_poisson = utils._EngineState._get_symbol('g05tjf')
int_poisson.restype = None
int_poisson.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, lambda.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[lr].
    utils._BYREF_INT, # Input, lr.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineIntArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

int_poisson_varmean = utils._EngineState._get_symbol('g05tkf')
int_poisson_varmean.restype = None
int_poisson_varmean.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, vlamda[m].
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineIntArrayType.c_type, # Output, x[m].
    utils._BYREF_INT, # Input/Output, ifail.
)

int_uniform = utils._EngineState._get_symbol('g05tlf')
int_uniform.restype = None
int_uniform.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, a.
    utils._BYREF_INT, # Input, b.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineIntArrayType.c_type, # Output, x[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

bb_init = utils._EngineState._get_symbol('g05xaf')
bb_init.restype = None
bb_init.argtypes = (
    utils._BYREF_FLOAT64, # Input, t0.
    utils._BYREF_FLOAT64, # Input, tend.
    utils._EngineFloat64ArrayType.c_type, # Input, times[ntimes].
    utils._BYREF_INT, # Input, ntimes.
    utils._EngineFloat64ArrayType.c_type, # Output, rcomm[12*(ntimes+1)].
    utils._BYREF_INT, # Input/Output, ifail.
)

bb = utils._EngineState._get_symbol('g05xbf')
bb.restype = None
bb.argtypes = (
    utils._BYREF_INT, # Input, npaths.
    utils._BYREF_INT, # Input, rcord.
    utils._BYREF_INT, # Input, d.
    utils._EngineFloat64ArrayType.c_type, # Input, start[d].
    utils._BYREF_INT, # Input, a.
    utils._EngineFloat64ArrayType.c_type, # Input, term[d].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, z[ldz, *].
    utils._BYREF_INT, # Input, ldz.
    utils._EngineFloat64ArrayType.c_type, # Input, c[ldc, *].
    utils._BYREF_INT, # Input, ldc.
    utils._EngineFloat64ArrayType.c_type, # Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._EngineFloat64ArrayType.c_type, # Input, rcomm[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

bb_inc_init = utils._EngineState._get_symbol('g05xcf')
bb_inc_init.restype = None
bb_inc_init.argtypes = (
    utils._BYREF_FLOAT64, # Input, t0.
    utils._BYREF_FLOAT64, # Input, tend.
    utils._EngineFloat64ArrayType.c_type, # Input, times[ntimes].
    utils._BYREF_INT, # Input, ntimes.
    utils._EngineFloat64ArrayType.c_type, # Output, rcomm[12*(ntimes+1)].
    utils._BYREF_INT, # Input/Output, ifail.
)

bb_inc = utils._EngineState._get_symbol('g05xdf')
bb_inc.restype = None
bb_inc.argtypes = (
    utils._BYREF_INT, # Input, npaths.
    utils._BYREF_INT, # Input, rcord.
    utils._BYREF_INT, # Input, d.
    utils._BYREF_INT, # Input, a.
    utils._EngineFloat64ArrayType.c_type, # Input, diff[d].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, z[ldz, *].
    utils._BYREF_INT, # Input, ldz.
    utils._EngineFloat64ArrayType.c_type, # Input, c[ldc, *].
    utils._BYREF_INT, # Input, ldc.
    utils._EngineFloat64ArrayType.c_type, # Output, b[ldb, *].
    utils._BYREF_INT, # Input, ldb.
    utils._EngineFloat64ArrayType.c_type, # Input, rcomm[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

bb_make_bridge_order = utils._EngineState._get_symbol('g05xef')
bb_make_bridge_order.restype = None
bb_make_bridge_order.argtypes = (
    utils._BYREF_INT, # Input, bgord.
    utils._BYREF_FLOAT64, # Input, t0.
    utils._BYREF_FLOAT64, # Input, tend.
    utils._BYREF_INT, # Input, ntimes.
    utils._EngineFloat64ArrayType.c_type, # Input, intime[ntimes].
    utils._BYREF_INT, # Input, nmove.
    utils._EngineIntArrayType.c_type, # Input, move[nmove].
    utils._EngineFloat64ArrayType.c_type, # Output, times[ntimes].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_quasi_faure_init = utils._EngineState._get_symbol('g05ycf')
withdraw_quasi_faure_init.restype = None
withdraw_quasi_faure_init.argtypes = (
    utils._BYREF_INT, # Input, idim.
    utils._EngineIntArrayType.c_type, # Output, iref[406].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_quasi_faure_uniform = utils._EngineState._get_symbol('g05ydf')
withdraw_quasi_faure_uniform.restype = None
withdraw_quasi_faure_uniform.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, quasi[n, *].
    utils._EngineIntArrayType.c_type, # Input/Output, iref[406].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_quasi_sobol_init = utils._EngineState._get_symbol('g05yef')
withdraw_quasi_sobol_init.restype = None
withdraw_quasi_sobol_init.argtypes = (
    utils._BYREF_INT, # Input, idim.
    utils._EngineIntArrayType.c_type, # Output, iref[2000].
    utils._BYREF_INT, # Input, iskip.
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_quasi_sobol_uniform = utils._EngineState._get_symbol('g05yff')
withdraw_quasi_sobol_uniform.restype = None
withdraw_quasi_sobol_uniform.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, quasi[n, *].
    utils._EngineIntArrayType.c_type, # Input/Output, iref[2000].
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_quasi_nied_init = utils._EngineState._get_symbol('g05ygf')
withdraw_quasi_nied_init.restype = None
withdraw_quasi_nied_init.argtypes = (
    utils._BYREF_INT, # Input, idim.
    utils._EngineIntArrayType.c_type, # Output, iref[2000].
    utils._BYREF_INT, # Input, iskip.
    utils._BYREF_INT, # Input/Output, ifail.
)

withdraw_quasi_nied_uniform = utils._EngineState._get_symbol('g05yhf')
withdraw_quasi_nied_uniform.restype = None
withdraw_quasi_nied_uniform.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, quasi[n, *].
    utils._EngineIntArrayType.c_type, # Input/Output, iref[2000].
    utils._BYREF_INT, # Input/Output, ifail.
)

quasi_normal = utils._EngineState._get_symbol('g05yjf')
quasi_normal.restype = None
quasi_normal.argtypes = (
    utils._EngineFloat64ArrayType.c_type, # Input, xmean[*].
    utils._EngineFloat64ArrayType.c_type, # Input, std[*].
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, quas[n, *].
    utils._EngineIntArrayType.c_type, # Input/Output, iref[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

quasi_lognormal = utils._EngineState._get_symbol('g05ykf')
quasi_lognormal.restype = None
quasi_lognormal.argtypes = (
    utils._EngineFloat64ArrayType.c_type, # Input, xmean[*].
    utils._EngineFloat64ArrayType.c_type, # Input, std[*].
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, quas[n, *].
    utils._EngineIntArrayType.c_type, # Input/Output, iref[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

quasi_init = utils._EngineState._get_symbol('g05ylf')
quasi_init.restype = None
quasi_init.argtypes = (
    utils._BYREF_INT, # Input, genid.
    utils._BYREF_INT, # Input, idim.
    utils._EngineIntArrayType.c_type, # Output, iref[liref].
    utils._BYREF_INT, # Input, liref.
    utils._BYREF_INT, # Input, iskip.
    utils._BYREF_INT, # Input/Output, ifail.
)

quasi_uniform = utils._EngineState._get_symbol('g05ymf')
quasi_uniform.restype = None
quasi_uniform.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, rcord.
    utils._EngineFloat64ArrayType.c_type, # Output, quas[ldquas, *].
    utils._BYREF_INT, # Input, ldquas.
    utils._EngineIntArrayType.c_type, # Input/Output, iref[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

quasi_init_scrambled = utils._EngineState._get_symbol('g05ynf')
quasi_init_scrambled.restype = None
quasi_init_scrambled.argtypes = (
    utils._BYREF_INT, # Input, genid.
    utils._BYREF_INT, # Input, stype.
    utils._BYREF_INT, # Input, idim.
    utils._EngineIntArrayType.c_type, # Output, iref[liref].
    utils._BYREF_INT, # Input, liref.
    utils._BYREF_INT, # Input, iskip.
    utils._BYREF_INT, # Input, nsdigi.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

field_1d_user_setup_cov1 = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_FLOAT64, # Output, gamma.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
field_1d_user_setup = utils._EngineState._get_symbol('g05zmf')
field_1d_user_setup.restype = None
field_1d_user_setup.argtypes = (
    utils._BYREF_INT, # Input, ns.
    utils._BYREF_FLOAT64, # Input, xmin.
    utils._BYREF_FLOAT64, # Input, xmax.
    utils._BYREF_INT, # Input, maxm.
    utils._BYREF_FLOAT64, # Input, var.
    field_1d_user_setup_cov1,
    utils._BYREF_INT, # Input, pad.
    utils._BYREF_INT, # Input, icorr.
    utils._EngineFloat64ArrayType.c_type, # Output, lam[maxm].
    utils._EngineFloat64ArrayType.c_type, # Output, xx[ns].
    utils._BYREF_INT, # Output, m.
    utils._BYREF_INT, # Output, approx.
    utils._BYREF_FLOAT64, # Output, rho.
    utils._BYREF_INT, # Output, icount.
    utils._EngineFloat64ArrayType.c_type, # Output, eig[3].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

field_1d_predef_setup = utils._EngineState._get_symbol('g05znf')
field_1d_predef_setup.restype = None
field_1d_predef_setup.argtypes = (
    utils._BYREF_INT, # Input, ns.
    utils._BYREF_FLOAT64, # Input, xmin.
    utils._BYREF_FLOAT64, # Input, xmax.
    utils._BYREF_INT, # Input, maxm.
    utils._BYREF_FLOAT64, # Input, var.
    utils._BYREF_INT, # Input, icov1.
    utils._BYREF_INT, # Input, np.
    utils._EngineFloat64ArrayType.c_type, # Input, params[np].
    utils._BYREF_INT, # Input, pad.
    utils._BYREF_INT, # Input, icorr.
    utils._EngineFloat64ArrayType.c_type, # Output, lam[maxm].
    utils._EngineFloat64ArrayType.c_type, # Output, xx[ns].
    utils._BYREF_INT, # Output, m.
    utils._BYREF_INT, # Output, approx.
    utils._BYREF_FLOAT64, # Output, rho.
    utils._BYREF_INT, # Output, icount.
    utils._EngineFloat64ArrayType.c_type, # Output, eig[3].
    utils._BYREF_INT, # Input/Output, ifail.
)

field_1d_generate = utils._EngineState._get_symbol('g05zpf')
field_1d_generate.restype = None
field_1d_generate.argtypes = (
    utils._BYREF_INT, # Input, ns.
    utils._BYREF_INT, # Input, s.
    utils._BYREF_INT, # Input, m.
    utils._EngineFloat64ArrayType.c_type, # Input, lam[m].
    utils._BYREF_FLOAT64, # Input, rho.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, z[ns, s].
    utils._BYREF_INT, # Input/Output, ifail.
)

field_2d_user_setup_cov2 = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_FLOAT64, # Input, y.
    utils._BYREF_FLOAT64, # Output, gamma.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
field_2d_user_setup = utils._EngineState._get_symbol('g05zqf')
field_2d_user_setup.restype = None
field_2d_user_setup.argtypes = (
    utils._EngineIntArrayType.c_type, # Input, ns[2].
    utils._BYREF_FLOAT64, # Input, xmin.
    utils._BYREF_FLOAT64, # Input, xmax.
    utils._BYREF_FLOAT64, # Input, ymin.
    utils._BYREF_FLOAT64, # Input, ymax.
    utils._EngineIntArrayType.c_type, # Input, maxm[2].
    utils._BYREF_FLOAT64, # Input, var.
    field_2d_user_setup_cov2,
    utils._BYREF_INT, # Input, even.
    utils._BYREF_INT, # Input, pad.
    utils._BYREF_INT, # Input, icorr.
    utils._EngineFloat64ArrayType.c_type, # Output, lam[maxm[1]*maxm[2]].
    utils._EngineFloat64ArrayType.c_type, # Output, xx[ns[1]].
    utils._EngineFloat64ArrayType.c_type, # Output, yy[ns[2]].
    utils._EngineIntArrayType.c_type, # Output, m[2].
    utils._BYREF_INT, # Output, approx.
    utils._BYREF_FLOAT64, # Output, rho.
    utils._BYREF_INT, # Output, icount.
    utils._EngineFloat64ArrayType.c_type, # Output, eig[3].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

field_2d_predef_setup = utils._EngineState._get_symbol('g05zrf')
field_2d_predef_setup.restype = None
field_2d_predef_setup.argtypes = (
    utils._EngineIntArrayType.c_type, # Input, ns[2].
    utils._BYREF_FLOAT64, # Input, xmin.
    utils._BYREF_FLOAT64, # Input, xmax.
    utils._BYREF_FLOAT64, # Input, ymin.
    utils._BYREF_FLOAT64, # Input, ymax.
    utils._EngineIntArrayType.c_type, # Input, maxm[2].
    utils._BYREF_FLOAT64, # Input, var.
    utils._BYREF_INT, # Input, icov2.
    utils._BYREF_INT, # Input, norm.
    utils._BYREF_INT, # Input, np.
    utils._EngineFloat64ArrayType.c_type, # Input, params[np].
    utils._BYREF_INT, # Input, pad.
    utils._BYREF_INT, # Input, icorr.
    utils._EngineFloat64ArrayType.c_type, # Output, lam[maxm[1]*maxm[2]].
    utils._EngineFloat64ArrayType.c_type, # Output, xx[ns[1]].
    utils._EngineFloat64ArrayType.c_type, # Output, yy[ns[2]].
    utils._EngineIntArrayType.c_type, # Output, m[2].
    utils._BYREF_INT, # Output, approx.
    utils._BYREF_FLOAT64, # Output, rho.
    utils._BYREF_INT, # Output, icount.
    utils._EngineFloat64ArrayType.c_type, # Output, eig[3].
    utils._BYREF_INT, # Input/Output, ifail.
)

field_2d_generate = utils._EngineState._get_symbol('g05zsf')
field_2d_generate.restype = None
field_2d_generate.argtypes = (
    utils._EngineIntArrayType.c_type, # Input, ns[2].
    utils._BYREF_INT, # Input, s.
    utils._EngineIntArrayType.c_type, # Input, m[2].
    utils._EngineFloat64ArrayType.c_type, # Input, lam[m[1]*m[2]].
    utils._BYREF_FLOAT64, # Input, rho.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, z[ns[1]*ns[2], s].
    utils._BYREF_INT, # Input/Output, ifail.
)

field_fracbm_generate = utils._EngineState._get_symbol('g05ztf')
field_fracbm_generate.restype = None
field_fracbm_generate.argtypes = (
    utils._BYREF_INT, # Input, ns.
    utils._BYREF_INT, # Input, s.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, xmax.
    utils._BYREF_FLOAT64, # Input, h.
    utils._EngineFloat64ArrayType.c_type, # Input, lam[m].
    utils._BYREF_FLOAT64, # Input, rho.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, z[ns+1, s].
    utils._EngineFloat64ArrayType.c_type, # Output, xx[ns+1].
    utils._BYREF_INT, # Input/Output, ifail.
)
