# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `rnla` Chapter.
"""

# NAG Copyright 2017-2020.

from ..base import utils

svd_rowext_real = utils._EngineState._get_symbol('f10caf')
svd_rowext_real.restype = None
svd_rowext_real.argtypes = (
    utils._BYREF_STRING, # Input, jobu(len=1).
    utils._BYREF_STRING, # Input, jobvt(len=1).
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._BYREF_INT, # Input, k.
    utils._BYREF_FLOAT64, # Input, rtol_abs.
    utils._BYREF_FLOAT64, # Input, rtol_rel.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._EngineFloat64ArrayType.c_type, # Output, s[k].
    utils._EngineFloat64ArrayType.c_type, # Output, u[ldu, *].
    utils._BYREF_INT, # Input, ldu.
    utils._EngineFloat64ArrayType.c_type, # Output, vt[ldvt, *].
    utils._BYREF_INT, # Input, ldvt.
    utils._BYREF_INT, # Output, r.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of jobu.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of jobvt.
)

randproj_dct_real = utils._EngineState._get_symbol('f10daf')
randproj_dct_real.restype = None
randproj_dct_real.argtypes = (
    utils._BYREF_STRING, # Input, trans(len=1).
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._BYREF_INT, # Input, k.
    utils._EngineIntArrayType.c_type, # Input/Output, state[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of trans.
)
