# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `roots` Chapter.
"""

# NAG Copyright 2017-2020.

from ..base import utils

contfn_brent_interval_f = utils._EngineState._sys_functype(
    utils._EngineFloat64ScalarType.c_type,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
contfn_brent_interval = utils._EngineState._get_symbol('c05auf')
contfn_brent_interval.restype = None
contfn_brent_interval.argtypes = (
    utils._BYREF_FLOAT64, # Input/Output, x.
    utils._BYREF_FLOAT64, # Input, h.
    utils._BYREF_FLOAT64, # Input, eps.
    utils._BYREF_FLOAT64, # Input, eta.
    contfn_brent_interval_f,
    utils._BYREF_FLOAT64, # Output, a.
    utils._BYREF_FLOAT64, # Output, b.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

contfn_interval_rcomm = utils._EngineState._get_symbol('c05avf')
contfn_interval_rcomm.restype = None
contfn_interval_rcomm.argtypes = (
    utils._BYREF_FLOAT64, # Input/Output, x.
    utils._BYREF_FLOAT64, # Input, fx.
    utils._BYREF_FLOAT64, # Input/Output, h.
    utils._BYREF_FLOAT64, # Input, boundl.
    utils._BYREF_FLOAT64, # Input, boundu.
    utils._BYREF_FLOAT64, # Input/Output, y.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, c[11].
    utils._BYREF_INT, # Input/Output, ind.
    utils._BYREF_INT, # Input/Output, ifail.
)

contfn_cntin_f = utils._EngineState._sys_functype(
    utils._EngineFloat64ScalarType.c_type,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
contfn_cntin = utils._EngineState._get_symbol('c05awf')
contfn_cntin.restype = None
contfn_cntin.argtypes = (
    utils._BYREF_FLOAT64, # Input/Output, x.
    utils._BYREF_FLOAT64, # Input, eps.
    utils._BYREF_FLOAT64, # Input, eta.
    contfn_cntin_f,
    utils._BYREF_INT, # Input, nfmax.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

contfn_cntin_rcomm = utils._EngineState._get_symbol('c05axf')
contfn_cntin_rcomm.restype = None
contfn_cntin_rcomm.argtypes = (
    utils._BYREF_FLOAT64, # Input/Output, x.
    utils._BYREF_FLOAT64, # Input, fx.
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_INT, # Input, ir.
    utils._BYREF_FLOAT64, # Input, scal.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, c[26].
    utils._BYREF_INT, # Input/Output, ind.
    utils._BYREF_INT, # Input/Output, ifail.
)

contfn_brent_f = utils._EngineState._sys_functype(
    utils._EngineFloat64ScalarType.c_type,
    utils._BYREF_FLOAT64, # Input, x.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
contfn_brent = utils._EngineState._get_symbol('c05ayf')
contfn_brent.restype = None
contfn_brent.argtypes = (
    utils._BYREF_FLOAT64, # Input, a.
    utils._BYREF_FLOAT64, # Input, b.
    utils._BYREF_FLOAT64, # Input, eps.
    utils._BYREF_FLOAT64, # Input, eta.
    contfn_brent_f,
    utils._BYREF_FLOAT64, # Output, x.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

contfn_brent_rcomm = utils._EngineState._get_symbol('c05azf')
contfn_brent_rcomm.restype = None
contfn_brent_rcomm.argtypes = (
    utils._BYREF_FLOAT64, # Input/Output, x.
    utils._BYREF_FLOAT64, # Input/Output, y.
    utils._BYREF_FLOAT64, # Input, fx.
    utils._BYREF_FLOAT64, # Input, tolx.
    utils._BYREF_INT, # Input, ir.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, c[17].
    utils._BYREF_INT, # Input/Output, ind.
    utils._BYREF_INT, # Input/Output, ifail.
)

lambertw_real = utils._EngineState._get_symbol('c05baf')
lambertw_real.restype = utils._EngineFloat64ScalarType.c_type
lambertw_real.argtypes = (
    utils._BYREF_FLOAT64, # Input, x.
    utils._BYREF_INT, # Input, branch.
    utils._BYREF_LOGICAL, # Input, offset.
    utils._BYREF_INT, # Input/Output, ifail.
)

lambertw_complex = utils._EngineState._get_symbol('c05bbf')
lambertw_complex.restype = None
lambertw_complex.argtypes = (
    utils._BYREF_INT, # Input, branch.
    utils._BYREF_LOGICAL, # Input, offset.
    utils._BYREF_COMPLEX128, # Input, z.
    utils._BYREF_COMPLEX128, # Output, w.
    utils._BYREF_FLOAT64, # Output, resid.
    utils._BYREF_INT, # Input/Output, ifail.
)

sys_func_aa_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
    utils._BYREF_INT, # Input/Output, iflag.
)
sys_func_aa = utils._EngineState._get_symbol('c05mbf')
sys_func_aa.restype = None
sys_func_aa.argtypes = (
    sys_func_aa_fcn,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[n].
    utils._BYREF_FLOAT64, # Input, atol.
    utils._BYREF_FLOAT64, # Input, rtol.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, cndtol.
    utils._BYREF_INT, # Input, astart.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
    utils._BYREF_INT, # Input/Output, ifail.
)

sys_func_aa_rcomm = utils._EngineState._get_symbol('c05mdf')
sys_func_aa_rcomm.restype = None
sys_func_aa_rcomm.argtypes = (
    utils._BYREF_INT, # Input/Output, irevcm.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fvec[n].
    utils._BYREF_FLOAT64, # Input, atol.
    utils._BYREF_FLOAT64, # Input, rtol.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_FLOAT64, # Input, cndtol.
    utils._BYREF_INT, # Input, astart.
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[14+m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[2*m*n+m**2+m+2*n+1+min(m, 1)*max(n, 3*m)].
    utils._BYREF_INT, # Input/Output, ifail.
)

sys_func_easy_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, iflag.
)
sys_func_easy = utils._EngineState._get_symbol('c05qbf')
sys_func_easy.restype = None
sys_func_easy.argtypes = (
    sys_func_easy_fcn,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[n].
    utils._BYREF_FLOAT64, # Input, xtol.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

sys_func_expert_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fvec[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, iflag.
)
sys_func_expert = utils._EngineState._get_symbol('c05qcf')
sys_func_expert.restype = None
sys_func_expert.argtypes = (
    sys_func_expert_fcn,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[n].
    utils._BYREF_FLOAT64, # Input, xtol.
    utils._BYREF_INT, # Input, maxfev.
    utils._BYREF_INT, # Input, ml.
    utils._BYREF_INT, # Input, mu.
    utils._BYREF_FLOAT64, # Input, epsfcn.
    utils._BYREF_INT, # Input, mode.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, diag[n].
    utils._BYREF_FLOAT64, # Input, factor.
    utils._BYREF_INT, # Input, nprint.
    utils._BYREF_INT, # Output, nfev.
    utils._EngineFloat64ArrayType.c_type, # Output, fjac[n, n].
    utils._EngineFloat64ArrayType.c_type, # Output, r[n*(n+1)/2].
    utils._EngineFloat64ArrayType.c_type, # Output, qtf[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

sys_func_rcomm = utils._EngineState._get_symbol('c05qdf')
sys_func_rcomm.restype = None
sys_func_rcomm.argtypes = (
    utils._BYREF_INT, # Input/Output, irevcm.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fvec[n].
    utils._BYREF_FLOAT64, # Input, xtol.
    utils._BYREF_INT, # Input, ml.
    utils._BYREF_INT, # Input, mu.
    utils._BYREF_FLOAT64, # Input, epsfcn.
    utils._BYREF_INT, # Input, mode.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, diag[n].
    utils._BYREF_FLOAT64, # Input, factor.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fjac[n, n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[n*(n+1)/2].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, qtf[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[17].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[4*n+10].
    utils._BYREF_INT, # Input/Output, ifail.
)

sparsys_func_easy_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, lindf.
    utils._EngineIntArrayType.c_type, # Input, indf[lindf].
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, iflag.
)
sparsys_func_easy = utils._EngineState._get_symbol('c05qsf')
sparsys_func_easy.restype = None
sparsys_func_easy.argtypes = (
    sparsys_func_easy_fcn,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[n].
    utils._BYREF_FLOAT64, # Input, xtol.
    utils._BYREF_LOGICAL, # Input, init.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rcomm[lrcomm].
    utils._BYREF_INT, # Input, lrcomm.
    utils._EngineIntArrayType.c_type, # Input/Output, icomm[licomm].
    utils._BYREF_INT, # Input, licomm.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

sys_deriv_easy_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fvec[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fjac[n, n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, iflag.
)
sys_deriv_easy = utils._EngineState._get_symbol('c05rbf')
sys_deriv_easy.restype = None
sys_deriv_easy.argtypes = (
    sys_deriv_easy_fcn,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fjac[n, n].
    utils._BYREF_FLOAT64, # Input, xtol.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

sys_deriv_expert_fcn = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fvec[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fjac[n, n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, iflag.
)
sys_deriv_expert = utils._EngineState._get_symbol('c05rcf')
sys_deriv_expert.restype = None
sys_deriv_expert.argtypes = (
    sys_deriv_expert_fcn,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fjac[n, n].
    utils._BYREF_FLOAT64, # Input, xtol.
    utils._BYREF_INT, # Input, maxfev.
    utils._BYREF_INT, # Input, mode.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, diag[n].
    utils._BYREF_FLOAT64, # Input, factor.
    utils._BYREF_INT, # Input, nprint.
    utils._BYREF_INT, # Output, nfev.
    utils._BYREF_INT, # Output, njev.
    utils._EngineFloat64ArrayType.c_type, # Output, r[n*(n+1)/2].
    utils._EngineFloat64ArrayType.c_type, # Output, qtf[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

sys_deriv_rcomm = utils._EngineState._get_symbol('c05rdf')
sys_deriv_rcomm.restype = None
sys_deriv_rcomm.argtypes = (
    utils._BYREF_INT, # Input/Output, irevcm.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fvec[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fjac[n, n].
    utils._BYREF_FLOAT64, # Input, xtol.
    utils._BYREF_INT, # Input, mode.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, diag[n].
    utils._BYREF_FLOAT64, # Input, factor.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[n*(n+1)/2].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, qtf[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[17].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[4*n+10].
    utils._BYREF_INT, # Input/Output, ifail.
)

sys_deriv_check = utils._EngineState._get_symbol('c05zdf')
sys_deriv_check.restype = None
sys_deriv_check.argtypes = (
    utils._BYREF_INT, # Input, mode.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Input, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Input, fjac[m, n].
    utils._EngineFloat64ArrayType.c_type, # Output, xp[n].
    utils._EngineFloat64ArrayType.c_type, # Input, fvecp[m].
    utils._EngineFloat64ArrayType.c_type, # Output, err[m].
    utils._BYREF_INT, # Input/Output, ifail.
)
