# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `smooth` Chapter.
"""

# NAG Copyright 2017-2020.

from ..base import utils

fit_spline = utils._EngineState._get_symbol('g10abf')
fit_spline.restype = None
fit_spline.argtypes = (
    utils._BYREF_STRING, # Input, mode(len=1).
    utils._BYREF_STRING, # Input, weight(len=1).
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._EngineFloat64ArrayType.c_type, # Input, wt[*].
    utils._BYREF_FLOAT64, # Input, rho.
    utils._EngineFloat64ArrayType.c_type, # Output, yhat[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, c[ldc, 3].
    utils._BYREF_INT, # Input, ldc.
    utils._BYREF_FLOAT64, # Output, rss.
    utils._BYREF_FLOAT64, # Output, df.
    utils._EngineFloat64ArrayType.c_type, # Output, res[n].
    utils._EngineFloat64ArrayType.c_type, # Output, h[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, comm[9*n+14].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of mode.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of weight.
)

fit_spline_parest = utils._EngineState._get_symbol('g10acf')
fit_spline_parest.restype = None
fit_spline_parest.argtypes = (
    utils._BYREF_STRING, # Input, method(len=1).
    utils._BYREF_STRING, # Input, weight(len=1).
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._EngineFloat64ArrayType.c_type, # Input, wt[*].
    utils._EngineFloat64ArrayType.c_type, # Output, yhat[n].
    utils._EngineFloat64ArrayType.c_type, # Output, c[ldc, 3].
    utils._BYREF_INT, # Input, ldc.
    utils._BYREF_FLOAT64, # Output, rss.
    utils._BYREF_FLOAT64, # Output, df.
    utils._EngineFloat64ArrayType.c_type, # Output, res[n].
    utils._EngineFloat64ArrayType.c_type, # Output, h[n].
    utils._BYREF_FLOAT64, # Input/Output, crit.
    utils._BYREF_FLOAT64, # Output, rho.
    utils._BYREF_FLOAT64, # Input, u.
    utils._BYREF_FLOAT64, # Input, tol.
    utils._BYREF_INT, # Input, maxcal.
    utils._EngineFloat64ArrayType.c_type, # Workspace, wk[7*(n+2)].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of method.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of weight.
)

kerndens_gauss = utils._EngineState._get_symbol('g10bbf')
kerndens_gauss.restype = None
kerndens_gauss.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_INT, # Input, wtype.
    utils._BYREF_FLOAT64, # Input/Output, window.
    utils._BYREF_FLOAT64, # Input/Output, slo.
    utils._BYREF_FLOAT64, # Input/Output, shi.
    utils._BYREF_INT, # Input, ns.
    utils._EngineFloat64ArrayType.c_type, # Output, smooth[ns].
    utils._EngineFloat64ArrayType.c_type, # Output, t[ns].
    utils._BYREF_INT, # Input, fcall.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rcomm[ns+20].
    utils._BYREF_INT, # Input/Output, ifail.
)

data_runningmedian = utils._EngineState._get_symbol('g10caf')
data_runningmedian.restype = None
data_runningmedian.argtypes = (
    utils._BYREF_INT, # Input, itype.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._EngineFloat64ArrayType.c_type, # Output, smooth[n].
    utils._EngineFloat64ArrayType.c_type, # Output, rough[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

data_order = utils._EngineState._get_symbol('g10zaf')
data_order.restype = None
data_order.argtypes = (
    utils._BYREF_STRING, # Input, weight(len=1).
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Input, y[n].
    utils._EngineFloat64ArrayType.c_type, # Input, wt[*].
    utils._BYREF_INT, # Output, nord.
    utils._EngineFloat64ArrayType.c_type, # Output, xord[n].
    utils._EngineFloat64ArrayType.c_type, # Output, yord[n].
    utils._EngineFloat64ArrayType.c_type, # Output, wtord[n].
    utils._BYREF_FLOAT64, # Output, rss.
    utils._EngineIntArrayType.c_type, # Workspace, iwrk[n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of weight.
)
