# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `wav` Chapter.
"""

# NAG Copyright 2017-2020.

from ..base import utils

dim1_init = utils._EngineState._get_symbol('c09aaf')
dim1_init.restype = None
dim1_init.argtypes = (
    utils._BYREF_STRING, # Input, wavnam(len=*).
    utils._BYREF_STRING, # Input, wtrans(len=1).
    utils._BYREF_STRING, # Input, mode(len=1).
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Output, nwlmax.
    utils._BYREF_INT, # Output, nf.
    utils._BYREF_INT, # Output, nwc.
    utils._EngineIntArrayType.c_type, # Output, icomm[100].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of wavnam.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of wtrans.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of mode.
)

dim2_init = utils._EngineState._get_symbol('c09abf')
dim2_init.restype = None
dim2_init.argtypes = (
    utils._BYREF_STRING, # Input, wavnam(len=*).
    utils._BYREF_STRING, # Input, wtrans(len=1).
    utils._BYREF_STRING, # Input, mode(len=1).
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Output, nwlmax.
    utils._BYREF_INT, # Output, nf.
    utils._BYREF_INT, # Output, nwct.
    utils._BYREF_INT, # Output, nwcn.
    utils._EngineIntArrayType.c_type, # Output, icomm[180].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of wavnam.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of wtrans.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of mode.
)

dim3_init = utils._EngineState._get_symbol('c09acf')
dim3_init.restype = None
dim3_init.argtypes = (
    utils._BYREF_STRING, # Input, wavnam(len=*).
    utils._BYREF_STRING, # Input, wtrans(len=1).
    utils._BYREF_STRING, # Input, mode(len=1).
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, fr.
    utils._BYREF_INT, # Output, nwlmax.
    utils._BYREF_INT, # Output, nf.
    utils._BYREF_INT, # Output, nwct.
    utils._BYREF_INT, # Output, nwcn.
    utils._BYREF_INT, # Output, nwcfr.
    utils._EngineIntArrayType.c_type, # Output, icomm[260].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of wavnam.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of wtrans.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of mode.
)

dim1_cont = utils._EngineState._get_symbol('c09baf')
dim1_cont.restype = None
dim1_cont.argtypes = (
    utils._BYREF_STRING, # Input, wavnam(len=*).
    utils._BYREF_INT, # Input, wparam.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_INT, # Input, nscal.
    utils._EngineIntArrayType.c_type, # Input, scales[nscal].
    utils._EngineFloat64ArrayType.c_type, # Output, c[nscal, n].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of wavnam.
)

dim1_sngl_fwd = utils._EngineState._get_symbol('c09caf')
dim1_sngl_fwd.restype = None
dim1_sngl_fwd.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_INT, # Input, lenc.
    utils._EngineFloat64ArrayType.c_type, # Output, ca[lenc].
    utils._EngineFloat64ArrayType.c_type, # Output, cd[lenc].
    utils._EngineIntArrayType.c_type, # Input/Output, icomm[100].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim1_sngl_inv = utils._EngineState._get_symbol('c09cbf')
dim1_sngl_inv.restype = None
dim1_sngl_inv.argtypes = (
    utils._BYREF_INT, # Input, lenc.
    utils._EngineFloat64ArrayType.c_type, # Input, ca[lenc].
    utils._EngineFloat64ArrayType.c_type, # Input, cd[lenc].
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, y[n].
    utils._EngineIntArrayType.c_type, # Input, icomm[100].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim1_multi_fwd = utils._EngineState._get_symbol('c09ccf')
dim1_multi_fwd.restype = None
dim1_multi_fwd.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_INT, # Input, lenc.
    utils._EngineFloat64ArrayType.c_type, # Output, c[lenc].
    utils._BYREF_INT, # Input, nwl.
    utils._EngineIntArrayType.c_type, # Output, dwtlev[nwl+1].
    utils._EngineIntArrayType.c_type, # Input/Output, icomm[100].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim1_multi_inv = utils._EngineState._get_symbol('c09cdf')
dim1_multi_inv.restype = None
dim1_multi_inv.argtypes = (
    utils._BYREF_INT, # Input, nwlinv.
    utils._BYREF_INT, # Input, lenc.
    utils._EngineFloat64ArrayType.c_type, # Input, c[lenc].
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, y[n].
    utils._EngineIntArrayType.c_type, # Input, icomm[100].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim1_mxolap_fwd = utils._EngineState._get_symbol('c09daf')
dim1_mxolap_fwd.restype = None
dim1_mxolap_fwd.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_INT, # Input, lenc.
    utils._EngineFloat64ArrayType.c_type, # Output, ca[lenc].
    utils._EngineFloat64ArrayType.c_type, # Output, cd[lenc].
    utils._EngineIntArrayType.c_type, # Input/Output, icomm[100].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim1_mxolap_inv = utils._EngineState._get_symbol('c09dbf')
dim1_mxolap_inv.restype = None
dim1_mxolap_inv.argtypes = (
    utils._BYREF_INT, # Input, lenc.
    utils._EngineFloat64ArrayType.c_type, # Input, ca[lenc].
    utils._EngineFloat64ArrayType.c_type, # Input, cd[lenc].
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, y[n].
    utils._EngineIntArrayType.c_type, # Input, icomm[100].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim1_mxolap_multi_fwd = utils._EngineState._get_symbol('c09dcf')
dim1_mxolap_multi_fwd.restype = None
dim1_mxolap_multi_fwd.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_STRING, # Input, keepa(len=1).
    utils._BYREF_INT, # Input, lenc.
    utils._EngineFloat64ArrayType.c_type, # Output, c[lenc].
    utils._BYREF_INT, # Input, nwl.
    utils._BYREF_INT, # Output, na.
    utils._EngineIntArrayType.c_type, # Input/Output, icomm[100].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of keepa.
)

dim1_mxolap_multi_inv = utils._EngineState._get_symbol('c09ddf')
dim1_mxolap_multi_inv.restype = None
dim1_mxolap_multi_inv.argtypes = (
    utils._BYREF_INT, # Input, nwlinv.
    utils._BYREF_STRING, # Input, keepa(len=1).
    utils._BYREF_INT, # Input, lenc.
    utils._EngineFloat64ArrayType.c_type, # Input, c[lenc].
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, y[n].
    utils._EngineIntArrayType.c_type, # Input, icomm[100].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of keepa.
)

dim2_sngl_fwd = utils._EngineState._get_symbol('c09eaf')
dim2_sngl_fwd.restype = None
dim2_sngl_fwd.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, n].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Output, ca[ldca, *].
    utils._BYREF_INT, # Input, ldca.
    utils._EngineFloat64ArrayType.c_type, # Output, ch[ldch, *].
    utils._BYREF_INT, # Input, ldch.
    utils._EngineFloat64ArrayType.c_type, # Output, cv[ldcv, *].
    utils._BYREF_INT, # Input, ldcv.
    utils._EngineFloat64ArrayType.c_type, # Output, cd[ldcd, *].
    utils._BYREF_INT, # Input, ldcd.
    utils._EngineIntArrayType.c_type, # Input/Output, icomm[180].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim2_sngl_inv = utils._EngineState._get_symbol('c09ebf')
dim2_sngl_inv.restype = None
dim2_sngl_inv.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, ca[ldca, *].
    utils._BYREF_INT, # Input, ldca.
    utils._EngineFloat64ArrayType.c_type, # Input, ch[ldch, *].
    utils._BYREF_INT, # Input, ldch.
    utils._EngineFloat64ArrayType.c_type, # Input, cv[ldcv, *].
    utils._BYREF_INT, # Input, ldcv.
    utils._EngineFloat64ArrayType.c_type, # Input, cd[ldcd, *].
    utils._BYREF_INT, # Input, ldcd.
    utils._EngineFloat64ArrayType.c_type, # Output, b[ldb, n].
    utils._BYREF_INT, # Input, ldb.
    utils._EngineIntArrayType.c_type, # Input, icomm[180].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim2_multi_fwd = utils._EngineState._get_symbol('c09ecf')
dim2_multi_fwd.restype = None
dim2_multi_fwd.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, n].
    utils._BYREF_INT, # Input, lda.
    utils._BYREF_INT, # Input, lenc.
    utils._EngineFloat64ArrayType.c_type, # Output, c[lenc].
    utils._BYREF_INT, # Input, nwl.
    utils._EngineIntArrayType.c_type, # Output, dwtlvm[nwl].
    utils._EngineIntArrayType.c_type, # Output, dwtlvn[nwl].
    utils._EngineIntArrayType.c_type, # Input/Output, icomm[180].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim2_multi_inv = utils._EngineState._get_symbol('c09edf')
dim2_multi_inv.restype = None
dim2_multi_inv.argtypes = (
    utils._BYREF_INT, # Input, nwlinv.
    utils._BYREF_INT, # Input, lenc.
    utils._EngineFloat64ArrayType.c_type, # Input, c[lenc].
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Output, b[ldb, n].
    utils._BYREF_INT, # Input, ldb.
    utils._EngineIntArrayType.c_type, # Input, icomm[180].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim2_coeff_ext = utils._EngineState._get_symbol('c09eyf')
dim2_coeff_ext.restype = None
dim2_coeff_ext.argtypes = (
    utils._BYREF_INT, # Input, ilev.
    utils._BYREF_INT, # Input, cindex.
    utils._BYREF_INT, # Input, lenc.
    utils._EngineFloat64ArrayType.c_type, # Input, c[lenc].
    utils._EngineFloat64ArrayType.c_type, # Output, d[ldd, *].
    utils._BYREF_INT, # Input, ldd.
    utils._EngineIntArrayType.c_type, # Input/Output, icomm[180].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim2_coeff_ins = utils._EngineState._get_symbol('c09ezf')
dim2_coeff_ins.restype = None
dim2_coeff_ins.argtypes = (
    utils._BYREF_INT, # Input, ilev.
    utils._BYREF_INT, # Input, cindex.
    utils._BYREF_INT, # Input, lenc.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, c[lenc].
    utils._EngineFloat64ArrayType.c_type, # Input, d[ldd, *].
    utils._BYREF_INT, # Input, ldd.
    utils._EngineIntArrayType.c_type, # Input/Output, icomm[180].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim3_sngl_fwd = utils._EngineState._get_symbol('c09faf')
dim3_sngl_fwd.restype = None
dim3_sngl_fwd.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, fr.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, sda, fr].
    utils._BYREF_INT, # Input, lda.
    utils._BYREF_INT, # Input, sda.
    utils._BYREF_INT, # Input, lenc.
    utils._EngineFloat64ArrayType.c_type, # Output, c[lenc].
    utils._EngineIntArrayType.c_type, # Input/Output, icomm[260].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim3_sngl_inv = utils._EngineState._get_symbol('c09fbf')
dim3_sngl_inv.restype = None
dim3_sngl_inv.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, fr.
    utils._BYREF_INT, # Input, lenc.
    utils._EngineFloat64ArrayType.c_type, # Input, c[lenc].
    utils._EngineFloat64ArrayType.c_type, # Output, b[ldb, sdb, fr].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_INT, # Input, sdb.
    utils._EngineIntArrayType.c_type, # Input, icomm[260].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim3_multi_fwd = utils._EngineState._get_symbol('c09fcf')
dim3_multi_fwd.restype = None
dim3_multi_fwd.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, fr.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, sda, fr].
    utils._BYREF_INT, # Input, lda.
    utils._BYREF_INT, # Input, sda.
    utils._BYREF_INT, # Input, lenc.
    utils._EngineFloat64ArrayType.c_type, # Output, c[lenc].
    utils._BYREF_INT, # Input, nwl.
    utils._EngineIntArrayType.c_type, # Output, dwtlvm[nwl].
    utils._EngineIntArrayType.c_type, # Output, dwtlvn[nwl].
    utils._EngineIntArrayType.c_type, # Output, dwtlvfr[nwl].
    utils._EngineIntArrayType.c_type, # Input/Output, icomm[260].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim3_mxolap_multi_inv = utils._EngineState._get_symbol('c09fdf')
dim3_mxolap_multi_inv.restype = None
dim3_mxolap_multi_inv.argtypes = (
    utils._BYREF_INT, # Input, nwlinv.
    utils._BYREF_INT, # Input, lenc.
    utils._EngineFloat64ArrayType.c_type, # Input, c[lenc].
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, fr.
    utils._EngineFloat64ArrayType.c_type, # Output, b[ldb, sdb, fr].
    utils._BYREF_INT, # Input, ldb.
    utils._BYREF_INT, # Input, sdb.
    utils._EngineIntArrayType.c_type, # Input, icomm[260].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim3_coeff_ext = utils._EngineState._get_symbol('c09fyf')
dim3_coeff_ext.restype = None
dim3_coeff_ext.argtypes = (
    utils._BYREF_INT, # Input, ilev.
    utils._BYREF_INT, # Input, cindex.
    utils._BYREF_INT, # Input, lenc.
    utils._EngineFloat64ArrayType.c_type, # Input, c[lenc].
    utils._EngineFloat64ArrayType.c_type, # Output, d[ldd, sdd, *].
    utils._BYREF_INT, # Input, ldd.
    utils._BYREF_INT, # Input, sdd.
    utils._EngineIntArrayType.c_type, # Input/Output, icomm[260].
    utils._BYREF_INT, # Input/Output, ifail.
)

dim3_coeff_ins = utils._EngineState._get_symbol('c09fzf')
dim3_coeff_ins.restype = None
dim3_coeff_ins.argtypes = (
    utils._BYREF_INT, # Input, ilev.
    utils._BYREF_INT, # Input, cindex.
    utils._BYREF_INT, # Input, lenc.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, c[lenc].
    utils._EngineFloat64ArrayType.c_type, # Input, d[ldd, sdd, *].
    utils._BYREF_INT, # Input, ldd.
    utils._BYREF_INT, # Input, sdd.
    utils._EngineIntArrayType.c_type, # Input/Output, icomm[260].
    utils._BYREF_INT, # Input/Output, ifail.
)
