# -*- coding: utf-8 -*-
u"""
Examples for the ``glopt`` module.

``glopt`` - Global Optimization of a Function

Global optimization involves finding the absolute maximum or minimum
value of a function (the `objective function`) of several variables,
possibly subject to restrictions (defined by a set of bounds or
`constraint functions`) on the values of the variables.
Such problems can be much harder to solve than local optimization
problems (which are discussed in submodule ``opt``) because it is
difficult to determine whether a potential optimum found is global, and
because of the nonlocal methods required to avoid becoming trapped near
local optima.
Most optimization functions in the NAG Library are concerned with
function **minimization** only, since the problem of maximizing a given
objective function F is equivalent to minimizing -F.
In ``bnd_mcs_solve``, ``bnd_pso`` and ``nlp_pso``, you may specify
whether you are solving a minimization or maximization problem; in the
latter case, the required transformation of the objective function will
be carried out automatically.
In what follows we refer exclusively to minimization problems.

This introduction is a brief guide to the subject of global
optimization, designed for the casual user.
For further details you may find it beneficial to consult a more
detailed text, see Neumaier (2004).
Furthermore, much of the material in [the E04 Introduction] is also
relevant in this context and it is strongly recommended that you read
[the E04 Introduction].

For full information please refer to the NAG Library document

https://www.nag.com/numeric/nl/nagdoc_27/flhtml/e05/e05intro.html
"""

# NAG Copyright 2017-2020.

pass
