# -*- coding: utf-8 -*-
u"""
Examples for the ``inteq`` module.

``inteq`` - Integral Equations

This module is concerned with the numerical solution of integral
equations.
Provision will be made for most of the standard types of equation (see
[Background to the Problems]).
The following are, however, specifically excluded:

(a) Equations arising in the solution of partial differential equations
    by integral equation methods. In cases where the prime purpose of an
    algorithm is the solution of a partial differential equation it will
    normally be included in submodule ``pde``.

(#) Calculation of inverse integral transforms. This problem falls
    within the scope of submodule ``sum``.

For full information please refer to the NAG Library document

https://www.nag.com/numeric/nl/nagdoc_27/flhtml/d05/d05intro.html
"""

# NAG Copyright 2017-2020.

pass
