# -*- coding: utf-8 -*-
u"""
Examples for the ``machine`` module.

``machine`` - Machine Constants

This module is concerned with **parameters** which characterise certain
aspects of the **computing environment** in which the NAG Library is
implemented.
They relate primarily to floating-point arithmetic, but also to integer
arithmetic, the elementary functions and exception handling.
The values of the parameters vary from one implementation of the NAG
Library to another, but within the context of a single implementation
they are constants.

The parameters are intended for use primarily by other functions in the
NAG Library, but users of the NAG Library may sometimes need to refer to
them directly.

For full information please refer to the NAG Library document

https://www.nag.com/numeric/nl/nagdoc_27/flhtml/x02/x02intro.html
"""

# NAG Copyright 2017-2020.

pass
