# -*- coding: utf-8 -*-
u"""
Examples for the ``nonpar`` module.

``nonpar`` - Nonparametric Statistics

The functions in this module perform nonparametric statistical tests
which are based on distribution-free methods of analysis.
For convenience, the module contents are divided into five types of
test: tests of location, tests of dispersion, tests of distribution,
tests of association and correlation, and tests of randomness.
There are also functions to fit linear regression models using the ranks
of the observations.

The emphasis in this module is on testing; if you wish to compute
nonparametric correlations you are referred to submodule ``correg``,
which contains several functions for that purpose.

There are a large number of nonparametric tests available.
A selection of some of the more commonly used tests are included in this
module.

For full information please refer to the NAG Library document

https://www.nag.com/numeric/nl/nagdoc_27/flhtml/g08/g08intro.html
"""

# NAG Copyright 2017-2020.

pass
