# -*- coding: utf-8 -*-
u"""
Examples for the ``sum`` module.

``sum`` - Summation of Series

This module is concerned with the following tasks:

(a) calculating the **discrete Fourier transform** of a sequence of real
    or complex data values;

(#) calculating the **discrete convolution** or the **discrete
    correlation** of two sequences of real or complex data values using
    discrete Fourier transforms;

(#) calculating the **inverse Laplace transform** of a user-supplied
    function;

(#) calculating the **fast Gauss transform** approximation to the
    **discrete Gauss transform**;

(#) direct summation of orthogonal series;

(#) acceleration of convergence of a sequence of real values.

For full information please refer to the NAG Library document

https://www.nag.com/numeric/nl/nagdoc_27/flhtml/c06/c06intro.html
"""

# NAG Copyright 2017-2020.

pass
