# -*- coding: utf-8 -*-
u"""
Examples for the ``tsa`` module.

``tsa`` - Time Series Analysis

This module provides facilities for investigating and modelling the
statistical structure of series of observations collected at points in
time.
The models may then be used to forecast the series.

The module covers the following models and approaches:

(1) univariate time series analysis, including autocorrelation functions
    and autoregressive moving average (ARMA) models;

(#) univariate spectral analysis;

(#) transfer function (multi-input) modelling, in which one time series
    is dependent on other time series;

(#) bivariate spectral methods including coherency, gain and input
    response functions;

(#) vector ARMA models for multivariate time series;

(#) Kalman filter models (linear and nonlinear);

(#) GARCH models for volatility;

(#) inhomogeneous time series.

For full information please refer to the NAG Library document

https://www.nag.com/numeric/nl/nagdoc_27/flhtml/g13/g13intro.html
"""

# NAG Copyright 2017-2020.

pass
