#!/usr/bin/env python
"""
Integration test utilities for wrapper functionality in the naginterfaces
package.

Public use of this module is not supported by NAG.
"""

# NAG Copyright 2017-2019.

# pylint: disable=invalid-name

import sys

class IntegrationTest(object):
    """
    Abstract suite for integration tests.
    """

    # pylint: disable=too-few-public-methods

    def set_up(self):
        # pylint: disable=attribute-defined-outside-init,missing-docstring,no-member

        if sys.version_info < (3,):
            self.my_assert_regex = self.assertRegexpMatches
            self.my_assert_raises_regex = self.assertRaisesRegexp
        else:
            self.my_assert_regex = self.assertRegex
            self.my_assert_raises_regex = self.assertRaisesRegex
