#!/usr/bin/env python
"""
Integration tests for wrapper functionality in the ieee submodule.

Public use of this module is not supported by NAG.
"""

# NAG Copyright 2018-2019.

# pylint: disable=invalid-name

import unittest

from naginterfaces.library import ieee as chap
from test_functionality_core import IntegrationTest

class TestX07aa(IntegrationTest): # pylint: disable=too-few-public-methods
    """
    Abstract suite of integration tests for the x07aa wrapper.
    """

class TestX07aaNp(TestX07aa, unittest.TestCase):
    """
    Concrete level-2 tests.
    """

    def setUp(self):
        TestX07aa.set_up(self)
        self.fun = chap.is_finite

    def test_good(self):
        """
        Good call.
        """
        self.assertTrue(self.fun(42.))

class TestX07ab(IntegrationTest): # pylint: disable=too-few-public-methods
    """
    Abstract suite of integration tests for the x07ab wrapper.
    """

class TestX07abNp(TestX07ab, unittest.TestCase):
    """
    Concrete level-2 tests.
    """

    def setUp(self):
        TestX07ab.set_up(self)
        self.fun = chap.is_nan

    def test_good(self):
        """
        Good call.
        """
        self.assertFalse(self.fun(42.))

if __name__ == '__main__': # pragma: no cover
    unittest.main()
