# -*- coding: utf-8 -*-
# pylint: disable=invalid-name,line-too-long,protected-access,too-many-locals
# pylint: disable=too-many-lines
"""
Primitive ``ctypes`` prototypes for the NAG Library `opt` Chapter.
"""

# NAG Copyright 2017-2020.

from ..base import utils

one_var_func_funct = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, xc.
    utils._BYREF_FLOAT64, # Output, fc.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
one_var_func = utils._EngineState._get_symbol('e04aba')
one_var_func.restype = None
one_var_func.argtypes = (
    one_var_func_funct,
    utils._BYREF_FLOAT64, # Input/Output, e1.
    utils._BYREF_FLOAT64, # Input/Output, e2.
    utils._BYREF_FLOAT64, # Input/Output, a.
    utils._BYREF_FLOAT64, # Input/Output, b.
    utils._BYREF_INT, # Input/Output, maxcal.
    utils._BYREF_FLOAT64, # Output, x.
    utils._BYREF_FLOAT64, # Output, f.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

one_var_func_old_funct = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, xc.
    utils._BYREF_FLOAT64, # Output, fc.
)
one_var_func_old = utils._EngineState._get_symbol('e04abf')
one_var_func_old.restype = None
one_var_func_old.argtypes = (
    one_var_func_old_funct,
    utils._BYREF_FLOAT64, # Input/Output, e1.
    utils._BYREF_FLOAT64, # Input/Output, e2.
    utils._BYREF_FLOAT64, # Input/Output, a.
    utils._BYREF_FLOAT64, # Input/Output, b.
    utils._BYREF_INT, # Input/Output, maxcal.
    utils._BYREF_FLOAT64, # Output, x.
    utils._BYREF_FLOAT64, # Output, f.
    utils._BYREF_INT, # Input/Output, ifail.
)

one_var_deriv_funct = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, xc.
    utils._BYREF_FLOAT64, # Output, fc.
    utils._BYREF_FLOAT64, # Output, gc.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
one_var_deriv = utils._EngineState._get_symbol('e04bba')
one_var_deriv.restype = None
one_var_deriv.argtypes = (
    one_var_deriv_funct,
    utils._BYREF_FLOAT64, # Input/Output, e1.
    utils._BYREF_FLOAT64, # Input/Output, e2.
    utils._BYREF_FLOAT64, # Input/Output, a.
    utils._BYREF_FLOAT64, # Input/Output, b.
    utils._BYREF_INT, # Input/Output, maxcal.
    utils._BYREF_FLOAT64, # Output, x.
    utils._BYREF_FLOAT64, # Output, f.
    utils._BYREF_FLOAT64, # Output, g.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

one_var_deriv_old_funct = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, xc.
    utils._BYREF_FLOAT64, # Output, fc.
    utils._BYREF_FLOAT64, # Output, gc.
)
one_var_deriv_old = utils._EngineState._get_symbol('e04bbf')
one_var_deriv_old.restype = None
one_var_deriv_old.argtypes = (
    one_var_deriv_old_funct,
    utils._BYREF_FLOAT64, # Input/Output, e1.
    utils._BYREF_FLOAT64, # Input/Output, e2.
    utils._BYREF_FLOAT64, # Input/Output, a.
    utils._BYREF_FLOAT64, # Input/Output, b.
    utils._BYREF_INT, # Input/Output, maxcal.
    utils._BYREF_FLOAT64, # Output, x.
    utils._BYREF_FLOAT64, # Output, f.
    utils._BYREF_FLOAT64, # Output, g.
    utils._BYREF_INT, # Input/Output, ifail.
)

uncon_simplex_funct = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._BYREF_FLOAT64, # Output, fc.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
uncon_simplex_monit = utils._EngineState._sys_functype(
    None,
    utils._BYREF_FLOAT64, # Input, fmin.
    utils._BYREF_FLOAT64, # Input, fmax.
    utils._EngineFloat64ArrayType.c_type, # Input, sim[n+1, n].
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ncall.
    utils._BYREF_FLOAT64, # Input, serror.
    utils._BYREF_FLOAT64, # Input, vratio.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
uncon_simplex = utils._EngineState._get_symbol('e04cbf')
uncon_simplex.restype = None
uncon_simplex.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, f.
    utils._BYREF_FLOAT64, # Input, tolf.
    utils._BYREF_FLOAT64, # Input, tolx.
    uncon_simplex_funct,
    uncon_simplex_monit,
    utils._BYREF_INT, # Input, maxcal.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

uncon_simplex_dummy_monit = utils._EngineState._get_symbol('e04cbk')
uncon_simplex_dummy_monit.restype = None
uncon_simplex_dummy_monit.argtypes = (
    utils._BYREF_FLOAT64, # Input, fmin.
    utils._BYREF_FLOAT64, # Input, fmax.
    utils._EngineFloat64ArrayType.c_type, # Input, sim[n+1, n].
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ncall.
    utils._BYREF_FLOAT64, # Input, serror.
    utils._BYREF_FLOAT64, # Input, vratio.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)

uncon_conjgrd_comp_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Output, objgrd[n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
uncon_conjgrd_comp = utils._EngineState._get_symbol('e04dga')
uncon_conjgrd_comp.restype = None
uncon_conjgrd_comp.argtypes = (
    utils._BYREF_INT, # Input, n.
    uncon_conjgrd_comp_objfun,
    utils._BYREF_INT, # Output, iter.
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Output, objgrd[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[n+1].
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[13*n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[120].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[475].
    utils._BYREF_INT, # Input/Output, ifail.
)

uncon_conjgrd_comp_old_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Output, objgrd[n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
uncon_conjgrd_comp_old = utils._EngineState._get_symbol('e04dgf')
uncon_conjgrd_comp_old.restype = None
uncon_conjgrd_comp_old.argtypes = (
    utils._BYREF_INT, # Input, n.
    uncon_conjgrd_comp_old_objfun,
    utils._BYREF_INT, # Output, iter.
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Output, objgrd[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[n+1].
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[13*n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

uncon_conjgrd_option_file = utils._EngineState._get_symbol('e04dja')
uncon_conjgrd_option_file.restype = None
uncon_conjgrd_option_file.argtypes = (
    utils._BYREF_INT, # Input, ioptns.
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[120].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[475].
    utils._BYREF_INT, # Output, inform.
)

uncon_conjgrd_option_file_old = utils._EngineState._get_symbol('e04djf')
uncon_conjgrd_option_file_old.restype = None
uncon_conjgrd_option_file_old.argtypes = (
    utils._BYREF_INT, # Input, ioptns.
    utils._BYREF_INT, # Output, inform.
)

uncon_conjgrd_option_string = utils._EngineState._get_symbol('e04dka')
uncon_conjgrd_option_string.restype = None
uncon_conjgrd_option_string.argtypes = (
    utils._BYREF_STRING, # Input, str(len=*).
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[120].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[475].
    utils._BYREF_INT, # Output, inform.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of str.
)

uncon_conjgrd_option_string_old = utils._EngineState._get_symbol('e04dkf')
uncon_conjgrd_option_string_old.restype = None
uncon_conjgrd_option_string_old.argtypes = (
    utils._BYREF_STRING, # Input, str(len=*).
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of str.
)

lsq_uncon_mod_func_comp_lsqfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, iflag.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[m].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
lsq_uncon_mod_func_comp_lsqmon = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Input, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Input, fjac[ldfjac, n].
    utils._BYREF_INT, # Input, ldfjac.
    utils._EngineFloat64ArrayType.c_type, # Input, s[n].
    utils._BYREF_INT, # Input, igrade.
    utils._BYREF_INT, # Input, niter.
    utils._BYREF_INT, # Input, nf.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
lsq_uncon_mod_func_comp = utils._EngineState._get_symbol('e04fcf')
lsq_uncon_mod_func_comp.restype = None
lsq_uncon_mod_func_comp.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    lsq_uncon_mod_func_comp_lsqfun,
    lsq_uncon_mod_func_comp_lsqmon,
    utils._BYREF_INT, # Input, iprint.
    utils._BYREF_INT, # Input, maxcal.
    utils._BYREF_FLOAT64, # Input, eta.
    utils._BYREF_FLOAT64, # Input, xtol.
    utils._BYREF_FLOAT64, # Input, stepmx.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, fsumsq.
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Output, fjac[ldfjac, n].
    utils._BYREF_INT, # Input, ldfjac.
    utils._EngineFloat64ArrayType.c_type, # Output, s[n].
    utils._EngineFloat64ArrayType.c_type, # Output, v[ldv, n].
    utils._BYREF_INT, # Input, ldv.
    utils._BYREF_INT, # Output, niter.
    utils._BYREF_INT, # Output, nf.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._BYREF_INT, # Input/Output, ifail.
)

lsq_uncon_quasi_deriv_comp_lsqlin_fun = utils._EngineState._get_symbol('e04fcv')
lsq_uncon_quasi_deriv_comp_lsqlin_fun.restype = None
lsq_uncon_quasi_deriv_comp_lsqlin_fun.argtypes = (
    utils._BYREF_INT, # Output, selct.
)

lsq_dummy_lsqmon = utils._EngineState._get_symbol('e04fdz')
lsq_dummy_lsqmon.restype = None
lsq_dummy_lsqmon.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Input, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Input, fjac[ldfjac, n].
    utils._BYREF_INT, # Input, ldfjac.
    utils._EngineFloat64ArrayType.c_type, # Input, s[n].
    utils._BYREF_INT, # Input, igrade.
    utils._BYREF_INT, # Input, niter.
    utils._BYREF_INT, # Input, nf.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)

handle_solve_dfls_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_INT, # Input, nres.
    utils._EngineFloat64ArrayType.c_type, # Output, rx[nres].
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)
handle_solve_dfls_monit = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineFloat64ArrayType.c_type, # Input, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Input, stats[100].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)
handle_solve_dfls = utils._EngineState._get_symbol('e04fff')
handle_solve_dfls.restype = None
handle_solve_dfls.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    handle_solve_dfls_objfun,
    handle_solve_dfls_monit,
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[nvar].
    utils._BYREF_INT, # Input, nres.
    utils._EngineFloat64ArrayType.c_type, # Output, rx[nres].
    utils._EngineFloat64ArrayType.c_type, # Output, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Output, stats[100].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
    utils._BYREF_INT, # Input/Output, ifail.
)

bobyqa_ls_dummy_monit = utils._EngineState._get_symbol('e04ffu')
bobyqa_ls_dummy_monit.restype = None
bobyqa_ls_dummy_monit.argtypes = (
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineFloat64ArrayType.c_type, # Input, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Input, stats[100].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)

handle_solve_dfls_rcomm = utils._EngineState._get_symbol('e04fgf')
handle_solve_dfls_rcomm.restype = None
handle_solve_dfls_rcomm.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_INT, # Input/Output, irevcm.
    utils._BYREF_INT, # Output, neval.
    utils._BYREF_INT, # Input, maxeval.
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[nvar, maxeval].
    utils._BYREF_INT, # Input, nres.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rx[nres, maxeval].
    utils._EngineFloat64ArrayType.c_type, # Output, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Output, stats[100].
    utils._BYREF_INT, # Input/Output, ifail.
)

lsq_uncon_mod_func_easy_lsfun1 = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[m].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
lsq_uncon_mod_func_easy = utils._EngineState._get_symbol('e04fyf')
lsq_uncon_mod_func_easy.restype = None
lsq_uncon_mod_func_easy.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    lsq_uncon_mod_func_easy_lsfun1,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, fsumsq.
    utils._EngineFloat64ArrayType.c_type, # Output, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

lsq_uncon_quasi_deriv_comp_lsqlin = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Output, selct.
)
lsq_uncon_quasi_deriv_comp_lsqfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, iflag.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Output, fjac[ldfjac, n].
    utils._BYREF_INT, # Input, ldfjac.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
lsq_uncon_quasi_deriv_comp_lsqmon = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Input, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Input, fjac[ldfjac, n].
    utils._BYREF_INT, # Input, ldfjac.
    utils._EngineFloat64ArrayType.c_type, # Input, s[n].
    utils._BYREF_INT, # Input, igrade.
    utils._BYREF_INT, # Input, niter.
    utils._BYREF_INT, # Input, nf.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
lsq_uncon_quasi_deriv_comp = utils._EngineState._get_symbol('e04gbf')
lsq_uncon_quasi_deriv_comp.restype = None
lsq_uncon_quasi_deriv_comp.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    lsq_uncon_quasi_deriv_comp_lsqlin,
    lsq_uncon_quasi_deriv_comp_lsqfun,
    lsq_uncon_quasi_deriv_comp_lsqmon,
    utils._BYREF_INT, # Input, iprint.
    utils._BYREF_INT, # Input, maxcal.
    utils._BYREF_FLOAT64, # Input, eta.
    utils._BYREF_FLOAT64, # Input, xtol.
    utils._BYREF_FLOAT64, # Input, stepmx.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, fsumsq.
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Output, fjac[ldfjac, n].
    utils._BYREF_INT, # Input, ldfjac.
    utils._EngineFloat64ArrayType.c_type, # Output, s[n].
    utils._EngineFloat64ArrayType.c_type, # Output, v[ldv, n].
    utils._BYREF_INT, # Input, ldv.
    utils._BYREF_INT, # Output, niter.
    utils._BYREF_INT, # Output, nf.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._BYREF_INT, # Input/Output, ifail.
)

lsq_uncon_mod_deriv_comp_lsqfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, iflag.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Output, fjac[ldfjac, n].
    utils._BYREF_INT, # Input, ldfjac.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
lsq_uncon_mod_deriv_comp_lsqmon = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Input, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Input, fjac[ldfjac, n].
    utils._BYREF_INT, # Input, ldfjac.
    utils._EngineFloat64ArrayType.c_type, # Input, s[n].
    utils._BYREF_INT, # Input, igrade.
    utils._BYREF_INT, # Input, niter.
    utils._BYREF_INT, # Input, nf.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
lsq_uncon_mod_deriv_comp = utils._EngineState._get_symbol('e04gdf')
lsq_uncon_mod_deriv_comp.restype = None
lsq_uncon_mod_deriv_comp.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    lsq_uncon_mod_deriv_comp_lsqfun,
    lsq_uncon_mod_deriv_comp_lsqmon,
    utils._BYREF_INT, # Input, iprint.
    utils._BYREF_INT, # Input, maxcal.
    utils._BYREF_FLOAT64, # Input, eta.
    utils._BYREF_FLOAT64, # Input, xtol.
    utils._BYREF_FLOAT64, # Input, stepmx.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, fsumsq.
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Output, fjac[ldfjac, n].
    utils._BYREF_INT, # Input, ldfjac.
    utils._EngineFloat64ArrayType.c_type, # Output, s[n].
    utils._EngineFloat64ArrayType.c_type, # Output, v[ldv, n].
    utils._BYREF_INT, # Input, ldv.
    utils._BYREF_INT, # Output, niter.
    utils._BYREF_INT, # Output, nf.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._BYREF_INT, # Input/Output, ifail.
)

lsq_uncon_quasi_deriv_easy_lsfun2 = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Output, fjac[ldfjac, n].
    utils._BYREF_INT, # Input, ldfjac.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
lsq_uncon_quasi_deriv_easy = utils._EngineState._get_symbol('e04gyf')
lsq_uncon_quasi_deriv_easy.restype = None
lsq_uncon_quasi_deriv_easy.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    lsq_uncon_quasi_deriv_easy_lsfun2,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, fsumsq.
    utils._EngineFloat64ArrayType.c_type, # Output, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

lsq_uncon_mod_deriv_easy_lsfun2 = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Output, fjac[ldfjac, n].
    utils._BYREF_INT, # Input, ldfjac.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
lsq_uncon_mod_deriv_easy = utils._EngineState._get_symbol('e04gzf')
lsq_uncon_mod_deriv_easy.restype = None
lsq_uncon_mod_deriv_easy.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    lsq_uncon_mod_deriv_easy_lsfun2,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, fsumsq.
    utils._EngineFloat64ArrayType.c_type, # Output, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

check_deriv_funct = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, iflag.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._BYREF_FLOAT64, # Output, fc.
    utils._EngineFloat64ArrayType.c_type, # Output, gc[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
check_deriv = utils._EngineState._get_symbol('e04hcf')
check_deriv.restype = None
check_deriv.argtypes = (
    utils._BYREF_INT, # Input, n.
    check_deriv_funct,
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_FLOAT64, # Output, f.
    utils._EngineFloat64ArrayType.c_type, # Output, g[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._BYREF_INT, # Input/Output, ifail.
)

check_deriv2_funct = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, iflag.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._BYREF_FLOAT64, # Output, fc.
    utils._EngineFloat64ArrayType.c_type, # Output, gc[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
check_deriv2_h = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, iflag.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fhesl[lh].
    utils._BYREF_INT, # Input, lh.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fhesd[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
check_deriv2 = utils._EngineState._get_symbol('e04hdf')
check_deriv2.restype = None
check_deriv2.argtypes = (
    utils._BYREF_INT, # Input, n.
    check_deriv2_funct,
    check_deriv2_h,
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, g[n].
    utils._EngineFloat64ArrayType.c_type, # Output, hesl[lh].
    utils._BYREF_INT, # Input, lh.
    utils._EngineFloat64ArrayType.c_type, # Output, hesd[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._BYREF_INT, # Input/Output, ifail.
)

lsq_uncon_mod_deriv2_comp_lsqfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, iflag.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Output, fjac[ldfjac, n].
    utils._BYREF_INT, # Input, ldfjac.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
lsq_uncon_mod_deriv2_comp_lsqhes = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, iflag.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Output, b[lb].
    utils._BYREF_INT, # Input, lb.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
lsq_uncon_mod_deriv2_comp_lsqmon = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Input, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Input, fjac[ldfjac, n].
    utils._BYREF_INT, # Input, ldfjac.
    utils._EngineFloat64ArrayType.c_type, # Input, s[n].
    utils._BYREF_INT, # Input, igrade.
    utils._BYREF_INT, # Input, niter.
    utils._BYREF_INT, # Input, nf.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
lsq_uncon_mod_deriv2_comp = utils._EngineState._get_symbol('e04hef')
lsq_uncon_mod_deriv2_comp.restype = None
lsq_uncon_mod_deriv2_comp.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    lsq_uncon_mod_deriv2_comp_lsqfun,
    lsq_uncon_mod_deriv2_comp_lsqhes,
    lsq_uncon_mod_deriv2_comp_lsqmon,
    utils._BYREF_INT, # Input, iprint.
    utils._BYREF_INT, # Input, maxcal.
    utils._BYREF_FLOAT64, # Input, eta.
    utils._BYREF_FLOAT64, # Input, xtol.
    utils._BYREF_FLOAT64, # Input, stepmx.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, fsumsq.
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Output, fjac[ldfjac, n].
    utils._BYREF_INT, # Input, ldfjac.
    utils._EngineFloat64ArrayType.c_type, # Output, s[n].
    utils._EngineFloat64ArrayType.c_type, # Output, v[ldv, n].
    utils._BYREF_INT, # Input, ldv.
    utils._BYREF_INT, # Output, niter.
    utils._BYREF_INT, # Output, nf.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._BYREF_INT, # Input/Output, ifail.
)

lsq_uncon_quasi_deriv_comp_lsqlin_deriv = utils._EngineState._get_symbol('e04hev')
lsq_uncon_quasi_deriv_comp_lsqlin_deriv.restype = None
lsq_uncon_quasi_deriv_comp_lsqlin_deriv.argtypes = (
    utils._BYREF_INT, # Output, selct.
)

lsq_uncon_mod_deriv2_easy_lsfun2 = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Output, fjac[ldfjac, n].
    utils._BYREF_INT, # Input, ldfjac.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
lsq_uncon_mod_deriv2_easy_lshes2 = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Output, b[lb].
    utils._BYREF_INT, # Input, lb.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
lsq_uncon_mod_deriv2_easy = utils._EngineState._get_symbol('e04hyf')
lsq_uncon_mod_deriv2_easy.restype = None
lsq_uncon_mod_deriv2_easy.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    lsq_uncon_mod_deriv2_easy_lsfun2,
    lsq_uncon_mod_deriv2_easy_lshes2,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, fsumsq.
    utils._EngineFloat64ArrayType.c_type, # Output, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

bounds_bobyqa_func_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_FLOAT64, # Output, f.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Output, inform.
)
bounds_bobyqa_func_monfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nf.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_FLOAT64, # Input, f.
    utils._BYREF_FLOAT64, # Input, rho.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Output, inform.
)
bounds_bobyqa_func = utils._EngineState._get_symbol('e04jcf')
bounds_bobyqa_func.restype = None
bounds_bobyqa_func.argtypes = (
    bounds_bobyqa_func_objfun,
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, npt.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n].
    utils._BYREF_FLOAT64, # Input, rhobeg.
    utils._BYREF_FLOAT64, # Input, rhoend.
    bounds_bobyqa_func_monfun,
    utils._BYREF_INT, # Input, maxcal.
    utils._BYREF_FLOAT64, # Output, f.
    utils._BYREF_INT, # Output, nf.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

bounds_bobyqa_func_dummy_monfun = utils._EngineState._get_symbol('e04jcp')
bounds_bobyqa_func_dummy_monfun.restype = None
bounds_bobyqa_func_dummy_monfun.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nf.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_FLOAT64, # Input, f.
    utils._BYREF_FLOAT64, # Input, rho.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Output, inform.
)

handle_solve_dfno_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_FLOAT64, # Output, fx.
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)
handle_solve_dfno_monit = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineFloat64ArrayType.c_type, # Input, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Input, stats[100].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)
handle_solve_dfno = utils._EngineState._get_symbol('e04jdf')
handle_solve_dfno.restype = None
handle_solve_dfno.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    handle_solve_dfno_objfun,
    handle_solve_dfno_monit,
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[nvar].
    utils._EngineFloat64ArrayType.c_type, # Output, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Output, stats[100].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
    utils._BYREF_INT, # Input/Output, ifail.
)

dfno_dummy_monit = utils._EngineState._get_symbol('e04jdu')
dfno_dummy_monit.restype = None
dfno_dummy_monit.argtypes = (
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineFloat64ArrayType.c_type, # Input, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Input, stats[100].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)

handle_solve_dfno_rcomm = utils._EngineState._get_symbol('e04jef')
handle_solve_dfno_rcomm.restype = None
handle_solve_dfno_rcomm.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_INT, # Input/Output, irevcm.
    utils._BYREF_INT, # Output, neval.
    utils._BYREF_INT, # Input, maxeval.
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[nvar, maxeval].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, f[maxeval].
    utils._EngineFloat64ArrayType.c_type, # Output, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Output, stats[100].
    utils._BYREF_INT, # Input/Output, ifail.
)

bounds_quasi_func_easy_funct1 = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._BYREF_FLOAT64, # Output, fc.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
bounds_quasi_func_easy = utils._EngineState._get_symbol('e04jyf')
bounds_quasi_func_easy.restype = None
bounds_quasi_func_easy.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ibound.
    bounds_quasi_func_easy_funct1,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bl[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bu[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, f.
    utils._EngineIntArrayType.c_type, # Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Output, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

bounds_mod_deriv_comp_funct = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, iflag.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._BYREF_FLOAT64, # Output, fc.
    utils._EngineFloat64ArrayType.c_type, # Output, gc[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
bounds_mod_deriv_comp_monit = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._BYREF_FLOAT64, # Input, fc.
    utils._EngineFloat64ArrayType.c_type, # Input, gc[n].
    utils._EngineIntArrayType.c_type, # Input, istate[n].
    utils._BYREF_FLOAT64, # Input, gpjnrm.
    utils._BYREF_FLOAT64, # Input, cond.
    utils._BYREF_LOGICAL, # Input, posdef.
    utils._BYREF_INT, # Input, niter.
    utils._BYREF_INT, # Input, nf.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
bounds_mod_deriv_comp = utils._EngineState._get_symbol('e04kdf')
bounds_mod_deriv_comp.restype = None
bounds_mod_deriv_comp.argtypes = (
    utils._BYREF_INT, # Input, n.
    bounds_mod_deriv_comp_funct,
    bounds_mod_deriv_comp_monit,
    utils._BYREF_INT, # Input, iprint.
    utils._BYREF_INT, # Input, maxcal.
    utils._BYREF_FLOAT64, # Input, eta.
    utils._BYREF_FLOAT64, # Input, xtol.
    utils._BYREF_FLOAT64, # Input, delta.
    utils._BYREF_FLOAT64, # Input, stepmx.
    utils._BYREF_INT, # Input, ibound.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bl[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bu[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, hesl[lh].
    utils._BYREF_INT, # Input, lh.
    utils._EngineFloat64ArrayType.c_type, # Output, hesd[n].
    utils._EngineIntArrayType.c_type, # Output, istate[n].
    utils._BYREF_FLOAT64, # Output, f.
    utils._EngineFloat64ArrayType.c_type, # Output, g[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._BYREF_INT, # Input/Output, ifail.
)

handle_solve_bounds_foas_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_FLOAT64, # Output, fx.
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)
handle_solve_bounds_foas_objgrd = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_INT, # Input, nnzfd.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fdx[nnzfd].
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)
handle_solve_bounds_foas_monit = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineFloat64ArrayType.c_type, # Input, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Input, stats[100].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)
handle_solve_bounds_foas = utils._EngineState._get_symbol('e04kff')
handle_solve_bounds_foas.restype = None
handle_solve_bounds_foas.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    handle_solve_bounds_foas_objfun,
    handle_solve_bounds_foas_objgrd,
    handle_solve_bounds_foas_monit,
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[nvar].
    utils._EngineFloat64ArrayType.c_type, # Output, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Output, stats[100].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
    utils._BYREF_INT, # Input/Output, ifail.
)

bounds_dummy_monit = utils._EngineState._get_symbol('e04kfu')
bounds_dummy_monit.restype = None
bounds_dummy_monit.argtypes = (
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineFloat64ArrayType.c_type, # Input, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Input, stats[100].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)

bounds_dummy_objfun = utils._EngineState._get_symbol('e04kfv')
bounds_dummy_objfun.restype = None
bounds_dummy_objfun.argtypes = (
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_FLOAT64, # Output, fx.
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)

bounds_dummy_objgrd = utils._EngineState._get_symbol('e04kfw')
bounds_dummy_objgrd.restype = None
bounds_dummy_objgrd.argtypes = (
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_INT, # Input, nnzfd.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fdx[nnzfd].
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)

bounds_quasi_deriv_easy_funct2 = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._BYREF_FLOAT64, # Output, fc.
    utils._EngineFloat64ArrayType.c_type, # Output, gc[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
bounds_quasi_deriv_easy = utils._EngineState._get_symbol('e04kyf')
bounds_quasi_deriv_easy.restype = None
bounds_quasi_deriv_easy.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ibound.
    bounds_quasi_deriv_easy_funct2,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bl[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bu[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, f.
    utils._EngineFloat64ArrayType.c_type, # Output, g[n].
    utils._EngineIntArrayType.c_type, # Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Output, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

bounds_mod_deriv_easy_funct2 = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._BYREF_FLOAT64, # Output, fc.
    utils._EngineFloat64ArrayType.c_type, # Output, gc[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
bounds_mod_deriv_easy = utils._EngineState._get_symbol('e04kzf')
bounds_mod_deriv_easy.restype = None
bounds_mod_deriv_easy.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ibound.
    bounds_mod_deriv_easy_funct2,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bl[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bu[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, f.
    utils._EngineFloat64ArrayType.c_type, # Output, g[n].
    utils._EngineIntArrayType.c_type, # Workspace, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Workspace, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

bounds_mod_deriv2_comp_funct = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, iflag.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._BYREF_FLOAT64, # Output, fc.
    utils._EngineFloat64ArrayType.c_type, # Output, gc[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
bounds_mod_deriv2_comp_h = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, iflag.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fhesl[lh].
    utils._BYREF_INT, # Input, lh.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fhesd[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
bounds_mod_deriv2_comp_monit = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._BYREF_FLOAT64, # Input, fc.
    utils._EngineFloat64ArrayType.c_type, # Input, gc[n].
    utils._EngineIntArrayType.c_type, # Input, istate[n].
    utils._BYREF_FLOAT64, # Input, gpjnrm.
    utils._BYREF_FLOAT64, # Input, cond.
    utils._BYREF_LOGICAL, # Input, posdef.
    utils._BYREF_INT, # Input, niter.
    utils._BYREF_INT, # Input, nf.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
bounds_mod_deriv2_comp = utils._EngineState._get_symbol('e04lbf')
bounds_mod_deriv2_comp.restype = None
bounds_mod_deriv2_comp.argtypes = (
    utils._BYREF_INT, # Input, n.
    bounds_mod_deriv2_comp_funct,
    bounds_mod_deriv2_comp_h,
    bounds_mod_deriv2_comp_monit,
    utils._BYREF_INT, # Input, iprint.
    utils._BYREF_INT, # Input, maxcal.
    utils._BYREF_FLOAT64, # Input, eta.
    utils._BYREF_FLOAT64, # Input, xtol.
    utils._BYREF_FLOAT64, # Input, stepmx.
    utils._BYREF_INT, # Input, ibound.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bl[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bu[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, hesl[lh].
    utils._BYREF_INT, # Input, lh.
    utils._EngineFloat64ArrayType.c_type, # Output, hesd[n].
    utils._EngineIntArrayType.c_type, # Output, istate[n].
    utils._BYREF_FLOAT64, # Output, f.
    utils._EngineFloat64ArrayType.c_type, # Output, g[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._BYREF_INT, # Input/Output, ifail.
)

bounds_mod_deriv2_easy_funct2 = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._BYREF_FLOAT64, # Output, fc.
    utils._EngineFloat64ArrayType.c_type, # Output, gc[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
bounds_mod_deriv2_easy_hess2 = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Output, heslc[lh].
    utils._BYREF_INT, # Input, lh.
    utils._EngineFloat64ArrayType.c_type, # Output, hesdc[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
bounds_mod_deriv2_easy = utils._EngineState._get_symbol('e04lyf')
bounds_mod_deriv2_easy.restype = None
bounds_mod_deriv2_easy.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ibound.
    bounds_mod_deriv2_easy_funct2,
    bounds_mod_deriv2_easy_hess2,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bl[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bu[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_FLOAT64, # Output, f.
    utils._EngineFloat64ArrayType.c_type, # Output, g[n].
    utils._EngineIntArrayType.c_type, # Workspace, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Workspace, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

lp_solve = utils._EngineState._get_symbol('e04mfa')
lp_solve.restype = None
lp_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nclin.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n+nclin].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n+nclin].
    utils._EngineFloat64ArrayType.c_type, # Input, cvec[*].
    utils._EngineIntArrayType.c_type, # Input/Output, istate[n+nclin].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_INT, # Output, iter.
    utils._BYREF_FLOAT64, # Output, obj.
    utils._EngineFloat64ArrayType.c_type, # Output, ax[max(1, nclin)].
    utils._EngineFloat64ArrayType.c_type, # Output, clamda[n+nclin].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[120].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[475].
    utils._BYREF_INT, # Input/Output, ifail.
)

lp_solve_old = utils._EngineState._get_symbol('e04mff')
lp_solve_old.restype = None
lp_solve_old.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nclin.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n+nclin].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n+nclin].
    utils._EngineFloat64ArrayType.c_type, # Input, cvec[*].
    utils._EngineIntArrayType.c_type, # Input/Output, istate[n+nclin].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_INT, # Output, iter.
    utils._BYREF_FLOAT64, # Output, obj.
    utils._EngineFloat64ArrayType.c_type, # Output, ax[max(1, nclin)].
    utils._EngineFloat64ArrayType.c_type, # Output, clamda[n+nclin].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

lp_option_file = utils._EngineState._get_symbol('e04mga')
lp_option_file.restype = None
lp_option_file.argtypes = (
    utils._BYREF_INT, # Input, ioptns.
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[120].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[475].
    utils._BYREF_INT, # Output, inform.
)

lp_option_file_old = utils._EngineState._get_symbol('e04mgf')
lp_option_file_old.restype = None
lp_option_file_old.argtypes = (
    utils._BYREF_INT, # Input, ioptns.
    utils._BYREF_INT, # Output, inform.
)

lp_option_string = utils._EngineState._get_symbol('e04mha')
lp_option_string.restype = None
lp_option_string.argtypes = (
    utils._BYREF_STRING, # Input, str(len=*).
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[120].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[475].
    utils._BYREF_INT, # Output, inform.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of str.
)

lp_option_string_old = utils._EngineState._get_symbol('e04mhf')
lp_option_string_old.restype = None
lp_option_string_old.argtypes = (
    utils._BYREF_STRING, # Input, str(len=*).
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of str.
)

handle_solve_lp_ipm_monit = utils._EngineState._sys_functype(
    None,
    utils._BYREF_C_PTR, # Input, handle.
    utils._EngineFloat64ArrayType.c_type, # Input, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Input, stats[100].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
    utils._BYREF_INT, # Input/Output, inform.
)
handle_solve_lp_ipm = utils._EngineState._get_symbol('e04mtf')
handle_solve_lp_ipm.restype = None
handle_solve_lp_ipm.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[nvar].
    utils._BYREF_INT, # Input, nnzu.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, u[nnzu].
    utils._EngineFloat64ArrayType.c_type, # Output, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Output, stats[100].
    handle_solve_lp_ipm_monit,
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
    utils._BYREF_INT, # Input/Output, ifail.
)

lp_imp_dummy_monit = utils._EngineState._get_symbol('e04mtu')
lp_imp_dummy_monit.restype = None
lp_imp_dummy_monit.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._EngineFloat64ArrayType.c_type, # Input, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Input, stats[100].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
    utils._BYREF_INT, # Input/Output, inform.
)

miqp_mps_write = utils._EngineState._get_symbol('e04mwf')
miqp_mps_write.restype = None
miqp_mps_write.argtypes = (
    utils._BYREF_INT, # Input, outfile.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, nnzc.
    utils._BYREF_INT, # Input, nnza.
    utils._BYREF_INT, # Input, ncolh.
    utils._BYREF_INT, # Input, nnzh.
    utils._BYREF_INT, # Input, lintvar.
    utils._EngineIntArrayType.c_type, # Input, idxc[nnzc].
    utils._EngineFloat64ArrayType.c_type, # Input, c[nnzc].
    utils._BYREF_INT, # Input, iobj.
    utils._EngineFloat64ArrayType.c_type, # Input, a[nnza].
    utils._EngineIntArrayType.c_type, # Input, irowa[nnza].
    utils._EngineIntArrayType.c_type, # Input, iccola[*].
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n+m].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n+m].
    utils._EngineCharArrayType.c_type, # Input, pnames(len=8)[5].
    utils._BYREF_INT, # Input, nname.
    utils._EngineCharArrayType.c_type, # Input, crname(len=8)[nname].
    utils._EngineFloat64ArrayType.c_type, # Input, h[nnzh].
    utils._EngineIntArrayType.c_type, # Input, irowh[nnzh].
    utils._EngineIntArrayType.c_type, # Input, iccolh[*].
    utils._BYREF_INT, # Input, minmax.
    utils._EngineIntArrayType.c_type, # Input, intvar[lintvar].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of pnames.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of crname.
)

miqp_mps_read = utils._EngineState._get_symbol('e04mxf')
miqp_mps_read.restype = None
miqp_mps_read.argtypes = (
    utils._BYREF_INT, # Input, infile.
    utils._BYREF_INT, # Input, maxn.
    utils._BYREF_INT, # Input, maxm.
    utils._BYREF_INT, # Input, maxnnz.
    utils._BYREF_INT, # Input, maxncolh.
    utils._BYREF_INT, # Input, maxnnzh.
    utils._BYREF_INT, # Input, maxlintvar.
    utils._BYREF_INT, # Input, mpslst.
    utils._BYREF_INT, # Output, n.
    utils._BYREF_INT, # Output, m.
    utils._BYREF_INT, # Output, nnz.
    utils._BYREF_INT, # Output, ncolh.
    utils._BYREF_INT, # Output, nnzh.
    utils._BYREF_INT, # Output, lintvar.
    utils._BYREF_INT, # Output, iobj.
    utils._EngineFloat64ArrayType.c_type, # Output, a[maxnnz].
    utils._EngineIntArrayType.c_type, # Output, irowa[maxnnz].
    utils._EngineIntArrayType.c_type, # Output, iccola[maxn+1].
    utils._EngineFloat64ArrayType.c_type, # Output, bl[maxn+maxm].
    utils._EngineFloat64ArrayType.c_type, # Output, bu[maxn+maxm].
    utils._EngineCharArrayType.c_type, # Input/Output, pnames(len=8)[5].
    utils._BYREF_INT, # Output, nname.
    utils._EngineCharArrayType.c_type, # Output, crname(len=8)[maxn+maxm].
    utils._EngineFloat64ArrayType.c_type, # Output, h[maxnnzh].
    utils._EngineIntArrayType.c_type, # Output, irowh[maxnnzh].
    utils._EngineIntArrayType.c_type, # Output, iccolh[maxncolh+1].
    utils._BYREF_INT, # Output, minmax.
    utils._EngineIntArrayType.c_type, # Output, intvar[maxlintvar].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of pnames.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of crname.
)

qpconvex1_sparse_mps = utils._EngineState._get_symbol('e04mzf')
qpconvex1_sparse_mps.restype = None
qpconvex1_sparse_mps.argtypes = (
    utils._BYREF_INT, # Input, infile.
    utils._BYREF_INT, # Input, maxn.
    utils._BYREF_INT, # Input, maxm.
    utils._BYREF_INT, # Input, maxnnz.
    utils._BYREF_FLOAT64, # Input, xbldef.
    utils._BYREF_FLOAT64, # Input, xbudef.
    utils._BYREF_LOGICAL, # Input, mpslst.
    utils._BYREF_INT, # Output, n.
    utils._BYREF_INT, # Output, m.
    utils._BYREF_INT, # Output, nnz.
    utils._BYREF_INT, # Output, iobj.
    utils._BYREF_INT, # Output, ncolh.
    utils._EngineFloat64ArrayType.c_type, # Output, a[maxnnz].
    utils._EngineIntArrayType.c_type, # Output, ha[maxnnz].
    utils._EngineIntArrayType.c_type, # Output, ka[maxn+1].
    utils._EngineFloat64ArrayType.c_type, # Output, bl[maxn+maxm].
    utils._EngineFloat64ArrayType.c_type, # Output, bu[maxn+maxm].
    utils._BYREF_STRING, # Output, start(len=1).
    utils._EngineCharArrayType.c_type, # Input/Output, names(len=8)[5].
    utils._BYREF_INT, # Output, nname.
    utils._EngineCharArrayType.c_type, # Output, crname(len=8)[maxn+maxm].
    utils._EngineFloat64ArrayType.c_type, # Output, xs[maxn+maxm].
    utils._EngineIntArrayType.c_type, # Output, istate[maxn+maxm].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of start.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of names.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of crname.
)

lsq_lincon_solve = utils._EngineState._get_symbol('e04nca')
lsq_lincon_solve.restype = None
lsq_lincon_solve.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nclin.
    utils._BYREF_INT, # Input, ldc.
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input, c[ldc, *].
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n+nclin].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n+nclin].
    utils._EngineFloat64ArrayType.c_type, # Input, cvec[*].
    utils._EngineIntArrayType.c_type, # Input/Output, istate[n+nclin].
    utils._EngineIntArrayType.c_type, # Input/Output, kx[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[lda, *].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, b[*].
    utils._BYREF_INT, # Output, iter.
    utils._BYREF_FLOAT64, # Output, obj.
    utils._EngineFloat64ArrayType.c_type, # Output, clamda[n+nclin].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[120].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[475].
    utils._BYREF_INT, # Input/Output, ifail.
)

lsq_lincon_solve_old = utils._EngineState._get_symbol('e04ncf')
lsq_lincon_solve_old.restype = None
lsq_lincon_solve_old.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nclin.
    utils._BYREF_INT, # Input, ldc.
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input, c[ldc, *].
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n+nclin].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n+nclin].
    utils._EngineFloat64ArrayType.c_type, # Input, cvec[*].
    utils._EngineIntArrayType.c_type, # Input/Output, istate[n+nclin].
    utils._EngineIntArrayType.c_type, # Input/Output, kx[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[lda, *].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, b[*].
    utils._BYREF_INT, # Output, iter.
    utils._BYREF_FLOAT64, # Output, obj.
    utils._EngineFloat64ArrayType.c_type, # Output, clamda[n+nclin].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

lsq_lincon_option_file = utils._EngineState._get_symbol('e04nda')
lsq_lincon_option_file.restype = None
lsq_lincon_option_file.argtypes = (
    utils._BYREF_INT, # Input, ioptns.
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[120].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[475].
    utils._BYREF_INT, # Output, inform.
)

lsq_lincon_option_file_old = utils._EngineState._get_symbol('e04ndf')
lsq_lincon_option_file_old.restype = None
lsq_lincon_option_file_old.argtypes = (
    utils._BYREF_INT, # Input, ioptns.
    utils._BYREF_INT, # Output, inform.
)

lsq_lincon_option_string = utils._EngineState._get_symbol('e04nea')
lsq_lincon_option_string.restype = None
lsq_lincon_option_string.argtypes = (
    utils._BYREF_STRING, # Input, str(len=*).
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[120].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[475].
    utils._BYREF_INT, # Output, inform.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of str.
)

lsq_lincon_option_string_old = utils._EngineState._get_symbol('e04nef')
lsq_lincon_option_string_old.restype = None
lsq_lincon_option_string_old.argtypes = (
    utils._BYREF_STRING, # Input, str(len=*).
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of str.
)

qp_dense_solve_qphess = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, jthcol.
    utils._EngineFloat64ArrayType.c_type, # Input, h[ldh, *].
    utils._BYREF_INT, # Input, ldh.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, hx[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
)
qp_dense_solve = utils._EngineState._get_symbol('e04nfa')
qp_dense_solve.restype = None
qp_dense_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nclin.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n+nclin].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n+nclin].
    utils._EngineFloat64ArrayType.c_type, # Input, cvec[*].
    utils._EngineFloat64ArrayType.c_type, # Input, h[ldh, *].
    utils._BYREF_INT, # Input, ldh.
    qp_dense_solve_qphess,
    utils._EngineIntArrayType.c_type, # Input/Output, istate[n+nclin].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_INT, # Output, iter.
    utils._BYREF_FLOAT64, # Output, obj.
    utils._EngineFloat64ArrayType.c_type, # Output, ax[max(1, nclin)].
    utils._EngineFloat64ArrayType.c_type, # Output, clamda[n+nclin].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[120].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[475].
    utils._BYREF_INT, # Input/Output, ifail.
)

qp_dense_solve_old_qphess = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, jthcol.
    utils._EngineFloat64ArrayType.c_type, # Input, h[ldh, *].
    utils._BYREF_INT, # Input, ldh.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, hx[n].
)
qp_dense_solve_old = utils._EngineState._get_symbol('e04nff')
qp_dense_solve_old.restype = None
qp_dense_solve_old.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nclin.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n+nclin].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n+nclin].
    utils._EngineFloat64ArrayType.c_type, # Input, cvec[*].
    utils._EngineFloat64ArrayType.c_type, # Input, h[ldh, *].
    utils._BYREF_INT, # Input, ldh.
    qp_dense_solve_old_qphess,
    utils._EngineIntArrayType.c_type, # Input/Output, istate[n+nclin].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_INT, # Output, iter.
    utils._BYREF_FLOAT64, # Output, obj.
    utils._EngineFloat64ArrayType.c_type, # Output, ax[max(1, nclin)].
    utils._EngineFloat64ArrayType.c_type, # Output, clamda[n+nclin].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

qp_dense_sample_qphess_old = utils._EngineState._get_symbol('e04nfu')
qp_dense_sample_qphess_old.restype = None
qp_dense_sample_qphess_old.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, jthcol.
    utils._EngineFloat64ArrayType.c_type, # Input, h[ldh, *].
    utils._BYREF_INT, # Input, ldh.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, hx[n].
)

qp_dense_option_file = utils._EngineState._get_symbol('e04nga')
qp_dense_option_file.restype = None
qp_dense_option_file.argtypes = (
    utils._BYREF_INT, # Input, ioptns.
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[120].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[475].
    utils._BYREF_INT, # Output, inform.
)

qp_dense_option_file_old = utils._EngineState._get_symbol('e04ngf')
qp_dense_option_file_old.restype = None
qp_dense_option_file_old.argtypes = (
    utils._BYREF_INT, # Input, ioptns.
    utils._BYREF_INT, # Output, inform.
)

qp_dense_option_string = utils._EngineState._get_symbol('e04nha')
qp_dense_option_string.restype = None
qp_dense_option_string.argtypes = (
    utils._BYREF_STRING, # Input, str(len=*).
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[120].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[475].
    utils._BYREF_INT, # Output, inform.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of str.
)

qp_dense_option_string_old = utils._EngineState._get_symbol('e04nhf')
qp_dense_option_string_old.restype = None
qp_dense_option_string_old.argtypes = (
    utils._BYREF_STRING, # Input, str(len=*).
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of str.
)

qpconvex1_sparse_solve_qphx = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, nstate.
    utils._BYREF_INT, # Input, ncolh.
    utils._EngineFloat64ArrayType.c_type, # Input, x[ncolh].
    utils._EngineFloat64ArrayType.c_type, # Output, hx[ncolh].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
qpconvex1_sparse_solve = utils._EngineState._get_symbol('e04nka')
qpconvex1_sparse_solve.restype = None
qpconvex1_sparse_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, nnz.
    utils._BYREF_INT, # Input, iobj.
    utils._BYREF_INT, # Input, ncolh.
    qpconvex1_sparse_solve_qphx,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[nnz].
    utils._EngineIntArrayType.c_type, # Input, ha[nnz].
    utils._EngineIntArrayType.c_type, # Input, ka[n+1].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bl[n+m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bu[n+m].
    utils._BYREF_STRING, # Input, start(len=1).
    utils._EngineCharArrayType.c_type, # Input, names(len=8)[5].
    utils._BYREF_INT, # Input, nname.
    utils._EngineCharArrayType.c_type, # Input, crname(len=8)[nname].
    utils._BYREF_INT, # Input/Output, ns.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, xs[n+m].
    utils._EngineIntArrayType.c_type, # Input/Output, istate[n+m].
    utils._BYREF_INT, # Output, miniz.
    utils._BYREF_INT, # Output, minz.
    utils._BYREF_INT, # Output, ninf.
    utils._BYREF_FLOAT64, # Output, sinf.
    utils._BYREF_FLOAT64, # Output, obj.
    utils._EngineFloat64ArrayType.c_type, # Output, clamda[n+m].
    utils._EngineIntArrayType.c_type, # Workspace, iz[leniz].
    utils._BYREF_INT, # Input, leniz.
    utils._EngineFloat64ArrayType.c_type, # Workspace, z[lenz].
    utils._BYREF_INT, # Input, lenz.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[20].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[380].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[285].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of start.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of names.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of crname.
)

qpconvex1_sparse_solve_old_qphx = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, nstate.
    utils._BYREF_INT, # Input, ncolh.
    utils._EngineFloat64ArrayType.c_type, # Input, x[ncolh].
    utils._EngineFloat64ArrayType.c_type, # Output, hx[ncolh].
)
qpconvex1_sparse_solve_old = utils._EngineState._get_symbol('e04nkf')
qpconvex1_sparse_solve_old.restype = None
qpconvex1_sparse_solve_old.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, nnz.
    utils._BYREF_INT, # Input, iobj.
    utils._BYREF_INT, # Input, ncolh.
    qpconvex1_sparse_solve_old_qphx,
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[nnz].
    utils._EngineIntArrayType.c_type, # Input, ha[nnz].
    utils._EngineIntArrayType.c_type, # Input, ka[n+1].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bl[n+m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bu[n+m].
    utils._BYREF_STRING, # Input, start(len=1).
    utils._EngineCharArrayType.c_type, # Input, names(len=8)[5].
    utils._BYREF_INT, # Input, nname.
    utils._EngineCharArrayType.c_type, # Input, crname(len=8)[nname].
    utils._BYREF_INT, # Input/Output, ns.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, xs[n+m].
    utils._EngineIntArrayType.c_type, # Input/Output, istate[n+m].
    utils._BYREF_INT, # Output, miniz.
    utils._BYREF_INT, # Output, minz.
    utils._BYREF_INT, # Output, ninf.
    utils._BYREF_FLOAT64, # Output, sinf.
    utils._BYREF_FLOAT64, # Output, obj.
    utils._EngineFloat64ArrayType.c_type, # Output, clamda[n+m].
    utils._EngineIntArrayType.c_type, # Workspace, iz[leniz].
    utils._BYREF_INT, # Input, leniz.
    utils._EngineFloat64ArrayType.c_type, # Workspace, z[lenz].
    utils._BYREF_INT, # Input, lenz.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of start.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of names.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of crname.
)

qpconvex1_sparse_dummy_qphx_old = utils._EngineState._get_symbol('e04nku')
qpconvex1_sparse_dummy_qphx_old.restype = None
qpconvex1_sparse_dummy_qphx_old.argtypes = (
    utils._BYREF_INT, # Input, nstate.
    utils._BYREF_INT, # Input, ncolh.
    utils._EngineFloat64ArrayType.c_type, # Input, x[ncolh].
    utils._EngineFloat64ArrayType.c_type, # Output, hx[ncolh].
)

qpconvex1_sparse_option_file = utils._EngineState._get_symbol('e04nla')
qpconvex1_sparse_option_file.restype = None
qpconvex1_sparse_option_file.argtypes = (
    utils._BYREF_INT, # Input, ioptns.
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[20].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[380].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[285].
    utils._BYREF_INT, # Output, inform.
)

qpconvex1_sparse_option_file_old = utils._EngineState._get_symbol('e04nlf')
qpconvex1_sparse_option_file_old.restype = None
qpconvex1_sparse_option_file_old.argtypes = (
    utils._BYREF_INT, # Input, ioptns.
    utils._BYREF_INT, # Output, inform.
)

qpconvex1_sparse_option_string = utils._EngineState._get_symbol('e04nma')
qpconvex1_sparse_option_string.restype = None
qpconvex1_sparse_option_string.argtypes = (
    utils._BYREF_STRING, # Input, str(len=*).
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[20].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[380].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[285].
    utils._BYREF_INT, # Output, inform.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of str.
)

qpconvex1_sparse_option_string_old = utils._EngineState._get_symbol('e04nmf')
qpconvex1_sparse_option_string_old.restype = None
qpconvex1_sparse_option_string_old.argtypes = (
    utils._BYREF_STRING, # Input, str(len=*).
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of str.
)

qpconvex2_sparse_init = utils._EngineState._get_symbol('e04npf')
qpconvex2_sparse_init.restype = None
qpconvex2_sparse_init.argtypes = (
    utils._EngineCharArrayType.c_type, # Output, cw(len=8)[lencw].
    utils._BYREF_INT, # Input, lencw.
    utils._EngineIntArrayType.c_type, # Output, iw[leniw].
    utils._BYREF_INT, # Input, leniw.
    utils._EngineFloat64ArrayType.c_type, # Output, rw[lenrw].
    utils._BYREF_INT, # Input, lenrw.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cw.
)

qpconvex2_sparse_solve_qphx = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, ncolh.
    utils._EngineFloat64ArrayType.c_type, # Input, x[ncolh].
    utils._EngineFloat64ArrayType.c_type, # Output, hx[ncolh].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineCharArrayType.c_type, # Input/Output, cuser(len=8)[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cuser.
)
qpconvex2_sparse_solve = utils._EngineState._get_symbol('e04nqf')
qpconvex2_sparse_solve.restype = None
qpconvex2_sparse_solve.argtypes = (
    utils._BYREF_STRING, # Input, start(len=1).
    qpconvex2_sparse_solve_qphx,
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ne.
    utils._BYREF_INT, # Input, nname.
    utils._BYREF_INT, # Input, lenc.
    utils._BYREF_INT, # Input, ncolh.
    utils._BYREF_INT, # Input, iobj.
    utils._BYREF_FLOAT64, # Input, objadd.
    utils._BYREF_STRING, # Input, prob(len=8).
    utils._EngineFloat64ArrayType.c_type, # Input/Output, acol[ne].
    utils._EngineIntArrayType.c_type, # Input, inda[ne].
    utils._EngineIntArrayType.c_type, # Input, loca[n+1].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bl[n+m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bu[n+m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, c[max(1, lenc)].
    utils._EngineCharArrayType.c_type, # Input, names(len=8)[nname].
    utils._EngineIntArrayType.c_type, # Input, helast[n+m].
    utils._EngineIntArrayType.c_type, # Input/Output, hs[n+m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n+m].
    utils._EngineFloat64ArrayType.c_type, # Output, pi[m].
    utils._EngineFloat64ArrayType.c_type, # Output, rc[n+m].
    utils._BYREF_INT, # Input/Output, ns.
    utils._BYREF_INT, # Output, ninf.
    utils._BYREF_FLOAT64, # Output, sinf.
    utils._BYREF_FLOAT64, # Output, obj.
    utils._EngineCharArrayType.c_type, # Input/Output, cw(len=8)[lencw].
    utils._BYREF_INT, # Input, lencw.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[leniw].
    utils._BYREF_INT, # Input, leniw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[lenrw].
    utils._BYREF_INT, # Input, lenrw.
    utils._EngineCharArrayType.c_type, # Input/Output, cuser(len=8)[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of start.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of prob.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of names.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cw.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cuser.
)

qpconvex2_sparse_option_file = utils._EngineState._get_symbol('e04nrf')
qpconvex2_sparse_option_file.restype = None
qpconvex2_sparse_option_file.argtypes = (
    utils._BYREF_INT, # Input, ispecs.
    utils._EngineCharArrayType.c_type, # Input/Output, cw(len=8)[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cw.
)

qpconvex2_sparse_option_string = utils._EngineState._get_symbol('e04nsf')
qpconvex2_sparse_option_string.restype = None
qpconvex2_sparse_option_string.argtypes = (
    utils._BYREF_STRING, # Input, string(len=*).
    utils._EngineCharArrayType.c_type, # Input/Output, cw(len=8)[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of string.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cw.
)

qpconvex2_sparse_dummy_qphx = utils._EngineState._get_symbol('e04nsh')
qpconvex2_sparse_dummy_qphx.restype = None
qpconvex2_sparse_dummy_qphx.argtypes = (
    utils._BYREF_INT, # Input, ncolh.
    utils._EngineFloat64ArrayType.c_type, # Input, x[ncolh].
    utils._EngineFloat64ArrayType.c_type, # Output, hx[ncolh].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineCharArrayType.c_type, # Input/Output, cuser(len=8)[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cuser.
)

qpconvex2_sparse_option_integer_set = utils._EngineState._get_symbol('e04ntf')
qpconvex2_sparse_option_integer_set.restype = None
qpconvex2_sparse_option_integer_set.argtypes = (
    utils._BYREF_STRING, # Input, string(len=*).
    utils._BYREF_INT, # Input, ivalue.
    utils._EngineCharArrayType.c_type, # Input/Output, cw(len=8)[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of string.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cw.
)

qpconvex2_sparse_option_double_set = utils._EngineState._get_symbol('e04nuf')
qpconvex2_sparse_option_double_set.restype = None
qpconvex2_sparse_option_double_set.argtypes = (
    utils._BYREF_STRING, # Input, string(len=*).
    utils._BYREF_FLOAT64, # Input, rvalue.
    utils._EngineCharArrayType.c_type, # Input/Output, cw(len=8)[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of string.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cw.
)

qpconvex2_sparse_option_integer_get = utils._EngineState._get_symbol('e04nxf')
qpconvex2_sparse_option_integer_get.restype = None
qpconvex2_sparse_option_integer_get.argtypes = (
    utils._BYREF_STRING, # Input, string(len=*).
    utils._BYREF_INT, # Output, ivalue.
    utils._EngineCharArrayType.c_type, # Input/Output, cw(len=8)[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of string.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cw.
)

qpconvex2_sparse_option_double_get = utils._EngineState._get_symbol('e04nyf')
qpconvex2_sparse_option_double_get.restype = None
qpconvex2_sparse_option_double_get.argtypes = (
    utils._BYREF_STRING, # Input, string(len=*).
    utils._BYREF_FLOAT64, # Output, rvalue.
    utils._EngineCharArrayType.c_type, # Input/Output, cw(len=8)[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of string.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cw.
)

bnd_lin_lsq = utils._EngineState._get_symbol('e04pcf')
bnd_lin_lsq.restype = None
bnd_lin_lsq.argtypes = (
    utils._BYREF_INT, # Input, itype.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[lda, *].
    utils._BYREF_INT, # Input, lda.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, b[m].
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n].
    utils._BYREF_FLOAT64, # Input, tol.
    utils._EngineFloat64ArrayType.c_type, # Output, x[n].
    utils._BYREF_FLOAT64, # Output, rnorm.
    utils._BYREF_INT, # Output, nfree.
    utils._EngineFloat64ArrayType.c_type, # Output, w[n].
    utils._EngineIntArrayType.c_type, # Output, indx[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

handle_solve_socp_ipm_monit = utils._EngineState._sys_functype(
    None,
    utils._BYREF_C_PTR, # Input, handle.
    utils._EngineFloat64ArrayType.c_type, # Input, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Input, stats[100].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
    utils._BYREF_INT, # Input/Output, inform.
)
handle_solve_socp_ipm = utils._EngineState._get_symbol('e04ptf')
handle_solve_socp_ipm.restype = None
handle_solve_socp_ipm.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[nvar].
    utils._BYREF_INT, # Input, nnzu.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, u[nnzu].
    utils._BYREF_INT, # Input, nnzuc.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, uc[nnzuc].
    utils._EngineFloat64ArrayType.c_type, # Output, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Output, stats[100].
    handle_solve_socp_ipm_monit,
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
    utils._BYREF_INT, # Input/Output, ifail.
)

socp_dummy_monit = utils._EngineState._get_symbol('e04ptu')
socp_dummy_monit.restype = None
socp_dummy_monit.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._EngineFloat64ArrayType.c_type, # Input, rinfo[100].
    utils._EngineFloat64ArrayType.c_type, # Input, stats[100].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
    utils._BYREF_INT, # Input/Output, inform.
)

handle_init = utils._EngineState._get_symbol('e04raf')
handle_init.restype = None
handle_init.argtypes = (
    utils._BYREF_C_PTR, # Output, handle.
    utils._BYREF_INT, # Input, nvar.
    utils._BYREF_INT, # Input/Output, ifail.
)

handle_set_group = utils._EngineState._get_symbol('e04rbf')
handle_set_group.restype = None
handle_set_group.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_STRING, # Input, gtype(len=*).
    utils._BYREF_INT, # Input, lgroup.
    utils._EngineIntArrayType.c_type, # Input, group[lgroup].
    utils._BYREF_INT, # Input/Output, idgroup.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of gtype.
)

sdp_read_sdpa = utils._EngineState._get_symbol('e04rdf')
sdp_read_sdpa.restype = None
sdp_read_sdpa.argtypes = (
    utils._BYREF_INT, # Input, infile.
    utils._BYREF_INT, # Input, maxnvar.
    utils._BYREF_INT, # Input, maxnblk.
    utils._BYREF_INT, # Input, maxnnz.
    utils._BYREF_INT, # Input, filelst.
    utils._BYREF_INT, # Output, nvar.
    utils._BYREF_INT, # Output, nblk.
    utils._BYREF_INT, # Output, nnz.
    utils._EngineFloat64ArrayType.c_type, # Output, cvec[maxnvar].
    utils._EngineIntArrayType.c_type, # Output, nnza[maxnvar+1].
    utils._EngineIntArrayType.c_type, # Output, irowa[maxnnz].
    utils._EngineIntArrayType.c_type, # Output, icola[maxnnz].
    utils._EngineFloat64ArrayType.c_type, # Output, a[maxnnz].
    utils._EngineIntArrayType.c_type, # Output, blksizea[maxnblk].
    utils._BYREF_INT, # Input/Output, ifail.
)

handle_set_linobj = utils._EngineState._get_symbol('e04ref')
handle_set_linobj.restype = None
handle_set_linobj.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, cvec[nvar].
    utils._BYREF_INT, # Input/Output, ifail.
)

handle_set_quadobj = utils._EngineState._get_symbol('e04rff')
handle_set_quadobj.restype = None
handle_set_quadobj.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_INT, # Input, nnzc.
    utils._EngineIntArrayType.c_type, # Input, idxc[nnzc].
    utils._EngineFloat64ArrayType.c_type, # Input, c[nnzc].
    utils._BYREF_INT, # Input, nnzh.
    utils._EngineIntArrayType.c_type, # Input, irowh[nnzh].
    utils._EngineIntArrayType.c_type, # Input, icolh[nnzh].
    utils._EngineFloat64ArrayType.c_type, # Input, h[nnzh].
    utils._BYREF_INT, # Input/Output, ifail.
)

handle_set_nlnobj = utils._EngineState._get_symbol('e04rgf')
handle_set_nlnobj.restype = None
handle_set_nlnobj.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_INT, # Input, nnzfd.
    utils._EngineIntArrayType.c_type, # Input, idxfd[nnzfd].
    utils._BYREF_INT, # Input/Output, ifail.
)

handle_set_simplebounds = utils._EngineState._get_symbol('e04rhf')
handle_set_simplebounds.restype = None
handle_set_simplebounds.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, bl[nvar].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[nvar].
    utils._BYREF_INT, # Input/Output, ifail.
)

handle_set_linconstr = utils._EngineState._get_symbol('e04rjf')
handle_set_linconstr.restype = None
handle_set_linconstr.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_INT, # Input, nclin.
    utils._EngineFloat64ArrayType.c_type, # Input, bl[nclin].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[nclin].
    utils._BYREF_INT, # Input, nnzb.
    utils._EngineIntArrayType.c_type, # Input, irowb[nnzb].
    utils._EngineIntArrayType.c_type, # Input, icolb[nnzb].
    utils._EngineFloat64ArrayType.c_type, # Input, b[nnzb].
    utils._BYREF_INT, # Input/Output, idlc.
    utils._BYREF_INT, # Input/Output, ifail.
)

handle_set_nlnconstr = utils._EngineState._get_symbol('e04rkf')
handle_set_nlnconstr.restype = None
handle_set_nlnconstr.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_INT, # Input, ncnln.
    utils._EngineFloat64ArrayType.c_type, # Input, bl[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[ncnln].
    utils._BYREF_INT, # Input, nnzgd.
    utils._EngineIntArrayType.c_type, # Input, irowgd[nnzgd].
    utils._EngineIntArrayType.c_type, # Input, icolgd[nnzgd].
    utils._BYREF_INT, # Input/Output, ifail.
)

handle_set_nlnhess = utils._EngineState._get_symbol('e04rlf')
handle_set_nlnhess.restype = None
handle_set_nlnhess.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_INT, # Input, idf.
    utils._BYREF_INT, # Input, nnzh.
    utils._EngineIntArrayType.c_type, # Input, irowh[nnzh].
    utils._EngineIntArrayType.c_type, # Input, icolh[nnzh].
    utils._BYREF_INT, # Input/Output, ifail.
)

handle_set_nlnls = utils._EngineState._get_symbol('e04rmf')
handle_set_nlnls.restype = None
handle_set_nlnls.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_INT, # Input, nres.
    utils._BYREF_INT, # Input, isparse.
    utils._BYREF_INT, # Input, nnzrd.
    utils._EngineIntArrayType.c_type, # Input, irowrd[nnzrd].
    utils._EngineIntArrayType.c_type, # Input, icolrd[nnzrd].
    utils._BYREF_INT, # Input/Output, ifail.
)

handle_set_linmatineq = utils._EngineState._get_symbol('e04rnf')
handle_set_linmatineq.restype = None
handle_set_linmatineq.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_INT, # Input, nvar.
    utils._BYREF_INT, # Input, dima.
    utils._EngineIntArrayType.c_type, # Input, nnza[nvar+1].
    utils._BYREF_INT, # Input, nnzasum.
    utils._EngineIntArrayType.c_type, # Input, irowa[nnzasum].
    utils._EngineIntArrayType.c_type, # Input, icola[nnzasum].
    utils._EngineFloat64ArrayType.c_type, # Input, a[nnzasum].
    utils._BYREF_INT, # Input, nblk.
    utils._EngineIntArrayType.c_type, # Input, blksizea[nblk].
    utils._BYREF_INT, # Input/Output, idblk.
    utils._BYREF_INT, # Input/Output, ifail.
)

handle_set_quadmatineq = utils._EngineState._get_symbol('e04rpf')
handle_set_quadmatineq.restype = None
handle_set_quadmatineq.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_INT, # Input, nq.
    utils._EngineIntArrayType.c_type, # Input, qi[nq].
    utils._EngineIntArrayType.c_type, # Input, qj[nq].
    utils._BYREF_INT, # Input, dimq.
    utils._EngineIntArrayType.c_type, # Input, nnzq[nq].
    utils._BYREF_INT, # Input, nnzqsum.
    utils._EngineIntArrayType.c_type, # Input, irowq[nnzqsum].
    utils._EngineIntArrayType.c_type, # Input, icolq[nnzqsum].
    utils._EngineFloat64ArrayType.c_type, # Input, q[nnzqsum].
    utils._BYREF_INT, # Input/Output, idblk.
    utils._BYREF_INT, # Input/Output, ifail.
)

handle_set_get_real = utils._EngineState._get_symbol('e04rxf')
handle_set_get_real.restype = None
handle_set_get_real.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_STRING, # Input, cmdstr(len=*).
    utils._BYREF_INT, # Input, ioflag.
    utils._BYREF_INT, # Input/Output, lrarr.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rarr[lrarr].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cmdstr.
)

handle_print = utils._EngineState._get_symbol('e04ryf')
handle_print.restype = None
handle_print.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_INT, # Input, nout.
    utils._BYREF_STRING, # Input, cmdstr(len=*).
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cmdstr.
)

handle_free = utils._EngineState._get_symbol('e04rzf')
handle_free.restype = None
handle_free.argtypes = (
    utils._BYREF_C_PTR, # Input/Output, handle.
    utils._BYREF_INT, # Input/Output, ifail.
)

handle_read_file = utils._EngineState._get_symbol('e04saf')
handle_read_file.restype = None
handle_read_file.argtypes = (
    utils._BYREF_C_PTR, # Output, handle.
    utils._BYREF_STRING, # Input, file(len=*).
    utils._BYREF_STRING, # Input, ftype(len=*).
    utils._EngineIntArrayType.c_type, # Output, pinfo[100].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of file.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of ftype.
)

handle_solve_ipopt_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_FLOAT64, # Output, fx.
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)
handle_solve_ipopt_objgrd = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_INT, # Input, nnzfd.
    utils._EngineFloat64ArrayType.c_type, # Output, fdx[nnzfd].
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)
handle_solve_ipopt_confun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_INT, # Input, ncnln.
    utils._EngineFloat64ArrayType.c_type, # Output, gx[ncnln].
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)
handle_solve_ipopt_congrd = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_INT, # Input, nnzgd.
    utils._EngineFloat64ArrayType.c_type, # Output, gdx[nnzgd].
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)
handle_solve_ipopt_hess = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, idf.
    utils._BYREF_FLOAT64, # Input, sigma.
    utils._EngineFloat64ArrayType.c_type, # Input, lambda[ncnln].
    utils._BYREF_INT, # Input, nnzh.
    utils._EngineFloat64ArrayType.c_type, # Output, hx[nnzh].
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)
handle_solve_ipopt_monit = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_INT, # Input, nnzu.
    utils._EngineFloat64ArrayType.c_type, # Input, u[nnzu].
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineFloat64ArrayType.c_type, # Input, rinfo[32].
    utils._EngineFloat64ArrayType.c_type, # Input, stats[32].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)
handle_solve_ipopt = utils._EngineState._get_symbol('e04stf')
handle_solve_ipopt.restype = None
handle_solve_ipopt.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    handle_solve_ipopt_objfun,
    handle_solve_ipopt_objgrd,
    handle_solve_ipopt_confun,
    handle_solve_ipopt_congrd,
    handle_solve_ipopt_hess,
    handle_solve_ipopt_monit,
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[nvar].
    utils._BYREF_INT, # Input, nnzu.
    utils._EngineFloat64ArrayType.c_type, # Output, u[nnzu].
    utils._EngineFloat64ArrayType.c_type, # Output, rinfo[32].
    utils._EngineFloat64ArrayType.c_type, # Output, stats[32].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
    utils._BYREF_INT, # Input/Output, ifail.
)

ipopt_dummy_monit = utils._EngineState._get_symbol('e04stu')
ipopt_dummy_monit.restype = None
ipopt_dummy_monit.argtypes = (
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_INT, # Input, nnzu.
    utils._EngineFloat64ArrayType.c_type, # Input, u[nnzu].
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineFloat64ArrayType.c_type, # Input, rinfo[32].
    utils._EngineFloat64ArrayType.c_type, # Input, stats[32].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)

ipopt_dummy_objfun = utils._EngineState._get_symbol('e04stv')
ipopt_dummy_objfun.restype = None
ipopt_dummy_objfun.argtypes = (
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_FLOAT64, # Output, fx.
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)

ipopt_dummy_objgrd = utils._EngineState._get_symbol('e04stw')
ipopt_dummy_objgrd.restype = None
ipopt_dummy_objgrd.argtypes = (
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_INT, # Input, nnzfd.
    utils._EngineFloat64ArrayType.c_type, # Output, fdx[nnzfd].
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)

ipopt_dummy_confun = utils._EngineState._get_symbol('e04stx')
ipopt_dummy_confun.restype = None
ipopt_dummy_confun.argtypes = (
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_INT, # Input, ncnln.
    utils._EngineFloat64ArrayType.c_type, # Output, gx[ncnln].
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)

ipopt_dummy_congrd = utils._EngineState._get_symbol('e04sty')
ipopt_dummy_congrd.restype = None
ipopt_dummy_congrd.argtypes = (
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_INT, # Input, nnzgd.
    utils._EngineFloat64ArrayType.c_type, # Output, gdx[nnzgd].
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)

ipopt_dummy_hess = utils._EngineState._get_symbol('e04stz')
ipopt_dummy_hess.restype = None
ipopt_dummy_hess.argtypes = (
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nvar].
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, idf.
    utils._BYREF_FLOAT64, # Input, sigma.
    utils._EngineFloat64ArrayType.c_type, # Input, lambda[ncnln].
    utils._BYREF_INT, # Input, nnzh.
    utils._EngineFloat64ArrayType.c_type, # Output, hx[nnzh].
    utils._BYREF_INT, # Input/Output, inform.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_C_PTR, # Input, cpuser.
)

handle_solve_pennon = utils._EngineState._get_symbol('e04svf')
handle_solve_pennon.restype = None
handle_solve_pennon.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_INT, # Input, nvar.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[nvar].
    utils._BYREF_INT, # Input, nnzu.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, u[nnzu].
    utils._BYREF_INT, # Input, nnzuc.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, uc[nnzuc].
    utils._BYREF_INT, # Input, nnzua.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ua[nnzua].
    utils._EngineFloat64ArrayType.c_type, # Output, rinfo[32].
    utils._EngineFloat64ArrayType.c_type, # Output, stats[32].
    utils._BYREF_INT, # Input/Output, inform.
    utils._BYREF_INT, # Input/Output, ifail.
)

nlp1_solve_confun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ldcj.
    utils._EngineIntArrayType.c_type, # Input, needc[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, c[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjac[ldcj, n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
nlp1_solve_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, objgrd[n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
nlp1_solve = utils._EngineState._get_symbol('e04uca')
nlp1_solve.restype = None
nlp1_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nclin.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, lda.
    utils._BYREF_INT, # Input, ldcj.
    utils._BYREF_INT, # Input, ldr.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n+nclin+ncnln].
    nlp1_solve_confun,
    nlp1_solve_objfun,
    utils._BYREF_INT, # Output, iter.
    utils._EngineIntArrayType.c_type, # Input/Output, istate[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Output, c[max(1, ncnln)].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjac[ldcj, *].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, clamda[n+nclin+ncnln].
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Output, objgrd[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[ldr, n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[120].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[475].
    utils._BYREF_INT, # Input/Output, ifail.
)

nlp1_solve_old_confun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ldcj.
    utils._EngineIntArrayType.c_type, # Input, needc[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, c[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjac[ldcj, n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
nlp1_solve_old_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, objgrd[n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
nlp1_solve_old = utils._EngineState._get_symbol('e04ucf')
nlp1_solve_old.restype = None
nlp1_solve_old.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nclin.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, lda.
    utils._BYREF_INT, # Input, ldcj.
    utils._BYREF_INT, # Input, ldr.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n+nclin+ncnln].
    nlp1_solve_old_confun,
    nlp1_solve_old_objfun,
    utils._BYREF_INT, # Output, iter.
    utils._EngineIntArrayType.c_type, # Input/Output, istate[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Output, c[max(1, ncnln)].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjac[ldcj, *].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, clamda[n+nclin+ncnln].
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Output, objgrd[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[ldr, n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

nlp1_option_file = utils._EngineState._get_symbol('e04uda')
nlp1_option_file.restype = None
nlp1_option_file.argtypes = (
    utils._BYREF_INT, # Input, ioptns.
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[120].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[475].
    utils._BYREF_INT, # Output, inform.
)

nlp1_option_file_old = utils._EngineState._get_symbol('e04udf')
nlp1_option_file_old.restype = None
nlp1_option_file_old.argtypes = (
    utils._BYREF_INT, # Input, ioptns.
    utils._BYREF_INT, # Output, inform.
)

nlp1_dummy_confun = utils._EngineState._get_symbol('e04udm')
nlp1_dummy_confun.restype = None
nlp1_dummy_confun.argtypes = (
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ldcj.
    utils._EngineIntArrayType.c_type, # Input, needc[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, c[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjac[ldcj, n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)

nlp1_option_string = utils._EngineState._get_symbol('e04uea')
nlp1_option_string.restype = None
nlp1_option_string.argtypes = (
    utils._BYREF_STRING, # Input, str(len=*).
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[120].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[475].
    utils._BYREF_INT, # Output, inform.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of str.
)

nlp1_option_string_old = utils._EngineState._get_symbol('e04uef')
nlp1_option_string_old.restype = None
nlp1_option_string_old.argtypes = (
    utils._BYREF_STRING, # Input, str(len=*).
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of str.
)

nlp1_rcomm = utils._EngineState._get_symbol('e04ufa')
nlp1_rcomm.restype = None
nlp1_rcomm.argtypes = (
    utils._BYREF_INT, # Input/Output, irevcm.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nclin.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, lda.
    utils._BYREF_INT, # Input, ldcj.
    utils._BYREF_INT, # Input, ldr.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n+nclin+ncnln].
    utils._BYREF_INT, # Input/Output, iter.
    utils._EngineIntArrayType.c_type, # Input/Output, istate[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, c[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjac[ldcj, *].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, clamda[n+nclin+ncnln].
    utils._BYREF_FLOAT64, # Input/Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, objgrd[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[ldr, n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineIntArrayType.c_type, # Output, needc[max(1, ncnln)].
    utils._EngineIntArrayType.c_type, # Input/Output, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._EngineCharArrayType.c_type, # Input/Output, cwsav(len=80)[5].
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[120].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[475].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cwsav.
)

nlp1_rcomm_old = utils._EngineState._get_symbol('e04uff')
nlp1_rcomm_old.restype = None
nlp1_rcomm_old.argtypes = (
    utils._BYREF_INT, # Input/Output, irevcm.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nclin.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, lda.
    utils._BYREF_INT, # Input, ldcj.
    utils._BYREF_INT, # Input, ldr.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n+nclin+ncnln].
    utils._BYREF_INT, # Input/Output, iter.
    utils._EngineIntArrayType.c_type, # Input/Output, istate[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, c[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjac[ldcj, *].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, clamda[n+nclin+ncnln].
    utils._BYREF_FLOAT64, # Input/Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, objgrd[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[ldr, n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineIntArrayType.c_type, # Output, needc[max(1, ncnln)].
    utils._EngineIntArrayType.c_type, # Input/Output, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._BYREF_INT, # Input/Output, ifail.
)

nlp1_sparse_solve_confun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, njnln.
    utils._BYREF_INT, # Input, nnzjac.
    utils._EngineFloat64ArrayType.c_type, # Input, x[njnln].
    utils._EngineFloat64ArrayType.c_type, # Output, f[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fjac[nnzjac].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
nlp1_sparse_solve_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, nonln.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nonln].
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, objgrd[nonln].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
nlp1_sparse_solve = utils._EngineState._get_symbol('e04uga')
nlp1_sparse_solve.restype = None
nlp1_sparse_solve.argtypes = (
    nlp1_sparse_solve_confun,
    nlp1_sparse_solve_objfun,
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, nonln.
    utils._BYREF_INT, # Input, njnln.
    utils._BYREF_INT, # Input, iobj.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[nnz].
    utils._EngineIntArrayType.c_type, # Input, ha[nnz].
    utils._EngineIntArrayType.c_type, # Input, ka[n+1].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bl[n+m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bu[n+m].
    utils._BYREF_STRING, # Input, start(len=1).
    utils._BYREF_INT, # Input, nname.
    utils._EngineCharArrayType.c_type, # Input, names(len=8)[nname].
    utils._BYREF_INT, # Input/Output, ns.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, xs[n+m].
    utils._EngineIntArrayType.c_type, # Input/Output, istate[n+m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, clamda[n+m].
    utils._BYREF_INT, # Output, miniz.
    utils._BYREF_INT, # Output, minz.
    utils._BYREF_INT, # Output, ninf.
    utils._BYREF_FLOAT64, # Output, sinf.
    utils._BYREF_FLOAT64, # Output, obj.
    utils._EngineIntArrayType.c_type, # Workspace, iz[leniz].
    utils._BYREF_INT, # Input, leniz.
    utils._EngineFloat64ArrayType.c_type, # Workspace, z[lenz].
    utils._BYREF_INT, # Input, lenz.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[20].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[550].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[550].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of start.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of names.
)

nlp1_sparse_solve_old_confun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, njnln.
    utils._BYREF_INT, # Input, nnzjac.
    utils._EngineFloat64ArrayType.c_type, # Input, x[njnln].
    utils._EngineFloat64ArrayType.c_type, # Output, f[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fjac[nnzjac].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
nlp1_sparse_solve_old_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, nonln.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nonln].
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, objgrd[nonln].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
nlp1_sparse_solve_old = utils._EngineState._get_symbol('e04ugf')
nlp1_sparse_solve_old.restype = None
nlp1_sparse_solve_old.argtypes = (
    nlp1_sparse_solve_old_confun,
    nlp1_sparse_solve_old_objfun,
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, nonln.
    utils._BYREF_INT, # Input, njnln.
    utils._BYREF_INT, # Input, iobj.
    utils._BYREF_INT, # Input, nnz.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, a[nnz].
    utils._EngineIntArrayType.c_type, # Input, ha[nnz].
    utils._EngineIntArrayType.c_type, # Input, ka[n+1].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bl[n+m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, bu[n+m].
    utils._BYREF_STRING, # Input, start(len=1).
    utils._BYREF_INT, # Input, nname.
    utils._EngineCharArrayType.c_type, # Input, names(len=8)[nname].
    utils._BYREF_INT, # Input/Output, ns.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, xs[n+m].
    utils._EngineIntArrayType.c_type, # Input/Output, istate[n+m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, clamda[n+m].
    utils._BYREF_INT, # Output, miniz.
    utils._BYREF_INT, # Output, minz.
    utils._BYREF_INT, # Output, ninf.
    utils._BYREF_FLOAT64, # Output, sinf.
    utils._BYREF_FLOAT64, # Output, obj.
    utils._EngineIntArrayType.c_type, # Workspace, iz[leniz].
    utils._BYREF_INT, # Input, leniz.
    utils._EngineFloat64ArrayType.c_type, # Workspace, z[lenz].
    utils._BYREF_INT, # Input, lenz.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of start.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of names.
)

nlp1_sparse_dummy_confun = utils._EngineState._get_symbol('e04ugm')
nlp1_sparse_dummy_confun.restype = None
nlp1_sparse_dummy_confun.argtypes = (
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, njnln.
    utils._BYREF_INT, # Input, nnzjac.
    utils._EngineFloat64ArrayType.c_type, # Input, x[njnln].
    utils._EngineFloat64ArrayType.c_type, # Output, f[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fjac[nnzjac].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)

nlp1_sparse_dummy_objfun = utils._EngineState._get_symbol('e04ugn')
nlp1_sparse_dummy_objfun.restype = None
nlp1_sparse_dummy_objfun.argtypes = (
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, nonln.
    utils._EngineFloat64ArrayType.c_type, # Input, x[nonln].
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, objgrd[nonln].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)

nlp1_sparse_option_file = utils._EngineState._get_symbol('e04uha')
nlp1_sparse_option_file.restype = None
nlp1_sparse_option_file.argtypes = (
    utils._BYREF_INT, # Input, ioptns.
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[20].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[550].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[550].
    utils._BYREF_INT, # Output, inform.
)

nlp1_sparse_option_file_old = utils._EngineState._get_symbol('e04uhf')
nlp1_sparse_option_file_old.restype = None
nlp1_sparse_option_file_old.argtypes = (
    utils._BYREF_INT, # Input, ioptns.
    utils._BYREF_INT, # Output, inform.
)

nlp1_sparse_option_string = utils._EngineState._get_symbol('e04uja')
nlp1_sparse_option_string.restype = None
nlp1_sparse_option_string.argtypes = (
    utils._BYREF_STRING, # Input, str(len=*).
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[20].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[550].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[550].
    utils._BYREF_INT, # Output, inform.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of str.
)

nlp1_sparse_option_string_old = utils._EngineState._get_symbol('e04ujf')
nlp1_sparse_option_string_old.restype = None
nlp1_sparse_option_string_old.argtypes = (
    utils._BYREF_STRING, # Input, str(len=*).
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of str.
)

lsq_gencon_deriv_option_file = utils._EngineState._get_symbol('e04uqa')
lsq_gencon_deriv_option_file.restype = None
lsq_gencon_deriv_option_file.argtypes = (
    utils._BYREF_INT, # Input, ioptns.
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[120].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[475].
    utils._BYREF_INT, # Output, inform.
)

lsq_gencon_deriv_option_file_old = utils._EngineState._get_symbol('e04uqf')
lsq_gencon_deriv_option_file_old.restype = None
lsq_gencon_deriv_option_file_old.argtypes = (
    utils._BYREF_INT, # Input, ioptns.
    utils._BYREF_INT, # Output, inform.
)

lsq_gencon_deriv_option_string = utils._EngineState._get_symbol('e04ura')
lsq_gencon_deriv_option_string.restype = None
lsq_gencon_deriv_option_string.argtypes = (
    utils._BYREF_STRING, # Input, str(len=*).
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[120].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[475].
    utils._BYREF_INT, # Output, inform.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of str.
)

lsq_gencon_deriv_option_string_old = utils._EngineState._get_symbol('e04urf')
lsq_gencon_deriv_option_string_old.restype = None
lsq_gencon_deriv_option_string_old.argtypes = (
    utils._BYREF_STRING, # Input, str(len=*).
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of str.
)

lsq_gencon_deriv_confun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ldcj.
    utils._EngineIntArrayType.c_type, # Input, needc[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, c[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjac[ldcj, n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
lsq_gencon_deriv_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ldfj.
    utils._BYREF_INT, # Input, needfi.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, f[m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fjac[ldfj, n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
lsq_gencon_deriv = utils._EngineState._get_symbol('e04usa')
lsq_gencon_deriv.restype = None
lsq_gencon_deriv.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nclin.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, lda.
    utils._BYREF_INT, # Input, ldcj.
    utils._BYREF_INT, # Input, ldfj.
    utils._BYREF_INT, # Input, ldr.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, y[m].
    lsq_gencon_deriv_confun,
    lsq_gencon_deriv_objfun,
    utils._BYREF_INT, # Output, iter.
    utils._EngineIntArrayType.c_type, # Input/Output, istate[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Output, c[max(1, ncnln)].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjac[ldcj, *].
    utils._EngineFloat64ArrayType.c_type, # Output, f[m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fjac[ldfj, n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, clamda[n+nclin+ncnln].
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[ldr, n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineLogicalArrayType.c_type, # Input/Output, lwsav[120].
    utils._EngineIntArrayType.c_type, # Input/Output, iwsav[610].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rwsav[475].
    utils._BYREF_INT, # Input/Output, ifail.
)

lsq_gencon_deriv_old_confun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ldcj.
    utils._EngineIntArrayType.c_type, # Input, needc[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, c[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjac[ldcj, n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
lsq_gencon_deriv_old_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ldfj.
    utils._BYREF_INT, # Input, needfi.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, f[m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fjac[ldfj, n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
lsq_gencon_deriv_old = utils._EngineState._get_symbol('e04usf')
lsq_gencon_deriv_old.restype = None
lsq_gencon_deriv_old.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nclin.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, lda.
    utils._BYREF_INT, # Input, ldcj.
    utils._BYREF_INT, # Input, ldfj.
    utils._BYREF_INT, # Input, ldr.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, y[m].
    lsq_gencon_deriv_old_confun,
    lsq_gencon_deriv_old_objfun,
    utils._BYREF_INT, # Output, iter.
    utils._EngineIntArrayType.c_type, # Input/Output, istate[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Output, c[max(1, ncnln)].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjac[ldcj, *].
    utils._EngineFloat64ArrayType.c_type, # Output, f[m].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fjac[ldfj, n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, clamda[n+nclin+ncnln].
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, r[ldr, n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineIntArrayType.c_type, # Workspace, iwork[liwork].
    utils._BYREF_INT, # Input, liwork.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[lwork].
    utils._BYREF_INT, # Input, lwork.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

nlp2_sparse_init = utils._EngineState._get_symbol('e04vgf')
nlp2_sparse_init.restype = None
nlp2_sparse_init.argtypes = (
    utils._EngineCharArrayType.c_type, # Output, cw(len=8)[lencw].
    utils._BYREF_INT, # Input, lencw.
    utils._EngineIntArrayType.c_type, # Output, iw[leniw].
    utils._BYREF_INT, # Input, leniw.
    utils._EngineFloat64ArrayType.c_type, # Output, rw[lenrw].
    utils._BYREF_INT, # Input, lenrw.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cw.
)

nlp2_sparse_solve_usrfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, status.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_INT, # Input, needf.
    utils._BYREF_INT, # Input, nf.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, f[nf].
    utils._BYREF_INT, # Input, needg.
    utils._BYREF_INT, # Input, leng.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, g[leng].
    utils._EngineCharArrayType.c_type, # Input/Output, cuser(len=8)[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cuser.
)
nlp2_sparse_solve = utils._EngineState._get_symbol('e04vhf')
nlp2_sparse_solve.restype = None
nlp2_sparse_solve.argtypes = (
    utils._BYREF_INT, # Input, start.
    utils._BYREF_INT, # Input, nf.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nxname.
    utils._BYREF_INT, # Input, nfname.
    utils._BYREF_FLOAT64, # Input, objadd.
    utils._BYREF_INT, # Input/Output, objrow.
    utils._BYREF_STRING, # Input, prob(len=8).
    nlp2_sparse_solve_usrfun,
    utils._EngineIntArrayType.c_type, # Input, iafun[lena].
    utils._EngineIntArrayType.c_type, # Input, javar[lena].
    utils._EngineFloat64ArrayType.c_type, # Input, a[lena].
    utils._BYREF_INT, # Input, lena.
    utils._BYREF_INT, # Input, nea.
    utils._EngineIntArrayType.c_type, # Input, igfun[leng].
    utils._EngineIntArrayType.c_type, # Input, jgvar[leng].
    utils._BYREF_INT, # Input, leng.
    utils._BYREF_INT, # Input, neg.
    utils._EngineFloat64ArrayType.c_type, # Input, xlow[n].
    utils._EngineFloat64ArrayType.c_type, # Input, xupp[n].
    utils._EngineCharArrayType.c_type, # Input, xnames(len=8)[nxname].
    utils._EngineFloat64ArrayType.c_type, # Input, flow[nf].
    utils._EngineFloat64ArrayType.c_type, # Input, fupp[nf].
    utils._EngineCharArrayType.c_type, # Input, fnames(len=8)[nfname].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineIntArrayType.c_type, # Input/Output, xstate[n].
    utils._EngineFloat64ArrayType.c_type, # Output, xmul[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, f[nf].
    utils._EngineIntArrayType.c_type, # Input/Output, fstate[nf].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, fmul[nf].
    utils._BYREF_INT, # Input/Output, ns.
    utils._BYREF_INT, # Output, ninf.
    utils._BYREF_FLOAT64, # Output, sinf.
    utils._EngineCharArrayType.c_type, # Input/Output, cw(len=8)[lencw].
    utils._BYREF_INT, # Input, lencw.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[leniw].
    utils._BYREF_INT, # Input, leniw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[lenrw].
    utils._BYREF_INT, # Input, lenrw.
    utils._EngineCharArrayType.c_type, # Input/Output, cuser(len=8)[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of prob.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of xnames.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of fnames.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cw.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cuser.
)

nlp2_sparse_jacobian_usrfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, status.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_INT, # Input, needf.
    utils._BYREF_INT, # Input, nf.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, f[nf].
    utils._BYREF_INT, # Input, needg.
    utils._BYREF_INT, # Input, leng.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, g[leng].
    utils._EngineCharArrayType.c_type, # Input/Output, cuser(len=8)[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cuser.
)
nlp2_sparse_jacobian = utils._EngineState._get_symbol('e04vjf')
nlp2_sparse_jacobian.restype = None
nlp2_sparse_jacobian.argtypes = (
    utils._BYREF_INT, # Input, nf.
    utils._BYREF_INT, # Input, n.
    nlp2_sparse_jacobian_usrfun,
    utils._EngineIntArrayType.c_type, # Output, iafun[lena].
    utils._EngineIntArrayType.c_type, # Output, javar[lena].
    utils._EngineFloat64ArrayType.c_type, # Output, a[lena].
    utils._BYREF_INT, # Input, lena.
    utils._BYREF_INT, # Output, nea.
    utils._EngineIntArrayType.c_type, # Output, igfun[leng].
    utils._EngineIntArrayType.c_type, # Output, jgvar[leng].
    utils._BYREF_INT, # Input, leng.
    utils._BYREF_INT, # Output, neg.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Input, xlow[n].
    utils._EngineFloat64ArrayType.c_type, # Input, xupp[n].
    utils._EngineCharArrayType.c_type, # Input/Output, cw(len=8)[lencw].
    utils._BYREF_INT, # Input, lencw.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[leniw].
    utils._BYREF_INT, # Input, leniw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[lenrw].
    utils._BYREF_INT, # Input, lenrw.
    utils._EngineCharArrayType.c_type, # Input/Output, cuser(len=8)[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cw.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cuser.
)

nlp2_sparse_option_file = utils._EngineState._get_symbol('e04vkf')
nlp2_sparse_option_file.restype = None
nlp2_sparse_option_file.argtypes = (
    utils._BYREF_INT, # Input, ispecs.
    utils._EngineCharArrayType.c_type, # Input/Output, cw(len=8)[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cw.
)

nlp2_sparse_option_string = utils._EngineState._get_symbol('e04vlf')
nlp2_sparse_option_string.restype = None
nlp2_sparse_option_string.argtypes = (
    utils._BYREF_STRING, # Input, string(len=*).
    utils._EngineCharArrayType.c_type, # Input/Output, cw(len=8)[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of string.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cw.
)

nlp2_sparse_option_integer_set = utils._EngineState._get_symbol('e04vmf')
nlp2_sparse_option_integer_set.restype = None
nlp2_sparse_option_integer_set.argtypes = (
    utils._BYREF_STRING, # Input, string(len=*).
    utils._BYREF_INT, # Input, ivalue.
    utils._EngineCharArrayType.c_type, # Input/Output, cw(len=8)[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of string.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cw.
)

nlp2_sparse_option_double_set = utils._EngineState._get_symbol('e04vnf')
nlp2_sparse_option_double_set.restype = None
nlp2_sparse_option_double_set.argtypes = (
    utils._BYREF_STRING, # Input, string(len=*).
    utils._BYREF_FLOAT64, # Input, rvalue.
    utils._EngineCharArrayType.c_type, # Input/Output, cw(len=8)[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of string.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cw.
)

nlp2_sparse_option_integer_get = utils._EngineState._get_symbol('e04vrf')
nlp2_sparse_option_integer_get.restype = None
nlp2_sparse_option_integer_get.argtypes = (
    utils._BYREF_STRING, # Input, string(len=*).
    utils._BYREF_INT, # Output, ivalue.
    utils._EngineCharArrayType.c_type, # Input/Output, cw(len=8)[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of string.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cw.
)

nlp2_sparse_option_double_get = utils._EngineState._get_symbol('e04vsf')
nlp2_sparse_option_double_get.restype = None
nlp2_sparse_option_double_get.argtypes = (
    utils._BYREF_STRING, # Input, string(len=*).
    utils._BYREF_FLOAT64, # Output, rvalue.
    utils._EngineCharArrayType.c_type, # Input/Output, cw(len=8)[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of string.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cw.
)

nlp1_init = utils._EngineState._get_symbol('e04wbf')
nlp1_init.restype = None
nlp1_init.argtypes = (
    utils._BYREF_STRING, # Input, rname(len=*).
    utils._EngineCharArrayType.c_type, # Output, cwsav(len=80)[lcwsav].
    utils._BYREF_INT, # Input, lcwsav.
    utils._EngineLogicalArrayType.c_type, # Output, lwsav[llwsav].
    utils._BYREF_INT, # Input, llwsav.
    utils._EngineIntArrayType.c_type, # Output, iwsav[liwsav].
    utils._BYREF_INT, # Input, liwsav.
    utils._EngineFloat64ArrayType.c_type, # Output, rwsav[lrwsav].
    utils._BYREF_INT, # Input, lrwsav.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of rname.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cwsav.
)

nlp2_init = utils._EngineState._get_symbol('e04wcf')
nlp2_init.restype = None
nlp2_init.argtypes = (
    utils._EngineIntArrayType.c_type, # Output, iw[leniw].
    utils._BYREF_INT, # Input, leniw.
    utils._EngineFloat64ArrayType.c_type, # Output, rw[lenrw].
    utils._BYREF_INT, # Input, lenrw.
    utils._BYREF_INT, # Input/Output, ifail.
)

nlp2_solve_confun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ldcj.
    utils._EngineIntArrayType.c_type, # Input, needc[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, ccon[max(1, ncnln)].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjac[ldcj, n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
nlp2_solve_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, grad[n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
nlp2_solve = utils._EngineState._get_symbol('e04wdf')
nlp2_solve.restype = None
nlp2_solve.argtypes = (
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, nclin.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, lda.
    utils._BYREF_INT, # Input, ldcj.
    utils._BYREF_INT, # Input, ldh.
    utils._EngineFloat64ArrayType.c_type, # Input, a[lda, *].
    utils._EngineFloat64ArrayType.c_type, # Input, bl[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, bu[n+nclin+ncnln].
    nlp2_solve_confun,
    nlp2_solve_objfun,
    utils._BYREF_INT, # Output, majits.
    utils._EngineIntArrayType.c_type, # Input/Output, istate[n+nclin+ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ccon[max(1, ncnln)].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjac[ldcj, *].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, clamda[n+nclin+ncnln].
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Output, grad[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, h[ldh, *].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._EngineIntArrayType.c_type, # Input/Output, iw[leniw].
    utils._BYREF_INT, # Input, leniw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[lenrw].
    utils._BYREF_INT, # Input, lenrw.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

nlp2_dummy_confun = utils._EngineState._get_symbol('e04wdp')
nlp2_dummy_confun.restype = None
nlp2_dummy_confun.argtypes = (
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, ncnln.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_INT, # Input, ldcj.
    utils._EngineIntArrayType.c_type, # Input, needc[ncnln].
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, ccon[max(1, ncnln)].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, cjac[ldcj, n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)

nlp2_option_file = utils._EngineState._get_symbol('e04wef')
nlp2_option_file.restype = None
nlp2_option_file.argtypes = (
    utils._BYREF_INT, # Input, ispecs.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[*].
    utils._BYREF_INT, # Input/Output, ifail.
)

nlp2_option_string = utils._EngineState._get_symbol('e04wff')
nlp2_option_string.restype = None
nlp2_option_string.argtypes = (
    utils._BYREF_STRING, # Input, string(len=*).
    utils._EngineIntArrayType.c_type, # Input/Output, iw[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of string.
)

nlp2_option_integer_set = utils._EngineState._get_symbol('e04wgf')
nlp2_option_integer_set.restype = None
nlp2_option_integer_set.argtypes = (
    utils._BYREF_STRING, # Input, string(len=*).
    utils._BYREF_INT, # Input, ivalue.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of string.
)

nlp2_option_double_set = utils._EngineState._get_symbol('e04whf')
nlp2_option_double_set.restype = None
nlp2_option_double_set.argtypes = (
    utils._BYREF_STRING, # Input, string(len=*).
    utils._BYREF_FLOAT64, # Input, rvalue.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of string.
)

nlp2_option_integer_get = utils._EngineState._get_symbol('e04wkf')
nlp2_option_integer_get.restype = None
nlp2_option_integer_get.argtypes = (
    utils._BYREF_STRING, # Input, string(len=*).
    utils._BYREF_INT, # Output, ivalue.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of string.
)

nlp2_option_double_get = utils._EngineState._get_symbol('e04wlf')
nlp2_option_double_get.restype = None
nlp2_option_double_get.argtypes = (
    utils._BYREF_STRING, # Input, string(len=*).
    utils._BYREF_FLOAT64, # Output, rvalue.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, rw[*].
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of string.
)

estimate_deriv_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Output, objgrd[n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
estimate_deriv = utils._EngineState._get_symbol('e04xaa')
estimate_deriv.restype = None
estimate_deriv.argtypes = (
    utils._BYREF_INT, # Input, msglvl.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, epsrf.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_INT, # Input/Output, mode.
    estimate_deriv_objfun,
    utils._BYREF_INT, # Input, ldh.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, hforw[n].
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Output, objgrd[n].
    utils._EngineFloat64ArrayType.c_type, # Output, hcntrl[n].
    utils._EngineFloat64ArrayType.c_type, # Output, h[ldh, *].
    utils._BYREF_INT, # Output, iwarn.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineIntArrayType.c_type, # Output, info[n].
    utils._EngineLogicalArrayType.c_type, # Input, lwsav[1].
    utils._EngineIntArrayType.c_type, # Input, iwsav[1].
    utils._EngineFloat64ArrayType.c_type, # Input, rwsav[1].
    utils._BYREF_INT, # Input/Output, ifail.
)

estimate_deriv_old_objfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, mode.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Output, objgrd[n].
    utils._BYREF_INT, # Input, nstate.
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
)
estimate_deriv_old = utils._EngineState._get_symbol('e04xaf')
estimate_deriv_old.restype = None
estimate_deriv_old.argtypes = (
    utils._BYREF_INT, # Input, msglvl.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, epsrf.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, x[n].
    utils._BYREF_INT, # Input/Output, mode.
    estimate_deriv_old_objfun,
    utils._BYREF_INT, # Input, ldh.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, hforw[n].
    utils._BYREF_FLOAT64, # Output, objf.
    utils._EngineFloat64ArrayType.c_type, # Output, objgrd[n].
    utils._EngineFloat64ArrayType.c_type, # Output, hcntrl[n].
    utils._EngineFloat64ArrayType.c_type, # Output, h[ldh, *].
    utils._BYREF_INT, # Output, iwarn.
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[*].
    utils._EngineIntArrayType.c_type, # Input/Output, iuser[*].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, ruser[*].
    utils._EngineIntArrayType.c_type, # Output, info[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

lsq_check_deriv_lsqfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, iflag.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Output, fjac[ldfjac, n].
    utils._BYREF_INT, # Input, ldfjac.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
lsq_check_deriv = utils._EngineState._get_symbol('e04yaf')
lsq_check_deriv.restype = None
lsq_check_deriv.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    lsq_check_deriv_lsqfun,
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Output, fjac[ldfjac, n].
    utils._BYREF_INT, # Input, ldfjac.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._BYREF_INT, # Input/Output, ifail.
)

lsq_check_hessian_lsqfun = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, iflag.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Output, fjac[ldfjac, n].
    utils._BYREF_INT, # Input, ldfjac.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
lsq_check_hessian_lsqhes = utils._EngineState._sys_functype(
    None,
    utils._BYREF_INT, # Input/Output, iflag.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._EngineFloat64ArrayType.c_type, # Input, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Input, xc[n].
    utils._EngineFloat64ArrayType.c_type, # Output, b[lb].
    utils._BYREF_INT, # Input, lb.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
)
lsq_check_hessian = utils._EngineState._get_symbol('e04ybf')
lsq_check_hessian.restype = None
lsq_check_hessian.argtypes = (
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    lsq_check_hessian_lsqfun,
    lsq_check_hessian_lsqhes,
    utils._EngineFloat64ArrayType.c_type, # Input, x[n].
    utils._EngineFloat64ArrayType.c_type, # Output, fvec[m].
    utils._EngineFloat64ArrayType.c_type, # Output, fjac[ldfjac, n].
    utils._BYREF_INT, # Input, ldfjac.
    utils._EngineFloat64ArrayType.c_type, # Output, b[lb].
    utils._BYREF_INT, # Input, lb.
    utils._EngineIntArrayType.c_type, # Input/Output, iw[liw].
    utils._BYREF_INT, # Input, liw.
    utils._EngineFloat64ArrayType.c_type, # Input/Output, w[lw].
    utils._BYREF_INT, # Input, lw.
    utils._BYREF_INT, # Input/Output, ifail.
)

lsq_uncon_covariance = utils._EngineState._get_symbol('e04ycf')
lsq_uncon_covariance.restype = None
lsq_uncon_covariance.argtypes = (
    utils._BYREF_INT, # Input, job.
    utils._BYREF_INT, # Input, m.
    utils._BYREF_INT, # Input, n.
    utils._BYREF_FLOAT64, # Input, fsumsq.
    utils._EngineFloat64ArrayType.c_type, # Input, s[n].
    utils._EngineFloat64ArrayType.c_type, # Input/Output, v[ldv, n].
    utils._BYREF_INT, # Input, ldv.
    utils._EngineFloat64ArrayType.c_type, # Output, cj[n].
    utils._EngineFloat64ArrayType.c_type, # Workspace, work[n].
    utils._BYREF_INT, # Input/Output, ifail.
)

handle_opt_set = utils._EngineState._get_symbol('e04zmf')
handle_opt_set.restype = None
handle_opt_set.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_STRING, # Input, optstr(len=*).
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of optstr.
)

handle_opt_get = utils._EngineState._get_symbol('e04znf')
handle_opt_get.restype = None
handle_opt_get.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_STRING, # Input, optstr(len=*).
    utils._BYREF_INT, # Output, ivalue.
    utils._BYREF_FLOAT64, # Output, rvalue.
    utils._BYREF_STRING, # Output, cvalue(len=*).
    utils._BYREF_INT, # Output, optype.
    utils._BYREF_INT, # Input/Output, ifail.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of optstr.
    utils._EngineState._chrlen_ctype, # Input, hidden chrlen of cvalue.
)

handle_opt_set_file = utils._EngineState._get_symbol('e04zpf')
handle_opt_set_file.restype = None
handle_opt_set_file.argtypes = (
    utils._BYREF_C_PTR, # Input, handle.
    utils._BYREF_INT, # Input, infile.
    utils._BYREF_INT, # Input/Output, ifail.
)
